/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/types","vs/base/common/event","vs/base/common/errors","vs/base/common/uri","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/arrays","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/platform/product/common/productService","os","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","child_process","vs/platform/instantiation/common/descriptors","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/map","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/node/shellEnv","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/terminal/node/shellEnv","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/iterator","graceful-fs","crypto","vs/platform/environment/node/argvHelper","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Y=function(j){for(var t=[],D=0,R=j.length;D<R;D++)t[D]=J[j[D]];return t};define(J[55],Y([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function D(R,b){if(!R)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}t.ok=D}),define(J[44],Y([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function D(T){return(P,l,p)=>{let C=null,L=null;if(typeof p.value=="function"?(C="value",L=p.value):typeof p.get=="function"&&(C="get",L=p.get),!L)throw new Error("not supported");p[C]=T(L,l)}}t.createDecorator=D;function R(T,P,l){let p=null,C=null;if(typeof l.value=="function"?(p="value",C=l.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(p="get",C=l.get),!C)throw new Error("not supported");const L=`$memoize$${P}`;l[p]=function(...d){return this.hasOwnProperty(L)||Object.defineProperty(this,L,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,d)}),this[L]}}t.memoize=R;function b(T,P,l){return D((p,C)=>{const L=`$debounce$${C}`,d=`$debounce$result$${C}`;return function(...y){this[d]||(this[d]=l?l():void 0),clearTimeout(this[L]),P&&(this[d]=P(this[d],...y),y=[this[d]]),this[L]=setTimeout(()=>{p.apply(this,y),this[d]=l?l():void 0},T)}})}t.debounce=b;function I(T,P,l){return D((p,C)=>{const L=`$throttle$timer$${C}`,d=`$throttle$result$${C}`,y=`$throttle$lastRun$${C}`,w=`$throttle$pending$${C}`;return function(...g){if(this[d]||(this[d]=l?l():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),P&&(this[d]=P(this[d],...g)),this[w])return;const u=this[y]+T;u<=Date.now()?(this[y]=Date.now(),p.apply(this,[this[d]]),this[d]=l?l():void 0):(this[w]=!0,this[L]=setTimeout(()=>{this[w]=!1,this[y]=Date.now(),p.apply(this,[this[d]]),this[d]=l?l():void 0},u-Date.now()))}})}t.throttle=I}),define(J[56],Y([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var D;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(D=t.ScanError||(t.ScanError={}));var R;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(R=t.SyntaxKind||(t.SyntaxKind={}));var b;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(b=t.ParseErrorCode||(t.ParseErrorCode={}));var I;(function(i){i.DEFAULT={allowTrailingComma:!0}})(I=t.ParseOptions||(t.ParseOptions={}));function T(i,r=!1){let e=0,n=i.length,o="",a=0,c=16,h=0;function S(ie){let ue=0,he=0;for(;ue<ie;){const V=i.charCodeAt(e);if(V>=48&&V<=57)he=he*16+V-48;else if(V>=65&&V<=70)he=he*16+V-65+10;else if(V>=97&&V<=102)he=he*16+V-97+10;else break;e++,ue++}return ue<ie&&(he=-1),he}function O(ie){e=ie,o="",a=0,c=16,h=0}function M(){const ie=e;if(i.charCodeAt(e)===48)e++;else for(e++;e<i.length&&p(i.charCodeAt(e));)e++;if(e<i.length&&i.charCodeAt(e)===46)if(e++,e<i.length&&p(i.charCodeAt(e)))for(e++;e<i.length&&p(i.charCodeAt(e));)e++;else return h=3,i.substring(ie,e);let ue=e;if(e<i.length&&(i.charCodeAt(e)===69||i.charCodeAt(e)===101))if(e++,(e<i.length&&i.charCodeAt(e)===43||i.charCodeAt(e)===45)&&e++,e<i.length&&p(i.charCodeAt(e))){for(e++;e<i.length&&p(i.charCodeAt(e));)e++;ue=e}else h=3;return i.substring(ie,ue)}function _(){let ie="",ue=e;for(;;){if(e>=n){ie+=i.substring(ue,e),h=2;break}const he=i.charCodeAt(e);if(he===34){ie+=i.substring(ue,e),e++;break}if(he===92){if(ie+=i.substring(ue,e),e++,e>=n){h=2;break}switch(i.charCodeAt(e++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const Z=S(4);Z>=0?ie+=String.fromCharCode(Z):h=4;break}default:h=5}ue=e;continue}if(he>=0&&he<=31)if(l(he)){ie+=i.substring(ue,e),h=2;break}else h=6;e++}return ie}function X(){if(o="",h=0,a=e,e>=n)return a=n,c=17;let ie=i.charCodeAt(e);if(P(ie)){do e++,o+=String.fromCharCode(ie),ie=i.charCodeAt(e);while(P(ie));return c=15}if(l(ie))return e++,o+=String.fromCharCode(ie),ie===13&&i.charCodeAt(e)===10&&(e++,o+=`
`),c=14;switch(ie){case 123:return e++,c=1;case 125:return e++,c=2;case 91:return e++,c=3;case 93:return e++,c=4;case 58:return e++,c=6;case 44:return e++,c=5;case 34:return e++,o=_(),c=10;case 47:{const ue=e-1;if(i.charCodeAt(e+1)===47){for(e+=2;e<n&&!l(i.charCodeAt(e));)e++;return o=i.substring(ue,e),c=12}if(i.charCodeAt(e+1)===42){e+=2;const he=n-1;let V=!1;for(;e<he;){if(i.charCodeAt(e)===42&&i.charCodeAt(e+1)===47){e+=2,V=!0;break}e++}return V||(e++,h=1),o=i.substring(ue,e),c=13}return o+=String.fromCharCode(ie),e++,c=16}case 45:if(o+=String.fromCharCode(ie),e++,e===n||!p(i.charCodeAt(e)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=M(),c=11;default:for(;e<n&&ee(ie);)e++,ie=i.charCodeAt(e);if(a!==e){switch(o=i.substring(a,e),o){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return o+=String.fromCharCode(ie),e++,c=16}}function ee(ie){if(P(ie)||l(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function te(){let ie;do ie=X();while(ie>=12&&ie<=15);return ie}return{setPosition:O,getPosition:()=>e,scan:r?te:X,getToken:()=>c,getTokenValue:()=>o,getTokenOffset:()=>a,getTokenLength:()=>e-a,getTokenError:()=>h}}t.createScanner=T;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function l(i){return i===10||i===13||i===8232||i===8233}function p(i){return i>=48&&i<=57}var C;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(C||(C={}));function L(i,r){const e=[],n=new Object;let o;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function h(S,O,M,_){a.value=S,a.offset=O,a.length=M,a.type=_,a.colonOffset=void 0,o=a}try{v(i,{onObjectBegin:(S,O)=>{if(r<=S)throw n;o=void 0,c=r>S,e.push("")},onObjectProperty:(S,O,M)=>{if(r<O||(h(S,O,M,"property"),e[e.length-1]=S,r<=O+M))throw n},onObjectEnd:(S,O)=>{if(r<=S)throw n;o=void 0,e.pop()},onArrayBegin:(S,O)=>{if(r<=S)throw n;o=void 0,e.push(0)},onArrayEnd:(S,O)=>{if(r<=S)throw n;o=void 0,e.pop()},onLiteralValue:(S,O,M)=>{if(r<O||(h(S,O,M,s(S)),r<=O+M))throw n},onSeparator:(S,O,M)=>{if(r<=O)throw n;if(S===":"&&o&&o.type==="property")o.colonOffset=O,c=!1,o=void 0;else if(S===","){const _=e[e.length-1];typeof _=="number"?e[e.length-1]=_+1:(c=!0,e[e.length-1]=""),o=void 0}}})}catch(S){if(S!==n)throw S}return{path:e,previousNode:o,isAtPropertyKey:c,matches:S=>{let O=0;for(let M=0;O<S.length&&M<e.length;M++)if(S[O]===e[M]||S[O]==="*")O++;else if(S[O]!=="**")return!1;return O===S.length}}}t.getLocation=L;function d(i,r=[],e=I.DEFAULT){let n=null,o=[];const a=[];function c(S){Array.isArray(o)?o.push(S):n!==null&&(o[n]=S)}return v(i,{onObjectBegin:()=>{const S={};c(S),a.push(o),o=S,n=null},onObjectProperty:S=>{n=S},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const S=[];c(S),a.push(o),o=S,n=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:c,onError:(S,O,M)=>{r.push({error:S,offset:O,length:M})}},e),o[0]}t.parse=d;function y(i,r=[],e=I.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(S){n.type==="property"&&(n.length=S-n.offset,n=n.parent)}function a(S){return n.children.push(S),S}v(i,{onObjectBegin:S=>{n=a({type:"object",offset:S,length:-1,parent:n,children:[]})},onObjectProperty:(S,O,M)=>{n=a({type:"property",offset:O,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:S,offset:O,length:M,parent:n})},onObjectEnd:(S,O)=>{n.length=S+O-n.offset,n=n.parent,o(S+O)},onArrayBegin:(S,O)=>{n=a({type:"array",offset:S,length:-1,parent:n,children:[]})},onArrayEnd:(S,O)=>{n.length=S+O-n.offset,n=n.parent,o(S+O)},onLiteralValue:(S,O,M)=>{a({type:s(S),offset:O,length:M,parent:n,value:S}),o(O+M)},onSeparator:(S,O,M)=>{n.type==="property"&&(S===":"?n.colonOffset=O:S===","&&o(O))},onError:(S,O,M)=>{r.push({error:S,offset:O,length:M})}},e);const h=n.children[0];return h&&delete h.parent,h}t.parseTree=y;function w(i,r){if(!i)return;let e=i;for(let n of r)if(typeof n=="string"){if(e.type!=="object"||!Array.isArray(e.children))return;let o=!1;for(const a of e.children)if(Array.isArray(a.children)&&a.children[0].value===n){e=a.children[1],o=!0;break}if(!o)return}else{const o=n;if(e.type!=="array"||o<0||!Array.isArray(e.children)||o>=e.children.length)return;e=e.children[o]}return e}t.findNodeAtLocation=w;function g(i){if(!i.parent||!i.parent.children)return[];const r=g(i.parent);if(i.parent.type==="property"){const e=i.parent.children[0].value;r.push(e)}else if(i.parent.type==="array"){const e=i.parent.children.indexOf(i);e!==-1&&r.push(e)}return r}t.getNodePath=g;function u(i){switch(i.type){case"array":return i.children.map(u);case"object":{const r=Object.create(null);for(let e of i.children){const n=e.children[1];n&&(r[e.children[0].value]=u(n))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}t.getNodeValue=u;function f(i,r,e=!1){return r>=i.offset&&r<i.offset+i.length||e&&r===i.offset+i.length}t.contains=f;function E(i,r,e=!1){if(f(i,r,e)){const n=i.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=r;o++){const a=E(n[o],r,e);if(a)return a}return i}}t.findNodeAtOffset=E;function v(i,r,e=I.DEFAULT){const n=T(i,!1);function o(K){return K?()=>K(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(K){return K?Q=>K(Q,n.getTokenOffset(),n.getTokenLength()):()=>!0}const c=o(r.onObjectBegin),h=a(r.onObjectProperty),S=o(r.onObjectEnd),O=o(r.onArrayBegin),M=o(r.onArrayEnd),_=a(r.onLiteralValue),X=a(r.onSeparator),ee=o(r.onComment),te=a(r.onError),ie=e&&e.disallowComments,ue=e&&e.allowTrailingComma;function he(){for(;;){const K=n.scan();switch(n.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:ie||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(K){case 12:case 13:ie?V(10):ee();break;case 16:V(1);break;case 15:case 14:break;default:return K}}}function V(K,Q=[],A=[]){if(te(K),Q.length+A.length>0){let F=n.getToken();for(;F!==17;){if(Q.indexOf(F)!==-1){he();break}else if(A.indexOf(F)!==-1)break;F=he()}}}function Z(K){const Q=n.getTokenValue();return K?_(Q):h(Q),he(),!0}function U(){switch(n.getToken()){case 11:{let K=0;try{K=JSON.parse(n.getTokenValue()),typeof K!="number"&&(V(2),K=0)}catch{V(2)}_(K);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return he(),!0}function k(){return n.getToken()!==10?(V(3,[],[2,5]),!1):(Z(!1),n.getToken()===6?(X(":"),he(),ne()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function x(){c(),he();let K=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(K||V(4,[],[]),X(","),he(),n.getToken()===2&&ue)break}else K&&V(6,[],[]);k()||V(4,[],[2,5]),K=!0}return S(),n.getToken()!==2?V(7,[2],[]):he(),!0}function H(){O(),he();let K=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(K||V(4,[],[]),X(","),he(),n.getToken()===4&&ue)break}else K&&V(6,[],[]);ne()||V(4,[],[4,5]),K=!0}return M(),n.getToken()!==4?V(8,[4],[]):he(),!0}function ne(){switch(n.getToken()){case 3:return H();case 1:return x();case 10:return Z(!0);default:return U()}}return he(),n.getToken()===17?e.allowEmptyContent?!0:(V(4,[],[]),!1):ne()?(n.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}t.visit=v;function m(i,r){let e=T(i),n=[],o,a=0,c;do switch(c=e.getPosition(),o=e.scan(),o){case 12:case 13:case 17:a!==c&&n.push(i.substring(a,c)),r!==void 0&&n.push(e.getTokenValue().replace(/[^\r\n]/g,r)),a=e.getPosition();break}while(o!==17);return n.join("")}t.stripComments=m;function s(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function j(b){const I=[];typeof b=="number"&&I.push("code/timeOrigin",b);function T(l){I.push(l,Date.now())}function P(){const l=[];for(let p=0;p<I.length;p+=2)l.push({name:I[p],startTime:I[p+1]});return l}return{mark:T,getMarks:P}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const T of performance.getEntriesByType("mark"))I.push({name:T.name,startTime:Math.round(b+T.startTime)});return I}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function D(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=t()),b.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=D(R))}(),define(J[57],Y([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0;var D;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(D=t.Source||(t.Source={}));var R;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(R=t.TerminateResponseCode||(t.TerminateResponseCode={}));function b(I,...T){const P=T.reduce((C,L)=>(C[L]=!0,C),{}),l=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(C=>!P[C]).forEach(C=>{for(let L=0;L<l.length;L++)if(C.search(l[L])!==-1){delete I[C];break}})}t.sanitizeProcessEnvironment=b}),function(j,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var D=t();for(var R in D)(typeof exports=="object"?exports:j)[R]=D[R]}}(typeof self!="undefined"?self:this,function(){return function(j){var t={};function D(R){if(t[R])return t[R].exports;var b=t[R]={i:R,l:!1,exports:{}};return j[R].call(b.exports,b,b.exports,D),b.l=!0,b.exports}return D.m=j,D.c=t,D.d=function(R,b,I){D.o(R,b)||Object.defineProperty(R,b,{enumerable:!0,get:I})},D.r=function(R){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},D.t=function(R,b){if(1&b&&(R=D(R)),8&b||4&b&&typeof R=="object"&&R&&R.__esModule)return R;var I=Object.create(null);if(D.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:R}),2&b&&typeof R!="string")for(var T in R)D.d(I,T,function(P){return R[P]}.bind(null,T));return I},D.n=function(R){var b=R&&R.__esModule?function(){return R.default}:function(){return R};return D.d(b,"a",b),b},D.o=function(R,b){return Object.prototype.hasOwnProperty.call(R,b)},D.p="",D(D.s=0)}([function(j,t,D){(function(R){var b;t=j.exports=A,b=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var N=Array.prototype.slice.call(arguments,0);N.unshift("SEMVER"),console.log.apply(console,N)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var I=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,P=t.re=[],l=t.src=[],p=0,C=p++;l[C]="0|[1-9]\\d*";var L=p++;l[L]="[0-9]+";var d=p++;l[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=p++;l[y]="("+l[C]+")\\.("+l[C]+")\\.("+l[C]+")";var w=p++;l[w]="("+l[L]+")\\.("+l[L]+")\\.("+l[L]+")";var g=p++;l[g]="(?:"+l[C]+"|"+l[d]+")";var u=p++;l[u]="(?:"+l[L]+"|"+l[d]+")";var f=p++;l[f]="(?:-("+l[g]+"(?:\\."+l[g]+")*))";var E=p++;l[E]="(?:-?("+l[u]+"(?:\\."+l[u]+")*))";var v=p++;l[v]="[0-9A-Za-z-]+";var m=p++;l[m]="(?:\\+("+l[v]+"(?:\\."+l[v]+")*))";var s=p++,i="v?"+l[y]+l[f]+"?"+l[m]+"?";l[s]="^"+i+"$";var r="[v=\\s]*"+l[w]+l[E]+"?"+l[m]+"?",e=p++;l[e]="^"+r+"$";var n=p++;l[n]="((?:<|>)?=?)";var o=p++;l[o]=l[L]+"|x|X|\\*";var a=p++;l[a]=l[C]+"|x|X|\\*";var c=p++;l[c]="[v=\\s]*("+l[a]+")(?:\\.("+l[a]+")(?:\\.("+l[a]+")(?:"+l[f]+")?"+l[m]+"?)?)?";var h=p++;l[h]="[v=\\s]*("+l[o]+")(?:\\.("+l[o]+")(?:\\.("+l[o]+")(?:"+l[E]+")?"+l[m]+"?)?)?";var S=p++;l[S]="^"+l[n]+"\\s*"+l[c]+"$";var O=p++;l[O]="^"+l[n]+"\\s*"+l[h]+"$";var M=p++;l[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=p++;l[_]="(?:~>?)";var X=p++;l[X]="(\\s*)"+l[_]+"\\s+",P[X]=new RegExp(l[X],"g");var ee=p++;l[ee]="^"+l[_]+l[c]+"$";var te=p++;l[te]="^"+l[_]+l[h]+"$";var ie=p++;l[ie]="(?:\\^)";var ue=p++;l[ue]="(\\s*)"+l[ie]+"\\s+",P[ue]=new RegExp(l[ue],"g");var he=p++;l[he]="^"+l[ie]+l[c]+"$";var V=p++;l[V]="^"+l[ie]+l[h]+"$";var Z=p++;l[Z]="^"+l[n]+"\\s*("+r+")$|^$";var U=p++;l[U]="^"+l[n]+"\\s*("+i+")$|^$";var k=p++;l[k]="(\\s*)"+l[n]+"\\s*("+r+"|"+l[c]+")",P[k]=new RegExp(l[k],"g");var x=p++;l[x]="^\\s*("+l[c]+")\\s+-\\s+("+l[c]+")\\s*$";var H=p++;l[H]="^\\s*("+l[h]+")\\s+-\\s+("+l[h]+")\\s*$";var ne=p++;l[ne]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)b(K,l[K]),P[K]||(P[K]=new RegExp(l[K]));function Q(N,B){if(N instanceof A)return N;if(typeof N!="string"||N.length>I||!(B?P[e]:P[s]).test(N))return null;try{return new A(N,B)}catch{return null}}function A(N,B){if(N instanceof A){if(N.loose===B)return N;N=N.version}else if(typeof N!="string")throw new TypeError("Invalid Version: "+N);if(N.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof A))return new A(N,B);b("SemVer",N,B),this.loose=B;var $=N.trim().match(B?P[e]:P[s]);if(!$)throw new TypeError("Invalid Version: "+N);if(this.raw=N,this.major=+$[1],this.minor=+$[2],this.patch=+$[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");$[4]?this.prerelease=$[4].split(".").map(function(le){if(/^[0-9]+$/.test(le)){var de=+le;if(de>=0&&de<T)return de}return le}):this.prerelease=[],this.build=$[5]?$[5].split("."):[],this.format()}t.parse=Q,t.valid=function(N,B){var $=Q(N,B);return $?$.version:null},t.clean=function(N,B){var $=Q(N.trim().replace(/^[=v]+/,""),B);return $?$.version:null},t.SemVer=A,A.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},A.prototype.toString=function(){return this.version},A.prototype.compare=function(N){return b("SemVer.compare",this.version,this.loose,N),N instanceof A||(N=new A(N,this.loose)),this.compareMain(N)||this.comparePre(N)},A.prototype.compareMain=function(N){return N instanceof A||(N=new A(N,this.loose)),z(this.major,N.major)||z(this.minor,N.minor)||z(this.patch,N.patch)},A.prototype.comparePre=function(N){if(N instanceof A||(N=new A(N,this.loose)),this.prerelease.length&&!N.prerelease.length)return-1;if(!this.prerelease.length&&N.prerelease.length)return 1;if(!this.prerelease.length&&!N.prerelease.length)return 0;var B=0;do{var $=this.prerelease[B],le=N.prerelease[B];if(b("prerelease compare",B,$,le),$===void 0&&le===void 0)return 0;if(le===void 0)return 1;if($===void 0)return-1;if($!==le)return z($,le)}while(++B)},A.prototype.inc=function(N,B){switch(N){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",B);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",B);break;case"prepatch":this.prerelease.length=0,this.inc("patch",B),this.inc("pre",B);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",B),this.inc("pre",B);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $=this.prerelease.length;--$>=0;)typeof this.prerelease[$]=="number"&&(this.prerelease[$]++,$=-2);$===-1&&this.prerelease.push(0)}B&&(this.prerelease[0]===B?isNaN(this.prerelease[1])&&(this.prerelease=[B,0]):this.prerelease=[B,0]);break;default:throw new Error("invalid increment argument: "+N)}return this.format(),this.raw=this.version,this},t.inc=function(N,B,$,le){typeof $=="string"&&(le=$,$=void 0);try{return new A(N,$).inc(B,le).version}catch{return null}},t.diff=function(N,B){if(re(N,B))return null;var $=Q(N),le=Q(B);if($.prerelease.length||le.prerelease.length){for(var de in $)if((de==="major"||de==="minor"||de==="patch")&&$[de]!==le[de])return"pre"+de;return"prerelease"}for(var de in $)if((de==="major"||de==="minor"||de==="patch")&&$[de]!==le[de])return de},t.compareIdentifiers=z;var F=/^[0-9]+$/;function z(N,B){var $=F.test(N),le=F.test(B);return $&&le&&(N=+N,B=+B),$&&!le?-1:le&&!$?1:N<B?-1:N>B?1:0}function W(N,B,$){return new A(N,$).compare(new A(B,$))}function G(N,B,$){return W(N,B,$)>0}function q(N,B,$){return W(N,B,$)<0}function re(N,B,$){return W(N,B,$)===0}function ae(N,B,$){return W(N,B,$)!==0}function pe(N,B,$){return W(N,B,$)>=0}function fe(N,B,$){return W(N,B,$)<=0}function se(N,B,$,le){var de;switch(B){case"===":typeof N=="object"&&(N=N.version),typeof $=="object"&&($=$.version),de=N===$;break;case"!==":typeof N=="object"&&(N=N.version),typeof $=="object"&&($=$.version),de=N!==$;break;case"":case"=":case"==":de=re(N,$,le);break;case"!=":de=ae(N,$,le);break;case">":de=G(N,$,le);break;case">=":de=pe(N,$,le);break;case"<":de=q(N,$,le);break;case"<=":de=fe(N,$,le);break;default:throw new TypeError("Invalid operator: "+B)}return de}function ce(N,B){if(N instanceof ce){if(N.loose===B)return N;N=N.value}if(!(this instanceof ce))return new ce(N,B);b("comparator",N,B),this.loose=B,this.parse(N),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}t.rcompareIdentifiers=function(N,B){return z(B,N)},t.major=function(N,B){return new A(N,B).major},t.minor=function(N,B){return new A(N,B).minor},t.patch=function(N,B){return new A(N,B).patch},t.compare=W,t.compareLoose=function(N,B){return W(N,B,!0)},t.rcompare=function(N,B,$){return W(B,N,$)},t.sort=function(N,B){return N.sort(function($,le){return t.compare($,le,B)})},t.rsort=function(N,B){return N.sort(function($,le){return t.rcompare($,le,B)})},t.gt=G,t.lt=q,t.eq=re,t.neq=ae,t.gte=pe,t.lte=fe,t.cmp=se,t.Comparator=ce;var ye={};function me(N,B){if(N instanceof me)return N.loose===B?N:new me(N.raw,B);if(N instanceof ce)return new me(N.value,B);if(!(this instanceof me))return new me(N,B);if(this.loose=B,this.raw=N,this.set=N.split(/\s*\|\|\s*/).map(function($){return this.parseRange($.trim())},this).filter(function($){return $.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+N);this.format()}function we(N){return!N||N.toLowerCase()==="x"||N==="*"}function Ne(N,B,$,le,de,De,Se,Oe,Ie,Te,Fe,Re,Ce){return((B=we($)?"":we(le)?">="+$+".0.0":we(de)?">="+$+"."+le+".0":">="+B)+" "+(Oe=we(Ie)?"":we(Te)?"<"+(+Ie+1)+".0.0":we(Fe)?"<"+Ie+"."+(+Te+1)+".0":Re?"<="+Ie+"."+Te+"."+Fe+"-"+Re:"<="+Oe)).trim()}function je(N,B){for(var $=0;$<N.length;$++)if(!N[$].test(B))return!1;if(B.prerelease.length){for($=0;$<N.length;$++)if(b(N[$].semver),N[$].semver!==ye&&N[$].semver.prerelease.length>0){var le=N[$].semver;if(le.major===B.major&&le.minor===B.minor&&le.patch===B.patch)return!0}return!1}return!0}function ze(N,B,$){try{B=new me(B,$)}catch{return!1}return B.test(N)}function xe(N,B,$,le){var de,De,Se,Oe,Ie;switch(N=new A(N,le),B=new me(B,le),$){case">":de=G,De=fe,Se=q,Oe=">",Ie=">=";break;case"<":de=q,De=pe,Se=G,Oe="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(N,B,le))return!1;for(var Te=0;Te<B.set.length;++Te){var Fe=B.set[Te],Re=null,Ce=null;if(Fe.forEach(function(ke){ke.semver===ye&&(ke=new ce(">=0.0.0")),Re=Re||ke,Ce=Ce||ke,de(ke.semver,Re.semver,le)?Re=ke:Se(ke.semver,Ce.semver,le)&&(Ce=ke)}),Re.operator===Oe||Re.operator===Ie||(!Ce.operator||Ce.operator===Oe)&&De(N,Ce.semver)||Ce.operator===Ie&&Se(N,Ce.semver))return!1}return!0}ce.prototype.parse=function(N){var B=this.loose?P[Z]:P[U],$=N.match(B);if(!$)throw new TypeError("Invalid comparator: "+N);this.operator=$[1],this.operator==="="&&(this.operator=""),$[2]?this.semver=new A($[2],this.loose):this.semver=ye},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(N){return b("Comparator.test",N,this.loose),this.semver===ye||(typeof N=="string"&&(N=new A(N,this.loose)),se(N,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(N,B){if(!(N instanceof ce))throw new TypeError("a Comparator is required");var $;if(this.operator==="")return $=new me(N.value,B),ze(this.value,$,B);if(N.operator==="")return $=new me(this.value,B),ze(N.semver,$,B);var le=!(this.operator!==">="&&this.operator!==">"||N.operator!==">="&&N.operator!==">"),de=!(this.operator!=="<="&&this.operator!=="<"||N.operator!=="<="&&N.operator!=="<"),De=this.semver.version===N.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||N.operator!==">="&&N.operator!=="<="),Oe=se(this.semver,"<",N.semver,B)&&(this.operator===">="||this.operator===">")&&(N.operator==="<="||N.operator==="<"),Ie=se(this.semver,">",N.semver,B)&&(this.operator==="<="||this.operator==="<")&&(N.operator===">="||N.operator===">");return le||de||De&&Se||Oe||Ie},t.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(N){return N.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(N){var B=this.loose;N=N.trim(),b("range",N,B);var $=B?P[H]:P[x];N=N.replace($,Ne),b("hyphen replace",N),N=N.replace(P[k],"$1$2$3"),b("comparator trim",N,P[k]),N=(N=(N=N.replace(P[X],"$1~")).replace(P[ue],"$1^")).split(/\s+/).join(" ");var le=B?P[Z]:P[U],de=N.split(" ").map(function(De){return function(Se,Oe){return b("comp",Se),Se=function(Ie,Te){return Ie.trim().split(/\s+/).map(function(Fe){return function(Re,Ce){b("caret",Re,Ce);var ke=Ce?P[V]:P[he];return Re.replace(ke,function(Ae,ve,Ee,be,Pe){var Le;return b("caret",Re,Ae,ve,Ee,be,Pe),we(ve)?Le="":we(Ee)?Le=">="+ve+".0.0 <"+(+ve+1)+".0.0":we(be)?Le=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Pe?(b("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Le=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+be+Pe+" <"+ve+"."+Ee+"."+(+be+1):">="+ve+"."+Ee+"."+be+Pe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+be+Pe+" <"+(+ve+1)+".0.0"):(b("no pr"),Le=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+be+" <"+ve+"."+Ee+"."+(+be+1):">="+ve+"."+Ee+"."+be+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+be+" <"+(+ve+1)+".0.0"),b("caret return",Le),Le})}(Fe,Te)}).join(" ")}(Se,Oe),b("caret",Se),Se=function(Ie,Te){return Ie.trim().split(/\s+/).map(function(Fe){return function(Re,Ce){var ke=Ce?P[te]:P[ee];return Re.replace(ke,function(Ae,ve,Ee,be,Pe){var Le;return b("tilde",Re,Ae,ve,Ee,be,Pe),we(ve)?Le="":we(Ee)?Le=">="+ve+".0.0 <"+(+ve+1)+".0.0":we(be)?Le=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Pe?(b("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Le=">="+ve+"."+Ee+"."+be+Pe+" <"+ve+"."+(+Ee+1)+".0"):Le=">="+ve+"."+Ee+"."+be+" <"+ve+"."+(+Ee+1)+".0",b("tilde return",Le),Le})}(Fe,Te)}).join(" ")}(Se,Oe),b("tildes",Se),Se=function(Ie,Te){return b("replaceXRanges",Ie,Te),Ie.split(/\s+/).map(function(Fe){return function(Re,Ce){Re=Re.trim();var ke=Ce?P[O]:P[S];return Re.replace(ke,function(Ae,ve,Ee,be,Pe,Le){b("xRange",Re,Ae,ve,Ee,be,Pe,Le);var Ve=we(Ee),Me=Ve||we(be),Ue=Me||we(Pe);return ve==="="&&Ue&&(ve=""),Ve?Ae=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Ue?(Me&&(be=0),Ue&&(Pe=0),ve===">"?(ve=">=",Me?(Ee=+Ee+1,be=0,Pe=0):Ue&&(be=+be+1,Pe=0)):ve==="<="&&(ve="<",Me?Ee=+Ee+1:be=+be+1),Ae=ve+Ee+"."+be+"."+Pe):Me?Ae=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Ue&&(Ae=">="+Ee+"."+be+".0 <"+Ee+"."+(+be+1)+".0"),b("xRange return",Ae),Ae})}(Fe,Te)}).join(" ")}(Se,Oe),b("xrange",Se),Se=function(Ie,Te){return b("replaceStars",Ie,Te),Ie.trim().replace(P[ne],"")}(Se,Oe),b("stars",Se),Se}(De,B)}).join(" ").split(/\s+/);return this.loose&&(de=de.filter(function(De){return!!De.match(le)})),de=de.map(function(De){return new ce(De,B)})},me.prototype.intersects=function(N,B){if(!(N instanceof me))throw new TypeError("a Range is required");return this.set.some(function($){return $.every(function(le){return N.set.some(function(de){return de.every(function(De){return le.intersects(De,B)})})})})},t.toComparators=function(N,B){return new me(N,B).set.map(function($){return $.map(function(le){return le.value}).join(" ").trim().split(" ")})},me.prototype.test=function(N){if(!N)return!1;typeof N=="string"&&(N=new A(N,this.loose));for(var B=0;B<this.set.length;B++)if(je(this.set[B],N))return!0;return!1},t.satisfies=ze,t.maxSatisfying=function(N,B,$){var le=null,de=null;try{var De=new me(B,$)}catch{return null}return N.forEach(function(Se){De.test(Se)&&(le&&de.compare(Se)!==-1||(de=new A(le=Se,$)))}),le},t.minSatisfying=function(N,B,$){var le=null,de=null;try{var De=new me(B,$)}catch{return null}return N.forEach(function(Se){De.test(Se)&&(le&&de.compare(Se)!==1||(de=new A(le=Se,$)))}),le},t.validRange=function(N,B){try{return new me(N,B).range||"*"}catch{return null}},t.ltr=function(N,B,$){return xe(N,B,"<",$)},t.gtr=function(N,B,$){return xe(N,B,">",$)},t.outside=xe,t.prerelease=function(N,B){var $=Q(N,B);return $&&$.prerelease.length?$.prerelease:null},t.intersects=function(N,B,$){return N=new me(N,$),B=new me(B,$),N.intersects(B)},t.coerce=function(N){if(N instanceof A)return N;if(typeof N!="string")return null;var B=N.match(P[M]);return B==null?null:Q((B[1]||"0")+"."+(B[2]||"0")+"."+(B[3]||"0"))}}).call(this,D(1))},function(j,t){var D,R,b=j.exports={};function I(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function P(u){if(D===setTimeout)return setTimeout(u,0);if((D===I||!D)&&setTimeout)return D=setTimeout,setTimeout(u,0);try{return D(u,0)}catch{try{return D.call(null,u,0)}catch{return D.call(this,u,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:I}catch{D=I}try{R=typeof clearTimeout=="function"?clearTimeout:T}catch{R=T}})();var l,p=[],C=!1,L=-1;function d(){C&&l&&(C=!1,l.length?p=l.concat(p):L=-1,p.length&&y())}function y(){if(!C){var u=P(d);C=!0;for(var f=p.length;f;){for(l=p,p=[];++L<f;)l&&l[L].run();L=-1,f=p.length}l=null,C=!1,function(E){if(R===clearTimeout)return clearTimeout(E);if((R===T||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(E);try{R(E)}catch{try{return R.call(null,E)}catch{return R.call(this,E)}}}(u)}}function w(u,f){this.fun=u,this.array=f}function g(){}b.nextTick=function(u){var f=new Array(arguments.length-1);if(arguments.length>1)for(var E=1;E<arguments.length;E++)f[E-1]=arguments[E];p.push(new w(u,f)),p.length!==1||C||P(y)},w.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=g,b.addListener=g,b.once=g,b.off=g,b.removeListener=g,b.removeAllListeners=g,b.emit=g,b.prependListener=g,b.prependOnceListener=g,b.listeners=function(u){return[]},b.binding=function(u){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(u){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(J[58],Y([0,1]),function(j,t){"use strict";var D;Object.defineProperty(t,"__esModule",{value:!0}),t.SkipList=void 0;class R{constructor(P,l,p){this.level=P,this.key=l,this.value=p,this.forward=[]}}const b=void 0;class I{constructor(P,l=2**16){this.comparator=P,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new R(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new R(this._maxLevel,b,b)}has(P){return Boolean(I._search(this,P,this.comparator))}get(P){return I._search(this,P,this.comparator)?.value}set(P,l){return I._insert(this,P,l,this.comparator)&&(this._size+=1),this}delete(P){const l=I._delete(this,P,this.comparator);return l&&(this._size-=1),l}forEach(P,l){let p=this._header.forward[0];for(;p;)P.call(l,p.value,p.key,this),p=p.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",l=this._header.forward[0];for(;l;)P+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return P}static _search(P,l,p){let C=P._header;for(let L=P._level-1;L>=0;L--)for(;C.forward[L]&&p(C.forward[L].key,l)<0;)C=C.forward[L];if(C=C.forward[0],C&&p(C.key,l)===0)return C}static _insert(P,l,p,C){let L=[],d=P._header;for(let y=P._level-1;y>=0;y--){for(;d.forward[y]&&C(d.forward[y].key,l)<0;)d=d.forward[y];L[y]=d}if(d=d.forward[0],d&&C(d.key,l)===0)return d.value=p,!1;{let y=I._randomLevel(P);if(y>P._level){for(let w=P._level;w<y;w++)L[w]=P._header;P._level=y}d=new R(y,l,p);for(let w=0;w<y;w++)d.forward[w]=L[w].forward[w],L[w].forward[w]=d;return!0}}static _randomLevel(P,l=.5){let p=1;for(;Math.random()<l&&p<P._maxLevel;)p+=1;return p}static _delete(P,l,p){let C=[],L=P._header;for(let d=P._level-1;d>=0;d--){for(;L.forward[d]&&p(L.forward[d].key,l)<0;)L=L.forward[d];C[d]=L}if(L=L.forward[0],!L||p(L.key,l)!==0)return!1;for(let d=0;d<P._level&&C[d].forward[d]===L;d++)C[d].forward[d]=L.forward[d];for(;P._level>0&&P._header.forward[P._level-1]===b;)P._level-=1;return!0}}t.SkipList=I}),define(J[38],Y([0,1,8,2]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function b(v){const m=v;return m?[m.on,m.pause,m.resume,m.destroy].every(s=>typeof s=="function"):!1}t.isReadableStream=b;function I(v){const m=v;return m?b(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}t.isReadableBufferedStream=I;function T(v,m){return new P(v,m)}t.newWriteableStream=T;class P{constructor(m,s){this.reducer=m,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(s=>s(m))}emitError(m){this.listeners.error.length===0?(0,D.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(s=>s(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,s){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(m,s){if(this.state.destroyed)return;let i;switch(m){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const r=i.indexOf(s);r>=0&&i.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(v,m){const s=[];let i;for(;(i=v.read())!==null;)s.push(i);return m(s)}t.consumeReadable=l;function p(v,m,s){const i=[];let r;for(;(r=v.read())!==null&&i.length<s;)i.push(r);return r===null&&i.length>0?m(i):{read:()=>{if(i.length>0)return i.shift();if(typeof r!="undefined"){const e=r;return r=void 0,e}return v.read()}}}t.peekReadable=p;function C(v,m){return new Promise((s,i)=>{const r=[];L(v,{onData:e=>{m&&r.push(e)},onError:e=>{m?i(e):s(void 0)},onEnd:()=>{s(m?m(r):void 0)}})})}t.consumeStream=C;function L(v,m){let s=!1;return v.on("error",i=>{s||m.onError(i)}),v.on("end",()=>{s||m.onEnd()}),v.on("data",i=>{s||m.onData(i)}),(0,R.toDisposable)(()=>s=!0)}t.listenStream=L;function d(v,m){return new Promise((s,i)=>{const r=new R.DisposableStore,e=[],n=c=>{if(e.push(c),e.length>m)return r.dispose(),v.pause(),s({stream:v,buffer:e,ended:!1})},o=c=>i(c),a=()=>s({stream:v,buffer:e,ended:!0});r.add((0,R.toDisposable)(()=>v.removeListener("error",o))),v.on("error",o),r.add((0,R.toDisposable)(()=>v.removeListener("end",a))),v.on("end",a),r.add((0,R.toDisposable)(()=>v.removeListener("data",n))),v.on("data",n)})}t.peekStream=d;function y(v,m){const s=T(m);return s.end(v),s}t.toStream=y;function w(){const v=T(()=>{throw new Error("not supported")});return v.end(),v}t.emptyStream=w;function g(v){let m=!1;return{read:()=>m?null:(m=!0,v)}}t.toReadable=g;function u(v,m,s){const i=T(s);return L(v,{onData:r=>i.write(m.data(r)),onError:r=>i.error(m.error?m.error(r):r),onEnd:()=>i.end()}),i}t.transform=u;function f(v,m,s){let i=!1;return{read:()=>{const r=m.read();return i?r:(i=!0,r!==null?s([v,r]):v)}}}t.prefixedReadable=f;function E(v,m,s){let i=!1;const r=T(s);return L(m,{onData:e=>i?r.write(e):(i=!0,r.write(s([v,e]))),onError:e=>r.error(e),onEnd:()=>{i||(i=!0,r.write(v)),r.end()}}),r}t.prefixedStream=E}),define(J[17],Y([0,1,38]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const R=typeof Buffer!="undefined";let b,I;class T{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return R?new T(Buffer.allocUnsafe(h)):new T(new Uint8Array(h))}static wrap(h){return R&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new T(h)}static fromString(h,S){return!(S?.dontUseNodeBuffer||!1)&&R?new T(Buffer.from(h)):(b||(b=new TextEncoder),new T(b.encode(h)))}static fromByteArray(h){const S=T.alloc(h.length);for(let O=0,M=h.length;O<M;O++)S.buffer[O]=h[O];return S}static concat(h,S){if(typeof S=="undefined"){S=0;for(let _=0,X=h.length;_<X;_++)S+=h[_].byteLength}const O=T.alloc(S);let M=0;for(let _=0,X=h.length;_<X;_++){const ee=h[_];O.set(ee,M),M+=ee.byteLength}return O}clone(){const h=T.alloc(this.byteLength);return h.set(this),h}toString(){return R?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(h,S){return new T(this.buffer.subarray(h,S))}set(h,S){if(h instanceof T)this.buffer.set(h.buffer,S);else if(h instanceof Uint8Array)this.buffer.set(h,S);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),S);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return p(this.buffer,h)}writeUInt32BE(h,S){C(this.buffer,h,S)}readUInt32LE(h){return L(this.buffer,h)}writeUInt32LE(h,S){d(this.buffer,h,S)}readUInt8(h){return y(this.buffer,h)}writeUInt8(h,S){w(this.buffer,h,S)}}t.VSBuffer=T;function P(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0}t.readUInt16LE=P;function l(c,h,S){c[S+0]=h&255,h=h>>>8,c[S+1]=h&255}t.writeUInt16LE=l;function p(c,h){return c[h]*2**24+c[h+1]*2**16+c[h+2]*2**8+c[h+3]}t.readUInt32BE=p;function C(c,h,S){c[S+3]=h,h=h>>>8,c[S+2]=h,h=h>>>8,c[S+1]=h,h=h>>>8,c[S]=h}t.writeUInt32BE=C;function L(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0|c[h+2]<<16>>>0|c[h+3]<<24>>>0}t.readUInt32LE=L;function d(c,h,S){c[S+0]=h&255,h=h>>>8,c[S+1]=h&255,h=h>>>8,c[S+2]=h&255,h=h>>>8,c[S+3]=h&255}t.writeUInt32LE=d;function y(c,h){return c[h]}t.readUInt8=y;function w(c,h,S){c[S]=h}t.writeUInt8=w;function g(c){return D.consumeReadable(c,h=>T.concat(h))}t.readableToBuffer=g;function u(c){return D.toReadable(c)}t.bufferToReadable=u;function f(c){return D.consumeStream(c,h=>T.concat(h))}t.streamToBuffer=f;async function E(c){return c.ended?T.concat(c.buffer):T.concat([...c.buffer,await f(c.stream)])}t.bufferedStreamToBuffer=E;function v(c){return D.toStream(c,h=>T.concat(h))}t.bufferToStream=v;function m(c){return D.transform(c,{data:h=>typeof h=="string"?T.fromString(h):T.wrap(h)},h=>T.concat(h))}t.streamToBufferReadableStream=m;function s(c){return D.newWriteableStream(h=>T.concat(h),c)}t.newWriteableBufferStream=s;function i(c,h){return D.prefixedReadable(c,h,S=>T.concat(S))}t.prefixedBufferReadable=i;function r(c,h){return D.prefixedStream(c,h,S=>T.concat(S))}t.prefixedBufferStream=r;function e(c){let h=0,S=0,O=0;const M=new Uint8Array(Math.floor(c.length/4*3)),_=ee=>{switch(S){case 3:M[O++]=h|ee,S=0;break;case 2:M[O++]=h|ee>>>2,h=ee<<6,S=3;break;case 1:M[O++]=h|ee>>>4,h=ee<<4,S=2;break;default:h=ee<<2,S=1}};for(let ee=0;ee<c.length;ee++){const te=c.charCodeAt(ee);if(te>=65&&te<=90)_(te-65);else if(te>=97&&te<=122)_(te-97+26);else if(te>=48&&te<=57)_(te-48+52);else if(te===43||te===45)_(62);else if(te===47||te===95)_(63);else{if(te===61)break;throw new SyntaxError(`Unexpected base64 character ${c[ee]}`)}}const X=O;for(;S>0;)_(0);return T.wrap(M).slice(0,X)}t.decodeBase64=e;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:c},h=!0,S=!1){const O=S?o:n;let M="";const _=c.byteLength%3;let X=0;for(;X<c.byteLength-_;X+=3){const ee=c[X+0],te=c[X+1],ie=c[X+2];M+=O[ee>>>2],M+=O[(ee<<4|te>>>4)&63],M+=O[(te<<2|ie>>>6)&63],M+=O[ie&63]}if(_===1){const ee=c[X+0];M+=O[ee>>>2],M+=O[ee<<4&63],h&&(M+="==")}else if(_===2){const ee=c[X+0],te=c[X+1];M+=O[ee>>>2],M+=O[(ee<<4|te>>>4)&63],M+=O[te<<2&63],h&&(M+="=")}return M}t.encodeBase64=a}),define(J[59],Y([0,1,26]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function R(f){return b(f,0)}t.hash=R;function b(f,E){switch(typeof f){case"object":return f===null?I(349,E):Array.isArray(f)?l(f,E):p(f,E);case"string":return P(f,E);case"boolean":return T(f,E);case"number":return I(f,E);case"undefined":return I(937,E);default:return I(617,E)}}t.doHash=b;function I(f,E){return(E<<5)-E+f|0}t.numberHash=I;function T(f,E){return I(f?433:863,E)}function P(f,E){E=I(149417,E);for(let v=0,m=f.length;v<m;v++)E=I(f.charCodeAt(v),E);return E}t.stringHash=P;function l(f,E){return E=I(104579,E),f.reduce((v,m)=>b(m,v),E)}function p(f,E){return E=I(181387,E),Object.keys(f).sort().reduce((v,m)=>(v=P(m,v),b(f[m],v)),E)}class C{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=b(E,this._value),this._value}}t.Hasher=C;var L;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(L||(L={}));function d(f,E,v=32){const m=v-E,s=~((1<<m)-1);return(f<<E|(s&f)>>>m)>>>0}function y(f,E=0,v=f.byteLength,m=0){for(let s=0;s<v;s++)f[E+s]=m}function w(f,E,v="0"){for(;f.length<E;)f=v+f;return f}function g(f,E=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(v=>v.toString(16).padStart(2,"0")).join(""):w((f>>>0).toString(16),E/4)}t.toHexString=g;class u{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const v=E.length;if(v===0)return;const m=this._buff;let s=this._buffLen,i=this._leftoverHighSurrogate,r,e;for(i!==0?(r=i,e=-1,i=0):(r=E.charCodeAt(0),e=0);;){let n=r;if(D.isHighSurrogate(r))if(e+1<v){const o=E.charCodeAt(e+1);D.isLowSurrogate(o)?(e++,n=D.computeCodePoint(r,o)):n=65533}else{i=r;break}else D.isLowSurrogate(r)&&(n=65533);if(s=this._push(m,s,n),e++,e<v)r=E.charCodeAt(e);else break}this._buffLen=s,this._leftoverHighSurrogate=i}_push(E,v,m){return m<128?E[v++]=m:m<2048?(E[v++]=192|(m&1984)>>>6,E[v++]=128|(m&63)>>>0):m<65536?(E[v++]=224|(m&61440)>>>12,E[v++]=128|(m&4032)>>>6,E[v++]=128|(m&63)>>>0):(E[v++]=240|(m&1835008)>>>18,E[v++]=128|(m&258048)>>>12,E[v++]=128|(m&4032)>>>6,E[v++]=128|(m&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=u._bigBlock32,v=this._buffDV;for(let c=0;c<64;c+=4)E.setUint32(c,v.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)E.setUint32(c,d(E.getUint32(c-12,!1)^E.getUint32(c-32,!1)^E.getUint32(c-56,!1)^E.getUint32(c-64,!1),1),!1);let m=this._h0,s=this._h1,i=this._h2,r=this._h3,e=this._h4,n,o,a;for(let c=0;c<80;c++)c<20?(n=s&i|~s&r,o=1518500249):c<40?(n=s^i^r,o=1859775393):c<60?(n=s&i|s&r|i&r,o=2400959708):(n=s^i^r,o=3395469782),a=d(m,5)+n+e+o+E.getUint32(c*4,!1)&4294967295,e=r,r=i,i=d(s,30),s=m,m=a;this._h0=this._h0+m&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+e&4294967295}}t.StringSHA1=u,u._bigBlock32=new DataView(new ArrayBuffer(320))}),define(J[22],Y([0,1,6]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function R(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const u=Array.isArray(g)?[]:{};return Object.keys(g).forEach(f=>{g[f]&&typeof g[f]=="object"?u[f]=R(g[f]):u[f]=g[f]}),u}t.deepClone=R;function b(g){if(!g||typeof g!="object")return g;const u=[g];for(;u.length>0;){const f=u.shift();Object.freeze(f);for(const E in f)if(I.call(f,E)){const v=f[E];typeof v=="object"&&!Object.isFrozen(v)&&u.push(v)}}return g}t.deepFreeze=b;const I=Object.prototype.hasOwnProperty;function T(g,u){return P(g,u,new Set)}t.cloneAndChange=T;function P(g,u,f){if((0,D.isUndefinedOrNull)(g))return g;const E=u(g);if(typeof E!="undefined")return E;if((0,D.isArray)(g)){const v=[];for(const m of g)v.push(P(m,u,f));return v}if((0,D.isObject)(g)){if(f.has(g))throw new Error("Cannot clone recursive data-structure");f.add(g);const v={};for(let m in g)I.call(g,m)&&(v[m]=P(g[m],u,f));return f.delete(g),v}return g}function l(g,u,f=!0){return(0,D.isObject)(g)?((0,D.isObject)(u)&&Object.keys(u).forEach(E=>{E in g?f&&((0,D.isObject)(g[E])&&(0,D.isObject)(u[E])?l(g[E],u[E],f):g[E]=u[E]):g[E]=u[E]}),g):u}t.mixin=l;function p(g,u){if(g===u)return!0;if(g==null||u===null||u===void 0||typeof g!=typeof u||typeof g!="object"||Array.isArray(g)!==Array.isArray(u))return!1;let f,E;if(Array.isArray(g)){if(g.length!==u.length)return!1;for(f=0;f<g.length;f++)if(!p(g[f],u[f]))return!1}else{const v=[];for(E in g)v.push(E);v.sort();const m=[];for(E in u)m.push(E);if(m.sort(),!p(v,m))return!1;for(f=0;f<v.length;f++)if(!p(g[v[f]],u[v[f]]))return!1}return!0}t.equals=p;function C(g){const u=new Set;return JSON.stringify(g,(f,E)=>{if((0,D.isObject)(E)||Array.isArray(E)){if(u.has(E))return"[Circular]";u.add(E)}return E})}t.safeStringify=C;function L(g,u,f){const E=u(g);return typeof E=="undefined"?f:E}t.getOrDefault=L;function d(g,u){const f=Object.create(null);return!g||!u||Object.keys(u).forEach(v=>{const m=g[v],s=u[v];p(m,s)||(f[v]=s)}),f}t.distinct=d;function y(g,u){const f=u.toLowerCase(),E=Object.keys(g).find(v=>v.toLowerCase()===f);return E?g[E]:g[u]}t.getCaseInsensitive=y;function w(g,u){const f=Object.create(null);for(const[E,v]of Object.entries(g))u(E,v)&&(f[E]=v);return f}t.filter=w}),define(J[60],Y([0,1,9]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function R(p){const C=p;return C&&typeof C.type=="string"&&typeof C.severity=="string"}t.isRemoteConsoleLog=R;function b(p){const C=[];let L;try{const d=JSON.parse(p.arguments),y=d[d.length-1];y&&y.__$stack&&(d.pop(),L=y.__$stack),C.push(...d)}catch{C.push("Unable to log remote console arguments",p.arguments)}return{args:C,stack:L}}t.parse=b;function I(p){if(typeof p!="string")return I(b(p).stack);const C=p;if(C){const L=T(C),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(L||"");if(d&&d.length===4)return{uri:D.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}t.getFirstFrame=I;function T(p){if(!p)return p;const C=p.indexOf(`
`);return C===-1?p:p.substring(0,C)}function P(p,C){const{args:L,stack:d}=b(p),y=typeof L[0]=="string"&&L.length===1;let w=T(d);w&&(w=`(${w.trim()})`);let g=[];if(typeof L[0]=="string"?w&&y?g=[`%c[${C}] %c${L[0]} %c${w}`,l("blue"),l(""),l("grey")]:g=[`%c[${C}] %c${L[0]}`,l("blue"),l(""),...L.slice(1)]:g=[`%c[${C}]%`,l("blue"),...L],w&&!y&&g.push(w),typeof console[p.severity]!="function")throw new Error("Unknown console method");console[p.severity].apply(console,g)}t.log=P;function l(p){return`color: ${p}`}}),define(J[61],Y([0,1,17,26,9]),function(j,t,D,R,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function I(p){return JSON.stringify(p,P)}t.stringify=I;function T(p){let C=JSON.parse(p);return C=l(C),C}t.parse=T;function P(p,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,R.regExpFlags)(C)}:C}function l(p,C=0){if(!p||C>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return b.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 14:return new Date(p.source)}if(p instanceof D.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let L=0;L<p.length;++L)p[L]=l(p[L],C+1);else for(const L in p)Object.hasOwnProperty.call(p,L)&&(p[L]=l(p[L],C+1))}return p}t.revive=l}),define(J[62],Y([0,1,45,11,10,12,19,26,9]),function(j,t,D,R,b,I,T,P,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function p(n,o,a){if(typeof n=="string"&&(n=l.URI.file(n)),a){const h=a.getWorkspaceFolder(n);if(h){const S=a.getWorkspace().folders.length>1;let O;if((0,T.isEqual)(h.uri,n)?O="":O=(0,T.relativePath)(h.uri,n),S){const M=h.name?h.name:(0,T.basename)(h.uri);O=O?M+" \u2022 "+O:M}return O}}if(n.scheme!==R.Schemas.file&&n.scheme!==R.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(n.fsPath))return(0,b.normalize)(L(n.fsPath));let c=(0,b.normalize)(n.fsPath);return!I.isWindows&&o?.userHome&&(c=y(c,o.userHome.fsPath)),c}t.getPathLabel=p;function C(n){if(!n)return;typeof n=="string"&&(n=l.URI.file(n));const o=(0,T.basename)(n)||(n.scheme===R.Schemas.file?n.fsPath:n.path);return I.isWindows&&(0,D.isRootOrDriveLetter)(o)?L(o):o}t.getBaseLabel=C;function L(n,o){return(0,D.hasDriveLetter)(n,o)?n.charAt(0).toUpperCase()+n.slice(1):n}t.normalizeDriveLetter=L;let d=Object.create(null);function y(n,o){if(I.isWindows||!n||!o)return n;let a=d.original===o?d.normalized:void 0;return a||(a=`${(0,P.rtrim)(o,b.posix.sep)}${b.posix.sep}`,d={original:o,normalized:a}),(I.isLinux?n.startsWith(a):(0,P.startsWithIgnoreCase)(n,a))&&(n=`~/${n.substr(a.length)}`),n}t.tildify=y;function w(n,o){return n.replace(/^~($|\/|\\)/,`${o}$1`)}t.untildify=w;const g="\u2026",u="\\\\",f="~";function E(n,o=b.sep){const a=new Array(n.length);let c=!1;for(let h=0;h<n.length;h++){let S=n[h];if(S===""){a[h]=`.${o}`;continue}if(!S){a[h]=S;continue}c=!0;let O="";S.indexOf(u)===0?(O=S.substr(0,S.indexOf(u)+u.length),S=S.substr(S.indexOf(u)+u.length)):S.indexOf(o)===0?(O=S.substr(0,S.indexOf(o)+o.length),S=S.substr(S.indexOf(o)+o.length)):S.indexOf(f)===0&&(O=S.substr(0,S.indexOf(f)+f.length),S=S.substr(S.indexOf(f)+f.length));const M=S.split(o);for(let _=1;c&&_<=M.length;_++)for(let X=M.length-_;c&&X>=0;X--){c=!1;let ee=M.slice(X,X+_).join(o);for(let te=0;!c&&te<n.length;te++)if(te!==h&&n[te]&&n[te].indexOf(ee)>-1){const ie=X+_===M.length,ue=X>0&&n[te].indexOf(o)>-1?o+ee:ee,he=n[te].endsWith(ue);c=!ie||he}if(!c){let te="";(M[0].endsWith(":")||O!=="")&&(X===1&&(X=0,_++,ee=M[0]+o+ee),X>0&&(te=M[0]+o),te=O+te),X>0&&(te=te+g+o),te=te+ee,X+_<M.length&&(te=te+o+g),a[h]=te}}c&&(a[h]=S)}return a}t.shorten=E;var v;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function m(n,o=Object.create(null)){const a=[];let c=!1,h="";for(const S of n)if(S==="$"||c&&S==="{")h&&a.push({value:h,type:v.TEXT}),h="",c=!0;else if(S==="}"&&c){const O=o[h];if(typeof O=="string")O.length&&a.push({value:O,type:v.VARIABLE});else if(O){const M=a[a.length-1];(!M||M.type!==v.SEPARATOR)&&a.push({value:O.label,type:v.SEPARATOR})}h="",c=!1}else h+=S;return h&&!c&&a.push({value:h,type:v.TEXT}),a.filter((S,O)=>{if(S.type===v.SEPARATOR){const M=a[O-1],_=a[O+1];return[M,_].every(X=>X&&(X.type===v.VARIABLE||X.type===v.TEXT)&&X.value.length>0)}return!0}).map(S=>S.value).join("")}t.template=m;function s(n,o){return I.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):n.replace(/&&|&/g,a=>a==="&"?"&&":"&")}t.mnemonicMenuLabel=s;function i(n,o){return I.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,""):I.isWindows?n.replace(/&&|&/g,a=>a==="&"?"&&":"&"):n.replace(/&&/g,"_")}t.mnemonicButtonLabel=i;function r(n){return n.replace(/&/g,"&&")}t.unmnemonicLabel=r;function e(n){const o=n.indexOf("/")!==-1?b.posix:b.win32,a=o.basename(n),c=o.dirname(n);return a.length?{name:a,parentPath:c}:{name:c,parentPath:""}}t.splitName=e}),define(J[27],Y([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.generateUuid=t.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(l){return D.test(l)}t.isUUID=R;const b=new Uint8Array(16),I=[];for(let l=0;l<256;l++)I.push(l.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(l){for(let p=0;p<l.length;p++)l[p]=Math.floor(Math.random()*256);return l};function P(){T(b),b[6]=b[6]&15|64,b[8]=b[8]&63|128;let l=0,p="";return p+=I[b[l++]],p+=I[b[l++]],p+=I[b[l++]],p+=I[b[l++]],p+="-",p+=I[b[l++]],p+=I[b[l++]],p+="-",p+=I[b[l++]],p+=I[b[l++]],p+="-",p+=I[b[l++]],p+=I[b[l++]],p+="-",p+=I[b[l++]],p+=I[b[l++]],p+=I[b[l++]],p+=I[b[l++]],p+=I[b[l++]],p+=I[b[l++]],p}t.generateUuid=P}),define(J[63],Y([0,1,132]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class R{constructor(I="utf8"){this.stringDecoder=new D.StringDecoder(I),this.remaining=null}write(I){const T=[],P=this.remaining?this.remaining+this.stringDecoder.write(I):this.stringDecoder.write(I);if(P.length<1)return T;let l=0,p,C=l;for(;C<P.length;)if(p=P.charCodeAt(C),p===13||p===10){if(T.push(P.substring(l,C)),C++,C<P.length){const L=p;p=P.charCodeAt(C),(L===13&&p===10||L===10&&p===13)&&C++}l=C}else C++;return this.remaining=l<P.length?P.substr(l):null,T}end(){return this.remaining}}t.LineDecoder=R}),define(J[64],Y([0,1,33,10,15]),function(j,t,D,R,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const I=/^\d+$/,T=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var l;(function(m){m[m.x64=0]="x64",m[m.x86=1]="x86",m[m.ARM=2]="ARM"})(l||(l={}));let p;switch(process.arch){case"ia32":case"x32":p=1;break;case"arm":case"arm64":p=2;break;default:p=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class L{constructor(s,i,r){this.exePath=s,this.displayName=i,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:m=!1}={}){return m?p===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:m=!1,findPreview:s=!1}={}){const i=d({useAlternateBitness:m});if(!i)return null;const r=R.join(i,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(r))return null;let e=-1,n=null;for(const c of await b.Promises.readdir(r)){let h=-1;if(s){const O=c.indexOf("-");if(O<0)continue;const M=c.substring(0,O);if(!I.test(M)||c.substring(O+1)!=="preview")continue;h=parseInt(M,10)}else{if(!I.test(c))continue;h=parseInt(c,10)}if(h<=e)continue;const S=R.join(r,c,"pwsh.exe");!await b.SymlinkSupport.existsFile(S)||(n=S,e=h)}if(!n)return null;const o=i.includes("x86")?" (x86)":"",a=s?" Preview":"";return new L(n,`PowerShell${a}${o}`,!0)}async function w({findPreview:m}={}){if(!process.env.LOCALAPPDATA)return null;const s=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=m?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const e of await b.Promises.readdir(s))if(i.test(e)){const n=R.join(s,e,"pwsh.exe");return new L(n,r)}return null}function g(){const m=R.join(D.homedir(),".dotnet","tools","pwsh.exe");return new L(m,".NET Core PowerShell Global Tool")}function u(){const m=R.join(process.env.windir,p===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new L(m,"Windows PowerShell",!0)}async function*f(){let m=await y();m&&(yield m),m=await y({useAlternateBitness:!0}),m&&(yield m),m=await w(),m&&(yield m),m=g(),m&&(yield m),m=await y({findPreview:!0}),m&&(yield m),m=await w({findPreview:!0}),m&&(yield m),m=await y({useAlternateBitness:!0,findPreview:!0}),m&&(yield m),m=u(),m&&(yield m)}async function*E(){for await(const m of f())await m.exists()&&(yield m)}t.enumeratePowerShellInstallations=E;async function v(){for await(const m of E())return m;return null}t.getFirstAvailablePowerShellInstallation=v});var ge=this&&this.__decorate||function(j,t,D,R){var b=arguments.length,I=b<3?t:R===null?R=Object.getOwnPropertyDescriptor(t,D):R,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(j,t,D,R);else for(var P=j.length-1;P>=0;P--)(T=j[P])&&(I=(b<3?T(I):b>3?T(t,D,I):T(t,D))||I);return b>3&&I&&Object.defineProperty(t,D,I),I};define(J[46],Y([0,1,18,3,17,24,44,8,7,2,61,26,6]),function(j,t,D,R,b,I,T,P,l,p,C,L,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var y;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(y=t.RequestType||(t.RequestType={}));function w(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(g=t.ResponseType||(t.ResponseType={}));function u(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(f||(f={}));class E{constructor(k){this.buffer=k,this.pos=0}read(k){const x=this.buffer.slice(this.pos,this.pos+k);return this.pos+=x.byteLength,x}}class v{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(k){this.buffers.push(k)}}var m;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(m||(m={}));function s(U){const k=b.VSBuffer.alloc(4);return k.writeUInt32BE(U,0),k}function i(U){return U.read(4).readUInt32BE(0)}function r(U){const k=b.VSBuffer.alloc(1);return k.writeUInt8(U,0),k}const e={Undefined:r(m.Undefined),String:r(m.String),Buffer:r(m.Buffer),VSBuffer:r(m.VSBuffer),Array:r(m.Array),Object:r(m.Object)},n=typeof Buffer!="undefined";function o(U,k){if(typeof k=="undefined")U.write(e.Undefined);else if(typeof k=="string"){const x=b.VSBuffer.fromString(k);U.write(e.String),U.write(s(x.byteLength)),U.write(x)}else if(n&&Buffer.isBuffer(k)){const x=b.VSBuffer.wrap(k);U.write(e.Buffer),U.write(s(x.byteLength)),U.write(x)}else if(k instanceof b.VSBuffer)U.write(e.VSBuffer),U.write(s(k.byteLength)),U.write(k);else if(Array.isArray(k)){U.write(e.Array),U.write(s(k.length));for(const x of k)o(U,x)}else{const x=b.VSBuffer.fromString(JSON.stringify(k));U.write(e.Object),U.write(s(x.byteLength)),U.write(x)}}function a(U){switch(U.read(1).readUInt8(0)){case m.Undefined:return;case m.String:return U.read(i(U)).toString();case m.Buffer:return U.read(i(U)).buffer;case m.VSBuffer:return U.read(i(U));case m.Array:{const x=i(U),H=[];for(let ne=0;ne<x;ne++)H.push(a(U));return H}case m.Object:return JSON.parse(U.read(i(U)).toString())}}class c{constructor(k,x,H=null,ne=1e3){this.protocol=k,this.ctx=x,this.logger=H,this.timeoutDelay=ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(k,x){this.channels.set(k,x),setTimeout(()=>this.flushPendingRequests(k),0)}sendResponse(k){switch(k.type){case 200:{const x=this.send([k.type]);this.logger?.logOutgoing(x,0,1,u(k.type));return}case 201:case 202:case 204:case 203:{const x=this.send([k.type,k.id],k.data);this.logger?.logOutgoing(x,k.id,1,u(k.type),k.data);return}}}send(k,x=void 0){const H=new v;return o(H,k),o(H,x),this.sendBuffer(H.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch{return 0}}onRawMessage(k){const x=new E(k),H=a(x),ne=a(x),K=H[0];switch(K){case 100:return this.logger?.logIncoming(k.byteLength,H[1],1,`${w(K)}: ${H[2]}.${H[3]}`,ne),this.onPromise({type:K,id:H[1],channelName:H[2],name:H[3],arg:ne});case 102:return this.logger?.logIncoming(k.byteLength,H[1],1,`${w(K)}: ${H[2]}.${H[3]}`,ne),this.onEventListen({type:K,id:H[1],channelName:H[2],name:H[3],arg:ne});case 101:return this.logger?.logIncoming(k.byteLength,H[1],1,`${w(K)}`),this.disposeActiveRequest({type:K,id:H[1]});case 103:return this.logger?.logIncoming(k.byteLength,H[1],1,`${w(K)}`),this.disposeActiveRequest({type:K,id:H[1]})}}onPromise(k){const x=this.channels.get(k.channelName);if(!x){this.collectPendingRequest(k);return}const H=new I.CancellationTokenSource;let ne;try{ne=x.call(this.ctx,k.name,k.arg,H.token)}catch(A){ne=Promise.reject(A)}const K=k.id;ne.then(A=>{this.sendResponse({id:K,data:A,type:201}),this.activeRequests.delete(k.id)},A=>{A instanceof Error?this.sendResponse({id:K,data:{message:A.message,name:A.name,stack:A.stack?A.stack.split?A.stack.split(`
`):A.stack:void 0},type:202}):this.sendResponse({id:K,data:A,type:203}),this.activeRequests.delete(k.id)});const Q=(0,p.toDisposable)(()=>H.cancel());this.activeRequests.set(k.id,Q)}onEventListen(k){const x=this.channels.get(k.channelName);if(!x){this.collectPendingRequest(k);return}const H=k.id,K=x.listen(this.ctx,k.name,k.arg)(Q=>this.sendResponse({id:H,data:Q,type:204}));this.activeRequests.set(k.id,K)}disposeActiveRequest(k){const x=this.activeRequests.get(k.id);x&&(x.dispose(),this.activeRequests.delete(k.id))}collectPendingRequest(k){let x=this.pendingRequests.get(k.channelName);x||(x=[],this.pendingRequests.set(k.channelName,x));const H=setTimeout(()=>{console.error(`Unknown channel: ${k.channelName}`),k.type===100&&this.sendResponse({id:k.id,data:{name:"Unknown channel",message:`Channel name '${k.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);x.push({request:k,timeoutTimer:H})}flushPendingRequests(k){const x=this.pendingRequests.get(k);if(x){for(const H of x)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(k)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,p.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=c;var h;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(h=t.RequestInitiator||(t.RequestInitiator={}));class S{constructor(k,x=null){this.protocol=k,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=x}getChannel(k){const x=this;return{call(H,ne,K){return x.isDisposed?Promise.reject(P.canceled()):x.requestPromise(k,H,ne,K)},listen(H,ne){return x.isDisposed?l.Event.None:x.requestEvent(k,H,ne)}}}requestPromise(k,x,H,ne=I.CancellationToken.None){const K=this.lastRequestId++,A={id:K,type:100,channelName:k,name:x,arg:H};if(ne.isCancellationRequested)return Promise.reject(P.canceled());let F;return new Promise((W,G)=>{if(ne.isCancellationRequested)return G(P.canceled());const q=()=>{const fe=se=>{switch(se.type){case 201:this.handlers.delete(K),W(se.data);break;case 202:{this.handlers.delete(K);const ce=new Error(se.data.message);ce.stack=se.data.stack,ce.name=se.data.name,G(ce);break}case 203:this.handlers.delete(K),G(se.data);break}};this.handlers.set(K,fe),this.sendRequest(A)};let re=null;this.state===f.Idle?q():(re=(0,R.createCancelablePromise)(fe=>this.whenInitialized()),re.then(()=>{re=null,q()}));const ae=()=>{re?(re.cancel(),re=null):this.sendRequest({id:K,type:101}),G(P.canceled())},pe=ne.onCancellationRequested(ae);F=(0,p.combinedDisposable)((0,p.toDisposable)(ae),pe),this.activeRequests.add(F)}).finally(()=>{this.activeRequests.delete(F)})}requestEvent(k,x,H){const ne=this.lastRequestId++,Q={id:ne,type:102,channelName:k,name:x,arg:H};let A=null;const F=new l.Emitter({onFirstListenerAdd:()=>{A=(0,R.createCancelablePromise)(W=>this.whenInitialized()),A.then(()=>{A=null,this.activeRequests.add(F),this.sendRequest(Q)})},onLastListenerRemove:()=>{A?(A.cancel(),A=null):(this.activeRequests.delete(F),this.sendRequest({id:ne,type:103}))}}),z=W=>F.fire(W.data);return this.handlers.set(ne,z),F.event}sendRequest(k){switch(k.type){case 100:case 102:{const x=this.send([k.type,k.id,k.channelName,k.name],k.arg);this.logger&&this.logger.logOutgoing(x,k.id,0,`${w(k.type)}: ${k.channelName}.${k.name}`,k.arg);return}case 101:case 103:{const x=this.send([k.type,k.id]);this.logger&&this.logger.logOutgoing(x,k.id,0,w(k.type));return}}}send(k,x=void 0){const H=new v;return o(H,k),o(H,x),this.sendBuffer(H.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch{return 0}}onBuffer(k){const x=new E(k),H=a(x),ne=a(x),K=H[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(k.byteLength,0,0,u(K)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],0,u(K),ne),this.onResponse({type:H[0],id:H[1],data:ne})}}onResponse(k){if(k.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}const x=this.handlers.get(k.id);x&&x(k)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,p.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ge([T.memoize],S.prototype,"onDidInitializePromise",null),t.ChannelClient=S;class O{constructor(k){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,k(({protocol:x,onDidClientDisconnect:H})=>{l.Event.once(x.onMessage)(K=>{const Q=new E(K),A=a(Q),F=new c(x,A),z=new S(x);this.channels.forEach((G,q)=>F.registerChannel(q,G));const W={channelServer:F,channelClient:z,ctx:A};this._connections.add(W),this._onDidAddConnection.fire(W),H(()=>{F.dispose(),z.dispose(),this._connections.delete(W),this._onDidRemoveConnection.fire(W)})})})}get connections(){const k=[];return this._connections.forEach(x=>k.push(x)),k}getChannel(k,x){const H=this;return{call(ne,K,Q){let A;if((0,d.isFunction)(x)){let z=(0,D.getRandomElement)(H.connections.filter(x));A=z?Promise.resolve(z):l.Event.toPromise(l.Event.filter(H.onDidAddConnection,x))}else A=x.routeCall(H,ne,K);const F=A.then(z=>z.channelClient.getChannel(k));return _(F).call(ne,K,Q)},listen(ne,K){if((0,d.isFunction)(x))return H.getMulticastEvent(k,x,ne,K);const Q=x.routeEvent(H,ne,K).then(A=>A.channelClient.getChannel(k));return _(Q).listen(ne,K)}}}getMulticastEvent(k,x,H,ne){const K=this;let Q=new p.DisposableStore;const A=new l.Emitter({onFirstListenerAdd:()=>{Q=new p.DisposableStore;const F=new l.EventMultiplexer,z=new Map,W=q=>{const ae=q.channelClient.getChannel(k).listen(H,ne),pe=F.add(ae);z.set(q,pe)},G=q=>{const re=z.get(q);!re||(re.dispose(),z.delete(q))};K.connections.filter(x).forEach(W),l.Event.filter(K.onDidAddConnection,x)(W,void 0,Q),K.onDidRemoveConnection(G,void 0,Q),F.event(A.fire,A,Q),Q.add(F)},onLastListenerRemove:()=>{Q.dispose()}});return A.event}registerChannel(k,x){this.channels.set(k,x),this._connections.forEach(H=>{H.channelServer.registerChannel(k,x)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=O;class M{constructor(k,x,H=null){const ne=new v;o(ne,x),k.send(ne.buffer),this.channelClient=new S(k,H),this.channelServer=new c(k,x,H)}getChannel(k){return this.channelClient.getChannel(k)}registerChannel(k,x){this.channelServer.registerChannel(k,x)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=M;function _(U){return{call(k,x,H){return U.then(ne=>ne.call(k,x,H))},listen(k,x){const H=new l.Relay;return U.then(ne=>H.input=ne.listen(k,x)),H.event}}}t.getDelayedChannel=_;function X(U){let k=!1;return{call(x,H,ne){return k?U.call(x,H,ne):(0,R.timeout)(0).then(()=>k=!0).then(()=>U.call(x,H,ne))},listen(x,H){if(k)return U.listen(x,H);const ne=new l.Relay;return(0,R.timeout)(0).then(()=>k=!0).then(()=>ne.input=U.listen(x,H)),ne.event}}}t.getNextTickChannel=X;class ee{constructor(k){this.fn=k}routeCall(k){return this.route(k)}routeEvent(k){return this.route(k)}async route(k){for(const x of k.connections)if(await Promise.resolve(this.fn(x.ctx)))return Promise.resolve(x);return await l.Event.toPromise(k.onDidAddConnection),await this.route(k)}}t.StaticRouter=ee;var te;(function(U){function k(K,Q){const A=K,F=Q&&Q.disableMarshalling,z=new Map;for(const W in A)H(W)&&z.set(W,l.Event.buffer(A[W],!0));return new class{listen(W,G,q){const re=z.get(G);if(re)return re;if(ne(G)){const ae=A[G];if(typeof ae=="function")return ae.call(A,q)}throw new Error(`Event not found: ${G}`)}call(W,G,q){const re=A[G];if(typeof re=="function"){if(!F&&Array.isArray(q))for(let ae=0;ae<q.length;ae++)q[ae]=(0,C.revive)(q[ae]);return re.apply(A,q)}throw new Error(`Method not found: ${G}`)}}}U.fromService=k;function x(K,Q){const A=Q&&Q.disableMarshalling;return new Proxy({},{get(F,z){if(typeof z=="string")return Q?.properties?.has(z)?Q.properties.get(z):ne(z)?function(W){return K.listen(z,W)}:H(z)?K.listen(z):async function(...W){let G;Q&&!(0,d.isUndefinedOrNull)(Q.context)?G=[Q.context,...W]:G=W;const q=await K.call(z,G);return A?q:(0,C.revive)(q)};throw new Error(`Property not found: ${String(z)}`)}})}U.toService=x;function H(K){return K[0]==="o"&&K[1]==="n"&&L.isUpperAsciiLetter(K.charCodeAt(2))}function ne(K){return/^onDynamic/.test(K)&&L.isUpperAsciiLetter(K.charCodeAt(9))}})(te=t.ProxyChannel||(t.ProxyChannel={}));const ie=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let k=U.toString();if(k!=="[object Object]")return k}return U}function he(U){return Array.isArray(U)?U.map(ue):ue(U)}function V(U,k,x,H,ne,K,Q){Q=he(Q);const A=ie[ne],F=A[H%A.length];let z=[`%c[${U}]%c[${String(k).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${F}`];/\($/.test(K)?(z=z.concat(Q),z.push(")")):z.push(Q),console.log.apply(console,z)}t.logWithColors=V;class Z{constructor(k,x){this._outgoingPrefix=k,this._incomingPrefix=x,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(k,x,H,ne,K){this._totalOutgoing+=k,V(this._outgoingPrefix,this._totalOutgoing,k,x,H,ne,K)}logIncoming(k,x,H,ne,K){this._totalIncoming+=k,V(this._incomingPrefix,this._totalIncoming,k,x,H,ne,K)}}t.IPCLogger=Z}),define(J[65],Y([0,1,3,7,2,6]),function(j,t,D,R,b,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageState=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var T;(function(L){L[L.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=t.StorageHint||(t.StorageHint={}));function P(L){const d=L;return d?.changed instanceof Map||d?.deleted instanceof Set}t.isStorageItemsChangeEvent=P;var l;(function(L){L[L.None=0]="None",L[L.Initialized=1]="Initialized",L[L.Closed=2]="Closed"})(l=t.StorageState||(t.StorageState={}));class p extends b.Disposable{constructor(d,y=Object.create(null)){super();this.database=d,this.options=y,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((y,w)=>this.accept(w,y)),d.deleted?.forEach(y=>this.accept(y,void 0))}accept(d,y){if(this.state===l.Closed)return;let w=!1;(0,I.isUndefinedOrNull)(y)?w=this.cache.delete(d):this.cache.get(d)!==y&&(this.cache.set(d,y),w=!0),w&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,y){const w=this.cache.get(d);return(0,I.isUndefinedOrNull)(w)?y:w}getBoolean(d,y){const w=this.get(d);return(0,I.isUndefinedOrNull)(w)?y:w==="true"}getNumber(d,y){const w=this.get(d);return(0,I.isUndefinedOrNull)(w)?y:parseInt(w,10)}async set(d,y){if(this.state===l.Closed)return;if((0,I.isUndefinedOrNull)(y))return this.delete(d);const w=String(y);if(this.cache.get(d)!==w)return this.cache.set(d,w),this.pendingInserts.set(d,w),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async delete(d){if(!(this.state===l.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(!!this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((y,w)=>this.items.set(w,y)),d.delete&&d.delete.forEach(y=>this.items.delete(y))}async close(){}}t.InMemoryStorageDatabase=C}),define(J[66],Y([4,5]),function(j,t){return j.create("vs/base/common/date",t)}),define(J[67],Y([0,1,66]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const R=60,b=R*60,I=b*24,T=I*7,P=I*30,l=I*365;function p(L,d,y){typeof L!="number"&&(L=L.getTime());const w=Math.round((new Date().getTime()-L)/1e3);if(w<-30)return(0,D.localize)(0,null,p(new Date().getTime()+w*1e3,!1));if(w<30)return(0,D.localize)(1,null);let g;return w<R?(g=w,d?g===1?y?(0,D.localize)(2,null,g):(0,D.localize)(3,null,g):y?(0,D.localize)(4,null,g):(0,D.localize)(5,null,g):g===1?y?(0,D.localize)(6,null,g):(0,D.localize)(7,null,g):y?(0,D.localize)(8,null,g):(0,D.localize)(9,null,g)):w<b?(g=Math.floor(w/R),d?g===1?y?(0,D.localize)(10,null,g):(0,D.localize)(11,null,g):y?(0,D.localize)(12,null,g):(0,D.localize)(13,null,g):g===1?y?(0,D.localize)(14,null,g):(0,D.localize)(15,null,g):y?(0,D.localize)(16,null,g):(0,D.localize)(17,null,g)):w<I?(g=Math.floor(w/b),d?g===1?y?(0,D.localize)(18,null,g):(0,D.localize)(19,null,g):y?(0,D.localize)(20,null,g):(0,D.localize)(21,null,g):g===1?y?(0,D.localize)(22,null,g):(0,D.localize)(23,null,g):y?(0,D.localize)(24,null,g):(0,D.localize)(25,null,g)):w<T?(g=Math.floor(w/I),d?g===1?(0,D.localize)(26,null,g):(0,D.localize)(27,null,g):g===1?(0,D.localize)(28,null,g):(0,D.localize)(29,null,g)):w<P?(g=Math.floor(w/T),d?g===1?y?(0,D.localize)(30,null,g):(0,D.localize)(31,null,g):y?(0,D.localize)(32,null,g):(0,D.localize)(33,null,g):g===1?y?(0,D.localize)(34,null,g):(0,D.localize)(35,null,g):y?(0,D.localize)(36,null,g):(0,D.localize)(37,null,g)):w<l?(g=Math.floor(w/P),d?g===1?y?(0,D.localize)(38,null,g):(0,D.localize)(39,null,g):y?(0,D.localize)(40,null,g):(0,D.localize)(41,null,g):g===1?y?(0,D.localize)(42,null,g):(0,D.localize)(43,null,g):y?(0,D.localize)(44,null,g):(0,D.localize)(45,null,g)):(g=Math.floor(w/l),d?g===1?y?(0,D.localize)(46,null,g):(0,D.localize)(47,null,g):y?(0,D.localize)(48,null,g):(0,D.localize)(49,null,g):g===1?y?(0,D.localize)(50,null,g):(0,D.localize)(51,null,g):y?(0,D.localize)(52,null,g):(0,D.localize)(53,null,g))}t.fromNow=p;function C(L){return L.getFullYear()+"-"+String(L.getMonth()+1).padStart(2,"0")+"-"+String(L.getDate()).padStart(2,"0")+"T"+String(L.getHours()).padStart(2,"0")+":"+String(L.getMinutes()).padStart(2,"0")+":"+String(L.getSeconds()).padStart(2,"0")+"."+(L.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=C}),define(J[68],Y([4,5]),function(j,t){return j.create("vs/base/common/errorMessage",t)}),define(J[28],Y([0,1,18,6,68]),function(j,t,D,R,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createErrorWithActions=t.isErrorWithActions=t.toErrorMessage=void 0;function I(L,d){return d&&(L.stack||L.stacktrace)?b.localize(0,null,P(L),T(L.stack)||T(L.stacktrace)):P(L)}function T(L){return Array.isArray(L)?L.join(`
`):L}function P(L){return typeof L.code=="string"&&typeof L.errno=="number"&&typeof L.syscall=="string"?b.localize(1,null,L.message):L.message||b.localize(2,null)}function l(L=null,d=!1){if(!L)return b.localize(3,null);if(Array.isArray(L)){const y=D.coalesce(L),w=l(y[0],d);return y.length>1?b.localize(4,null,w,y.length):w}if(R.isString(L))return L;if(L.detail){const y=L.detail;if(y.error)return I(y.error,d);if(y.exception)return I(y.exception,d)}return L.stack?I(L,d):L.message?L.message:b.localize(5,null)}t.toErrorMessage=l;function p(L){const d=L;return d instanceof Error&&Array.isArray(d.actions)}t.isErrorWithActions=p;function C(L,d=Object.create(null)){const y=new Error(L);return d.actions&&(y.actions=d.actions),y}t.createErrorWithActions=C}),define(J[69],Y([4,5]),function(j,t){return j.create("vs/base/node/processes",t)}),define(J[47],Y([0,1,39,45,11,22,10,12,29,57,6,63,15,69]),function(j,t,D,R,b,I,T,P,l,p,C,L,d,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.removeDangerousEnvVariables=t.TerminateResponseCode=t.Source=void 0,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return p.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return p.TerminateResponseCode}});function w(i){switch(i){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(i,r){if(P.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};r&&(e.cwd=r);const n=D.execFile("taskkill",["/T","/F","/PID",i.pid.toString()],e);return new Promise(o=>{n.once("error",a=>{o({success:!1,error:a})}),n.once("exit",(a,c)=>{o(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?w(e.status):1})}else if(P.isLinux||P.isMacintosh)try{const e=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(n=>{D.execFile(e,[i.pid.toString()],{encoding:"utf8",shell:!0},(o,a,c)=>{n(o?{success:!1,error:o}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else i.kill("SIGKILL");return Promise.resolve({success:!0})}function u(i){!i||(delete i.DEBUG,P.isMacintosh&&delete i.DYLD_LIBRARY_PATH,P.isLinux&&delete i.LD_PRELOAD)}t.removeDangerousEnvVariables=u;function f(i=l.env){return i.comspec||"cmd.exe"}t.getWindowsShell=f;class E{constructor(r,e,n,o){if(e!==void 0&&n!==void 0&&o!==void 0)this.cmd=r,this.args=e,this.shell=n,this.options=o;else{const a=r;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(l.env).forEach(c=>{a[c]=l.env[c]}),Object.keys(this.options.env).forEach(c=>{a[c]=this.options.env[c]}),this.options.env=a}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const e=r.lastIndexOf(T.sep);return e!==-1&&(r=r.substring(e+1)),E.WellKnowCommands[r]?r:"other"}start(r){return P.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(l.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(e=>{let n,o;const a=new Promise((c,h)=>{n=c,o=h});if(e){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=D.exec(c,this.options,(h,S,O)=>{this.childProcess=null;const M=h;M&&M.killed?o({killed:this.terminateRequested,stdout:S.toString(),stderr:O.toString()}):this.handleExec(n,r,h,S,O)})}else{let c=null;const h=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,n,r,o);const O={terminated:this.terminateRequested};C.isNumber(S)&&(O.cmdCode=S),n(O)};if(this.shell&&P.isWindows){const S=I.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let O=!1,M=!1;const _=[];let X=this.ensureQuotes(this.cmd);_.push(X.value),O=X.quoted,this.args&&this.args.forEach(te=>{X=this.ensureQuotes(te),_.push(X.value),M=M&&X.quoted});const ee=["/s","/c"];O?M?ee.push('"'+_.join(" ")+'"'):_.length>1?ee.push('"'+_[0]+'" '+_.slice(1).join(" ")):ee.push('"'+_[0]+'"'):ee.push(_.join(" ")),c=D.spawn(f(),ee,S)}else this.cmd&&(c=D.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(C.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",S=>{this.childProcess=null,o({terminated:this.terminateRequested,error:S})}),c.pid&&(this.childProcess.on("close",h),this.handleSpawn(c,n,r,o,!0)))}return a})}handleClose(r,e,n,o){}ensureQuotes(r){return E.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,g(r,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!P.isWindows)return r(!1);const e=D.spawn(f(),["/s","/c"]);e.on("error",n=>r(!0)),e.on("exit",n=>r(!1))})}}t.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class v extends E{constructor(r,e,n,o){super(r,e,n,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,e,n,o,a){[o,a].forEach((c,h)=>{const S=new L.LineDecoder;S.write(c).forEach(_=>{e({line:_,source:h===0?0:1})});const M=S.end();M&&e({line:M,source:h===0?0:1})}),r({terminated:this.terminateRequested,error:n})}handleSpawn(r,e,n,o,a){const c=new L.LineDecoder,h=new L.LineDecoder;r.stdout.on("data",S=>{c.write(S).forEach(M=>n({line:M,source:0}))}),r.stderr.on("data",S=>{h.write(S).forEach(M=>n({line:M,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=h}handleClose(r,e,n,o){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&n({line:a,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&n({line:c,source:1})}}t.LineProcess=v;function m(i){let r=[],e=!1;const n=function(o){if(e){r.push(o);return}(!i.send(o,c=>{if(c&&console.error(c),e=!1,r.length>0){const h=r.slice(0);r=[],h.forEach(S=>n(S))}})||P.isWindows)&&(e=!0)};return{send:n}}t.createQueuedSender=m;var s;(function(i){async function r(e,n,o){if(T.isAbsolute(e))return e;if(n===void 0&&(n=l.cwd()),T.dirname(e)!=="."||(o===void 0&&C.isString(l.env.PATH)&&(o=l.env.PATH.split(T.delimiter)),o===void 0||o.length===0))return T.join(n,e);async function c(h){if(await d.Promises.exists(h)){let S;try{S=await d.Promises.stat(h)}catch(O){O.message.startsWith("EACCES")&&(S=await d.Promises.lstat(h))}return S?!S.isDirectory():!1}return!1}for(let h of o){let S;if(T.isAbsolute(h)?S=T.join(h,e):S=T.join(n,h,e),await c(S))return S;let O=S+".com";if(await c(O)||(O=S+".exe",await c(O)))return O}return T.join(n,e)}i.findExecutable=r})(s=t.win32||(t.win32={}))}),define(J[70],Y([0,1,33,12,64,47]),function(j,t,D,R,b,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function T(y,w){return y===1?R.isWindows?L():I.getWindowsShell(w):p(y,w)}t.getSystemShell=T;function P(y,w){return y===1?R.isWindows?d(w):I.getWindowsShell(w):p(y,w)}t.getSystemShellSync=P;let l=null;function p(y,w){if(R.isLinux&&y===2||R.isMacintosh&&y===3)return"/bin/bash";if(!l){let g;if(R.isWindows)g="/bin/bash";else{if(g=w.SHELL,!g)try{g=(0,D.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}l=g}return l}let C=null;async function L(){return C||(C=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),C}function d(y){if(C)return C;const w=R.isWindows&&parseFloat((0,D.release)())>=10,g=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),u=`${y.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return w?u:I.getWindowsShell(y)}}),define(J[71],Y([0,1,39,3,17,24,60,8,7,2,22,47,46]),function(j,t,D,R,b,I,T,P,l,p,C,L,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class y extends d.ChannelServer{constructor(u){super({send:f=>{try{process.send&&process.send(f.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",f=>b.VSBuffer.wrap(Buffer.from(f,"base64")))},u);process.once("disconnect",()=>this.dispose())}}t.Server=y;class w{constructor(u,f){this.modulePath=u,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const E=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new R.Delayer(E),this.child=null,this._client=null}getChannel(u){const f=this;return{call(E,v,m){return f.requestPromise(u,E,v,m)},listen(E,v){return f.requestEvent(u,E,v)}}}requestPromise(u,f,E,v=I.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const m=this.getCachedChannel(u),s=(0,R.createCancelablePromise)(e=>m.call(f,E,e)),i=v.onCancellationRequested(()=>s.cancel()),r=(0,p.toDisposable)(()=>s.cancel());return this.activeRequests.add(r),s.finally(()=>{i.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),s}requestEvent(u,f,E){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let v;const m=new l.Emitter({onFirstListenerAdd:()=>{v=this.getCachedChannel(u).listen(f,E)(m.fire,m),this.activeRequests.add(v)},onLastListenerRemove:()=>{this.activeRequests.delete(v),v.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return m.event}get client(){if(!this._client){const u=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(f.env={...f.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,L.removeDangerousEnvVariables)(f.env),this.child=(0,D.fork)(this.modulePath,u,f);const E=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,T.isRemoteConsoleLog)(n)){(0,T.log)(n,`IPC Library: ${this.options.serverName}`);return}E.fire(b.VSBuffer.wrap(Buffer.from(n,"base64")))});const m=this.options.useQueue?(0,L.createQueuedSender)(this.child):this.child,s=n=>this.child&&this.child.connected&&m.send(n.buffer.toString("base64")),i=E.event,r={send:s,onMessage:i};this._client=new d.ChannelClient(r);const e=()=>this.disposeClient();process.once("exit",e),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,o)=>{process.removeListener("exit",e),this.activeRequests.forEach(a=>(0,p.dispose)(a)),this.activeRequests.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:o})})}return this._client}getCachedChannel(u){let f=this.channels.get(u);return f||(f=this.client.getChannel(u),this.channels.set(u,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=w}),define(J[72],Y([4,5]),function(j,t){return j.create("vs/base/node/zip",t)}),define(J[73],Y([4,5]),function(j,t){return j.create("vs/platform/configuration/common/configurationRegistry",t)}),define(J[74],Y([4,5]),function(j,t){return j.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(J[75],Y([4,5]),function(j,t){return j.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(J[76],Y([4,5]),function(j,t){return j.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(J[77],Y([4,5]),function(j,t){return j.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(J[78],Y([4,5]),function(j,t){return j.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(J[79],Y([4,5]),function(j,t){return j.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(J[80],Y([4,5]),function(j,t){return j.create("vs/platform/extensions/common/extensionValidator",t)}),define(J[81],Y([4,5]),function(j,t){return j.create("vs/platform/files/common/fileService",t)}),define(J[82],Y([4,5]),function(j,t){return j.create("vs/platform/files/common/io",t)}),define(J[83],Y([4,5]),function(j,t){return j.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(J[84],Y([4,5]),function(j,t){return j.create("vs/platform/request/common/request",t)}),define(J[85],Y([4,5]),function(j,t){return j.create("vs/platform/telemetry/common/telemetryService",t)}),define(J[86],Y([4,5]),function(j,t){return j.create("vs/platform/terminal/node/shellEnv",t)}),define(J[87],Y([0,1,67,44,11,10,29,19,9]),function(j,t,D,R,b,I,T,P,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class p{constructor(g,u,f){this._args=g,this.paths=u,this.productService=f}get appRoot(){return(0,I.dirname)(b.FileAccess.asFileUri("",j).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,I.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,I.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(l.URI.file((0,I.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return l.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return l.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=T.env.VSCODE_PORTABLE;return g?l.URI.file((0,I.join)(g,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,I.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,I.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,I.resolve)(g):(0,I.normalize)((0,I.join)(b.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,I.resolve)(g):(0,I.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,I.resolve)(g);const u=T.env.VSCODE_EXTENSIONS;if(u)return u;const f=T.env.VSCODE_PORTABLE;return f?(0,I.join)(f,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(u=>/^[^:/?#]+?:\/\//.test(u)?l.URI.parse(u):l.URI.file((0,I.normalize)(u)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?l.URI.parse(g):l.URI.file((0,I.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return l.URI.file((0,I.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ge([R.memoize],p.prototype,"appRoot",null),ge([R.memoize],p.prototype,"userHome",null),ge([R.memoize],p.prototype,"userDataPath",null),ge([R.memoize],p.prototype,"appSettingsHome",null),ge([R.memoize],p.prototype,"tmpDir",null),ge([R.memoize],p.prototype,"cacheHome",null),ge([R.memoize],p.prototype,"userRoamingDataHome",null),ge([R.memoize],p.prototype,"settingsResource",null),ge([R.memoize],p.prototype,"userDataSyncHome",null),ge([R.memoize],p.prototype,"userDataSyncLogResource",null),ge([R.memoize],p.prototype,"sync",null),ge([R.memoize],p.prototype,"machineSettingsResource",null),ge([R.memoize],p.prototype,"globalStorageHome",null),ge([R.memoize],p.prototype,"workspaceStorageHome",null),ge([R.memoize],p.prototype,"keybindingsResource",null),ge([R.memoize],p.prototype,"keyboardLayoutResource",null),ge([R.memoize],p.prototype,"argvResource",null),ge([R.memoize],p.prototype,"snippetsHome",null),ge([R.memoize],p.prototype,"isExtensionDevelopment",null),ge([R.memoize],p.prototype,"untitledWorkspacesHome",null),ge([R.memoize],p.prototype,"installSourcePath",null),ge([R.memoize],p.prototype,"builtinExtensionsPath",null),ge([R.memoize],p.prototype,"extensionsPath",null),ge([R.memoize],p.prototype,"extensionDevelopmentLocationURI",null),ge([R.memoize],p.prototype,"extensionDevelopmentKind",null),ge([R.memoize],p.prototype,"extensionTestsLocationURI",null),ge([R.memoize],p.prototype,"debugExtensionHost",null),ge([R.memoize],p.prototype,"serviceMachineIdResource",null),ge([R.memoize],p.prototype,"telemetryLogResource",null),ge([R.memoize],p.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=p;function C(w,g){return y(w["inspect-extensions"],w["inspect-brk-extensions"],5870,g,w.debugId,w.extensionEnvironment)}t.parseExtensionHostPort=C;function L(w,g){return y(w["inspect-search"],w["inspect-brk-search"],5876,g,w.extensionEnvironment)}t.parseSearchPort=L;function d(w,g){return y(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,g,w.extensionEnvironment)}t.parsePtyHostPort=d;function y(w,g,u,f,E,v){const s=Number(g||w)||(f?null:u),i=s?Boolean(!!g):!1;let r;if(v)try{r=JSON.parse(v)}catch{}return{port:s,break:i,debugId:E,env:r}}}),function(){"use strict";function j(t,D,R,b){function I(P){const l=T(P),p=[l];return t.isAbsolute(l)||p.unshift(b),t.resolve(...p)}function T(P){const l=process.env.VSCODE_PORTABLE;if(l)return t.join(l,"user-data");let p=process.env.VSCODE_APPDATA;if(p)return t.join(p,R);const C=P["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(p=process.env.APPDATA,!p){const L=process.env.USERPROFILE;if(typeof L!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");p=t.join(L,"AppData","Roaming")}break;case"darwin":p=t.join(D.homedir(),"Library","Application Support");break;case"linux":p=process.env.XDG_CONFIG_HOME||t.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(p,R)}return{getUserDataPath:I}}if(typeof define=="function")define(J[88],Y([0,133,33,11,19,29]),function(t,D,R,b,I,T){const P=I.dirname(b.FileAccess.asFileUri("",t)),l=t.__$__nodeRequire(I.joinPath(P,"package.json").fsPath);return j(D,R,l.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),D=require("path"),R=require("os");module.exports=j(D,R,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[89],Y([0,1,33,87,88]),function(j,t,D,R,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class I extends R.AbstractNativeEnvironmentService{constructor(P,l){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,b.getUserDataPath)(P)},l)}}t.NativeEnvironmentService=I}),define(J[90],Y([0,1,22]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const R=/^%([\w\d.-]+)%$/i;function b(I,T){const P=l=>{if(typeof l!="string")return;const p=R.exec(l);if(!p)return;const C=T[p[1]]??l;return typeof C=="string"?C:typeof C.message=="string"?C.message:l};return(0,D.cloneAndChange)(I,P)}t.localizeManifest=b}),define(J[48],Y([0,1,80]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function I(d){return d=d.trim(),d==="*"||R.test(d)}t.isValidVersionStr=I;function T(d){if(!I(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=d.match(R);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}t.parseVersion=T;function P(d){if(!d)return null;let y=d.majorBase,w=d.majorMustEqual,g=d.minorBase,u=d.minorMustEqual,f=d.patchBase,E=d.patchMustEqual;d.hasCaret&&(y===0||(u=!1),E=!1);let v=0;if(d.preRelease){const m=b.exec(d.preRelease);if(m){const[,s,i,r]=m;v=Date.UTC(Number(s),Number(i)-1,Number(r))}}return{majorBase:y,majorMustEqual:w,minorBase:g,minorMustEqual:u,patchBase:f,patchMustEqual:E,isMinimum:d.hasGreaterEquals,notBefore:v}}t.normalizeVersion=P;function l(d,y,w){let g;typeof d=="string"?g=P(T(d)):g=d;let u;y instanceof Date?u=y.getTime():typeof y=="string"&&(u=new Date(y).getTime());let f;if(typeof w=="string"?f=P(T(w)):f=w,!g||!f)return!1;let E=g.majorBase,v=g.minorBase,m=g.patchBase,s=f.majorBase,i=f.minorBase,r=f.patchBase,e=f.notBefore,n=f.majorMustEqual,o=f.minorMustEqual,a=f.patchMustEqual;return f.isMinimum?E>s?!0:E<s?!1:v>i?!0:v<i||u&&u<e?!1:m>=r:(E===1&&s===0&&(!n||!o||!a)&&(s=1,i=0,r=0,n=!0,o=!1,a=!1),E<s?!1:E>s?!n:v<i?!1:v>i?!o:m<r?!1:m>r?!a:!(u&&u<e))}t.isValidVersion=l;function p(d,y,w,g){return w.isBuiltin||typeof w.main=="undefined"?!0:L(d,y,w.engines.vscode,g)}t.isValidExtensionVersion=p;function C(d,y,w){return d==="*"||L(y,w,d)}t.isEngineValid=C;function L(d,y,w,g=[]){let u=P(T(w));if(!u)return g.push(D.localize(0,null,w)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return g.push(D.localize(1,null,w)),!1}else if(!u.majorMustEqual)return g.push(D.localize(2,null,w)),!1;return l(d,y,u)?!0:(g.push(D.localize(3,null,d,w)),!1)}}),define(J[91],Y([0,1,17,27]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function b(I,T,P){let l=P&&P.get("storage.serviceMachineId",0)||null;if(l)return l;try{const C=(await T.readFile(I.serviceMachineIdResource)).value.toString();l=(0,R.isUUID)(C)?C:null}catch{l=null}if(!l){l=(0,R.generateUuid)();try{await T.writeFile(I.serviceMachineIdResource,D.VSBuffer.fromString(l))}catch{}}return P&&P.store("storage.serviceMachineId",l,0,1),l}t.getServiceMachineId=b}),define(J[40],Y([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class D{constructor(b,I=[],T=!1){this.ctor=b,this.staticArguments=I,this.supportsDelayedInstantiation=T}}t.SyncDescriptor=D}),define(J[92],Y([0,1,40]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=void 0;const R=[];function b(T,P,l){P instanceof D.SyncDescriptor||(P=new D.SyncDescriptor(P,[],l)),R.push([T,P])}t.registerSingleton=b;function I(){return R}t.getSingletonServiceDescriptors=I}),define(J[93],Y([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class D{constructor(I){this.incoming=new Map,this.outgoing=new Map,this.data=I}}t.Node=D;class R{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(let T of this._nodes.values())T.outgoing.size===0&&I.push(T);return I}insertEdge(I,T){const P=this.lookupOrInsertNode(I),l=this.lookupOrInsertNode(T);P.outgoing.set(this._hashFn(T),l),l.incoming.set(this._hashFn(I),P)}removeNode(I){const T=this._hashFn(I);this._nodes.delete(T);for(let P of this._nodes.values())P.outgoing.delete(T),P.incoming.delete(T)}lookupOrInsertNode(I){const T=this._hashFn(I);let P=this._nodes.get(T);return P||(P=new D(I),this._nodes.set(T,P)),P}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){let I=[];for(let[T,P]of this._nodes)I.push(`${T}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return I.join(`
`)}findCycleSlow(){for(let[I,T]of this._nodes){const P=new Set([I]),l=this._findCycle(T,P);if(l)return l}}_findCycle(I,T){for(let[P,l]of I.outgoing){if(T.has(P))return[...T,P].join(" -> ");T.add(P);const p=this._findCycle(l,T);if(p)return p;T.delete(P)}}}t.Graph=R}),define(J[25],Y([0,1,6,9,13]),function(j,t,D,R,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationUpdateOverrides=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,b.createDecorator)("configurationService");function I(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof R.URI)}t.isConfigurationOverrides=I;function T(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||D.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof R.URI)}t.isConfigurationUpdateOverrides=T;var P;(function(u){u[u.USER=1]="USER",u[u.USER_LOCAL=2]="USER_LOCAL",u[u.USER_REMOTE=3]="USER_REMOTE",u[u.WORKSPACE=4]="WORKSPACE",u[u.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",u[u.DEFAULT=6]="DEFAULT",u[u.MEMORY=7]="MEMORY"})(P=t.ConfigurationTarget||(t.ConfigurationTarget={}));function l(u){switch(u){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=l;function p(u,f){const E=Object.create(null);for(let v in u)C(E,v,u[v],f);return E}t.toValuesTree=p;function C(u,f,E,v){const m=f.split("."),s=m.pop();let i=u;for(let r=0;r<m.length;r++){let e=m[r],n=i[e];switch(typeof n){case"undefined":n=i[e]=Object.create(null);break;case"object":break;default:v(`Ignoring ${f} as ${m.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}i=n}if(typeof i=="object"&&i!==null)try{i[s]=E}catch{v(`Ignoring ${f} as ${m.join(".")} is ${JSON.stringify(i)}`)}else v(`Ignoring ${f} as ${m.join(".")} is ${JSON.stringify(i)}`)}t.addToValueTree=C;function L(u,f){const E=f.split(".");d(u,E)}t.removeFromValueTree=L;function d(u,f){const E=f.shift();if(f.length===0){delete u[E];return}if(Object.keys(u).indexOf(E)!==-1){const v=u[E];typeof v=="object"&&!Array.isArray(v)&&(d(v,f),Object.keys(v).length===0&&delete u[E])}}function y(u,f,E){function v(i,r){let e=i;for(const n of r){if(typeof e!="object"||e===null)return;e=e[n]}return e}const m=f.split("."),s=v(u,m);return typeof s=="undefined"?E:s}t.getConfigurationValue=y;function w(u,f,E){Object.keys(f).forEach(v=>{v!=="__proto__"&&(v in u?D.isObject(u[v])&&D.isObject(f[v])?w(u[v],f[v],E):E&&(u[v]=f[v]):u[v]=f[v])})}t.merge=w;function g(u,f,E){const v=u.inspect(f),m=u.inspect(E);return typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:v.defaultValue}t.getMigratedSettingValue=g}),define(J[49],Y([0,1,13]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,D.createDecorator)("downloadService")}),define(J[20],Y([0,1,13]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,D.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,D.refineServiceDecorator)(t.IEnvironmentService)}),define(J[50],Y([0,1,17,8,82,16]),function(j,t,D,R,b,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function T(C,L,d,y,w,g){let u;try{await P(C,L,d,y,w,g)}catch(f){u=f}finally{u&&w.errorTransformer&&(u=w.errorTransformer(u)),typeof u!="undefined"&&d.error(u),d.end()}}t.readFileIntoStream=T;async function P(C,L,d,y,w,g){l(g);const u=await C.open(L,{create:!1});try{l(g);let f=0,E=0,v=w&&typeof w.length=="number"?w.length:void 0,m=D.VSBuffer.alloc(Math.min(w.bufferSize,typeof v=="number"?v:w.bufferSize)),s=w&&typeof w.position=="number"?w.position:0,i=0;do E=await C.read(u,s,m.buffer,i,m.byteLength-i),s+=E,i+=E,f+=E,typeof v=="number"&&(v-=E),i===m.byteLength&&(await d.write(y(m)),m=D.VSBuffer.alloc(Math.min(w.bufferSize,typeof v=="number"?v:w.bufferSize)),i=0);while(E>0&&(typeof v!="number"||v>0)&&l(g)&&p(f,w));if(i>0){let r=i;typeof v=="number"&&(r=Math.min(i,v)),d.write(y(m.slice(0,r)))}}catch(f){throw(0,I.ensureFileSystemProviderError)(f)}finally{await C.close(u)}}function l(C){if(C.isCancellationRequested)throw(0,R.canceled)();return!0}function p(C,L){if(L?.limits){if(typeof L.limits.memory=="number"&&C>L.limits.memory)throw(0,I.createFileSystemProviderError)((0,b.localize)(0,null),I.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof L.limits.size=="number"&&C>L.limits.size)throw(0,I.createFileSystemProviderError)((0,b.localize)(1,null),I.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[94],Y([0,1,18,7,2,12,134]),function(j,t,D,R,b,I,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcher=void 0;class P extends b.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new R.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=R.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(p){const C=this.normalizeRequests(p),L=C.filter(y=>{const w=this.watchers.get(y.path);return w?!(0,D.equals)(w.request.excludes,y.excludes):!0}),d=Array.from(this.watchers.values()).filter(({request:y})=>!C.find(w=>w.path===y.path&&(0,D.equals)(w.excludes,y.excludes))).map(({request:y})=>y.path);L.length&&this.trace(`Request to start watching: ${L.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"})`).join(",")}`),d.length&&this.trace(`Request to stop watching: ${d.join(",")}`);for(const y of d)this.stopWatching(y);for(const y of L)this.startWatching(y)}startWatching(p){const C=new T.NodeJSFileWatcherLibrary(p,d=>this._onDidChangeFile.fire(d),d=>this._onDidLogMessage.fire(d),this.verboseLogging),L={request:p,instance:C};this.watchers.set(p.path,L)}async stop(){for(const[p]of this.watchers)this.stopWatching(p);this.watchers.clear()}stopWatching(p){const C=this.watchers.get(p);C&&(this.watchers.delete(p),C.instance.dispose())}normalizeRequests(p){const C=new Map;for(const L of p){const d=I.isLinux?L.path:L.path.toLowerCase();C.set(d,L)}return Array.from(C.values())}async setVerboseLogging(p){this.verboseLogging=p;for(const[,C]of this.watchers)C.instance.setVerboseLogging(p)}trace(p){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(p)})}toMessage(p,C){return C?`[File Watcher (node.js)] ${p} (path: ${C.request.path})`:`[File Watcher (node.js)] ${p}`}}t.NodeJSWatcher=P}),define(J[95],Y([0,1,51,94]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcherClient=void 0;class b extends D.AbstractNonRecursiveWatcherClient{constructor(T,P,l){super(T,P,l);this.init()}createWatcher(){return new R.NodeJSWatcher}}t.NodeJSWatcherClient=b}),define(J[96],Y([0,1,11,46,71,51]),function(j,t,D,R,b,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UniversalWatcherClient=void 0;class T extends I.AbstractUniversalWatcherClient{constructor(l,p,C){super(l,p,C);this.init()}createWatcher(l){const p=l.add(new b.Client(D.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(p.onDidProcessExit(({code:C,signal:L})=>this.onError(`terminated by itself with code ${C}, signal: ${L}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(p.getChannel("watcher")))}}t.UniversalWatcherClient=T}),define(J[52],Y([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class D{constructor(...b){this._entries=new Map;for(let[I,T]of b)this.set(I,T)}set(b,I){const T=this._entries.get(b);return this._entries.set(b,I),T}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}t.ServiceCollection=D}),define(J[97],Y([0,1,3,8,40,93,13,52]),function(j,t,D,R,b,I,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Trace=t.InstantiationService=void 0;const l=!1;class p extends Error{constructor(w){super("cyclic dependency between services");this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class C{constructor(w=new P.ServiceCollection,g=!1,u){this._activeInstantiations=new Set,this._services=w,this._strict=g,this._parent=u,this._services.set(T.IInstantiationService,this)}createChild(w){return new C(w,this._strict,this)}invokeFunction(w,...g){let u=d.traceInvocation(w),f=!1;try{return w({get:v=>{if(f)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const m=this._getOrCreateServiceInstance(v,u);if(!m)throw new Error(`[invokeFunction] unknown service '${v}'`);return m}},...g)}finally{f=!0,u.stop()}}createInstance(w,...g){let u,f;return w instanceof b.SyncDescriptor?(u=d.traceCreation(w.ctor),f=this._createInstance(w.ctor,w.staticArguments.concat(g),u)):(u=d.traceCreation(w),f=this._createInstance(w,g,u)),u.stop(),f}_createInstance(w,g=[],u){let f=T._util.getServiceDependencies(w).sort((m,s)=>m.index-s.index),E=[];for(const m of f){let s=this._getOrCreateServiceInstance(m.id,u);s||this._throwIfStrict(`[createInstance] ${w.name} depends on UNKNOWN service ${m.id}.`,!1),E.push(s)}let v=f.length>0?f[0].index:g.length;if(g.length!==v){console.warn(`[createInstance] First service dependency of ${w.name} at position ${v+1} conflicts with ${g.length} static arguments`);let m=v-g.length;m>0?g=g.concat(new Array(m)):g=g.slice(0,v)}return new w(...[...g,...E])}_setServiceInstance(w,g){if(this._services.get(w)instanceof b.SyncDescriptor)this._services.set(w,g);else if(this._parent)this._parent._setServiceInstance(w,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(w){let g=this._services.get(w);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(w):g}_getOrCreateServiceInstance(w,g){let u=this._getServiceInstanceOrDescriptor(w);return u instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(w,u,g.branch(w,!0)):(g.branch(w,!1),u)}_safeCreateAndCacheServiceInstance(w,g,u){if(this._activeInstantiations.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this._activeInstantiations.add(w);try{return this._createAndCacheServiceInstance(w,g,u)}finally{this._activeInstantiations.delete(w)}}_createAndCacheServiceInstance(w,g,u){const f=new I.Graph(m=>m.id.toString());let E=0;const v=[{id:w,desc:g,_trace:u}];for(;v.length;){const m=v.pop();if(f.lookupOrInsertNode(m),E++>1e3)throw new p(f);for(let s of T._util.getServiceDependencies(m.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(s.id);if(i||this._throwIfStrict(`[createInstance] ${w} depends on ${s.id} which is NOT registered.`,!0),i instanceof b.SyncDescriptor){const r={id:s.id,desc:i,_trace:m._trace.branch(s.id,!0)};f.insertEdge(m,r),v.push(r)}}}for(;;){const m=f.roots();if(m.length===0){if(!f.isEmpty())throw new p(f);break}for(const{data:s}of m){if(this._getServiceInstanceOrDescriptor(s.id)instanceof b.SyncDescriptor){const r=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,r)}f.removeNode(s)}}return this._getServiceInstanceOrDescriptor(w)}_createServiceInstanceWithOwner(w,g,u=[],f,E){if(this._services.get(w)instanceof b.SyncDescriptor)return this._createServiceInstance(g,u,f,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(w,g,u,f,E);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(w,g=[],u,f){if(u){const E=new D.IdleValue(()=>this._createInstance(w,g,f));return new Proxy(Object.create(null),{get(v,m){if(m in v)return v[m];let s=E.value,i=s[m];return typeof i!="function"||(i=i.bind(s),v[m]=i),i},set(v,m,s){return E.value[m]=s,!0}})}else return this._createInstance(w,g,f)}_throwIfStrict(w,g){if(g&&console.warn(g),this._strict)throw new Error(w)}}t.InstantiationService=C;var L;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(L||(L={}));class d{constructor(w,g){this.type=w,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(w){return l?new d(1,w.name||w.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(w){return l?new d(0,w.name):d._None}branch(w,g){let u=new d(2,w.toString());return this._dep.push([w,g,u]),u}stop(){let w=Date.now()-this._start;d._totals+=w;let g=!1;function u(E,v){let m=[],s=new Array(E+1).join("	");for(const[i,r,e]of v._dep)if(r&&e){g=!0,m.push(`${s}CREATES -> ${i}`);let n=u(E+1,e);n&&m.push(n)}else m.push(`${s}uses -> ${i}`);return m.join(`
`)}let f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(w>2||g)&&console.log(f.join(`
`))}}t.Trace=d,d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(J[53],Y([0,1,13]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,D.createDecorator)("localizationsService");function R(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const I of b.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}t.isValidLocalization=R}),define(J[14],Y([0,1,28,7,2,12,13]),function(j,t,D,R,b,I,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.format=t.log=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,T.createDecorator)("logService"),t.ILoggerService=(0,T.createDecorator)("loggerService");function P(){return new Date().toISOString()}var l;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(l=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=l.Info;function p(r,e,n){switch(e){case l.Trace:r.trace(n);break;case l.Debug:r.debug(n);break;case l.Info:r.info(n);break;case l.Warning:r.warn(n);break;case l.Error:r.error(n);break;case l.Critical:r.critical(n);break;default:throw new Error("Invalid log level")}}t.log=p;function C(r){let e="";for(let n=0;n<r.length;n++){let o=r[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}e+=(n>0?" ":"")+o}return e}t.format=C;class L extends b.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=L;class d extends L{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...n){this.checkLogLevel(l.Trace)&&this.log(l.Trace,C([e,...n]))}debug(e,...n){this.checkLogLevel(l.Debug)&&this.log(l.Debug,C([e,...n]))}info(e,...n){this.checkLogLevel(l.Info)&&this.log(l.Info,C([e,...n]))}warn(e,...n){this.checkLogLevel(l.Warning)&&this.log(l.Warning,C([e,...n]))}error(e,...n){if(this.checkLogLevel(l.Error))if(e instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=e.stack,this.log(l.Error,C(o))}else this.log(l.Error,C([e,...n]))}critical(e,...n){this.checkLogLevel(l.Critical)&&this.log(l.Critical,C([e,...n]))}flush(){}}t.AbstractMessageLogger=d;class y extends L{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!I.isWindows}trace(e,...n){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,e,...n):console.log(`[main ${P()}]`,e,...n))}debug(e,...n){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,e,...n):console.log(`[main ${P()}]`,e,...n))}info(e,...n){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,e,...n):console.log(`[main ${P()}]`,e,...n))}warn(e,...n){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,e,...n):console.warn(`[main ${P()}]`,e,...n))}error(e,...n){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,e,...n):console.error(`[main ${P()}]`,e,...n))}critical(e,...n){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,e,...n):console.error(`[main ${P()}]`,e,...n))}dispose(){}flush(){}}t.ConsoleMainLogger=y;class w extends L{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...n){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",e,...n)}debug(e,...n){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...n)}info(e,...n){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",e,...n)}warn(e,...n){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",e,...n)}error(e,...n){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",e,...n)}critical(e,...n){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...n)}dispose(){}flush(){}}t.ConsoleLogger=w;class g extends L{constructor(e,n=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(n)}trace(e,...n){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(e),...n])}debug(e,...n){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(e),...n])}info(e,...n){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(e),...n])}warn(e,...n){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(e),...n])}error(e,...n){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(e),...n])}critical(e,...n){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(e),...n])}extractMessage(e){return typeof e=="string"?e:(0,D.toErrorMessage)(e,this.getLevel()<=l.Trace)}dispose(){}flush(){}}t.AdapterLogger=g;class u extends L{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const n of this.logServices)n.setLevel(e);super.setLevel(e)}trace(e,...n){for(const o of this.logServices)o.trace(e,...n)}debug(e,...n){for(const o of this.logServices)o.debug(e,...n)}info(e,...n){for(const o of this.logServices)o.info(e,...n)}warn(e,...n){for(const o of this.logServices)o.warn(e,...n)}error(e,...n){for(const o of this.logServices)o.error(e,...n)}critical(e,...n){for(const o of this.logServices)o.critical(e,...n)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=u;class f extends b.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...n){this.logger.trace(e,...n)}debug(e,...n){this.logger.debug(e,...n)}info(e,...n){this.logger.info(e,...n)}warn(e,...n){this.logger.warn(e,...n)}error(e,...n){this.logger.error(e,...n)}critical(e,...n){this.logger.critical(e,...n)}flush(){this.logger.flush()}}t.LogService=f;class E extends b.Disposable{constructor(e,n){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(o))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,n){let o=this.loggers.get(e.toString());return o||(o=this.doCreateLogger(e,n?.always?l.Trace:this.logLevel,n),this.loggers.set(e.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=E;class v{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(e){}getLevel(){return l.Info}trace(e,...n){}debug(e,...n){}info(e,...n){}warn(e,...n){}error(e,...n){}critical(e,...n){}dispose(){}flush(){}}t.NullLogService=v;function m(r){if(r.verbose)return l.Trace;if(typeof r.logLevel=="string"){const e=s(r.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=m;function s(r){switch(r){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}t.parseLogLevel=s;function i(r){switch(r){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}t.LogLevelToString=i});var oe=this&&this.__param||function(j,t){return function(D,R){t(D,R,j)}};define(J[98],Y([0,1,39,3,28,7,2,11,10,15,20,14]),function(j,t,D,R,b,I,T,P,l,p,C,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let d=class extends T.Disposable{constructor(w,g){super();this.environmentService=w,this.logService=g,this.processesLimiter=new R.Limiter(5)}async postUninstall(w){const g=this.parseScript(w,"uninstall");return g&&(this.logService.info(w.identifier.id,w.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(g.script,"uninstall",g.args,!0,w).then(()=>this.logService.info(w.identifier.id,w.manifest.version,"Finished running post uninstall script"),u=>this.logService.error(w.identifier.id,w.manifest.version,`Failed to run post uninstall script: ${u}`)))),p.Promises.rm(this.getExtensionStoragePath(w)).then(void 0,u=>this.logService.error("Error while removing extension storage path",u))}parseScript(w,g){const u=`vscode:${g}`;if(w.location.scheme===P.Schemas.file&&w.manifest&&w.manifest.scripts&&typeof w.manifest.scripts[u]=="string"){const f=w.manifest.scripts[u].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.logService.warn(w.identifier.id,w.manifest.version,`${u} should be a node script`),null):{script:(0,l.join)(w.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}runLifecycleHook(w,g,u,f,E){return new Promise((v,m)=>{const s=this.start(w,g,u,E);let i;const r=e=>{i&&(clearTimeout(i),i=null),e?m(e):v(void 0)};s.on("error",e=>{r((0,b.toErrorMessage)(e)||"Unknown")}),s.on("exit",(e,n)=>{r(e?`post-${g} process exited with code ${e}`:void 0)}),f&&(i=setTimeout(()=>{i=null,s.kill(),m("timed out")},5e3))})}start(w,g,u,f){const E={silent:!0,execArgv:void 0},v=(0,D.fork)(w,[`--type=extension-post-${g}`,...u],E);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const m=I.Event.fromNodeEventEmitter(v.stdout,"data"),s=I.Event.fromNodeEventEmitter(v.stderr,"data");m(e=>this.logService.info(f.identifier.id,f.manifest.version,`post-${g}`,e)),s(e=>this.logService.error(f.identifier.id,f.manifest.version,`post-${g}`,e));const i=I.Event.any(I.Event.map(m,e=>({data:`%c${e}`,format:[""]})),I.Event.map(s,e=>({data:`%c${e}`,format:["color: red"]})));return I.Event.debounce(i,(e,n)=>e?{data:e.data+n.data,format:[...e.format,...n.format]}:{data:n.data,format:n.format},100)(e=>{console.group(f.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),v}getExtensionStoragePath(w){return(0,l.join)(this.environmentService.globalStorageHome.fsPath,w.identifier.id.toLowerCase())}};d=ge([oe(0,C.IEnvironmentService),oe(1,L.ILogService)],d),t.ExtensionsLifecycle=d}),define(J[99],Y([0,1,18,3,8,7,2,10,51,14]),function(j,t,D,R,b,I,T,P,l,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractDiskFileSystemProvider=void 0;class C extends T.Disposable{constructor(d,y){super();this.logService=d,this.options=y,this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new I.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new R.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new R.ThrottledDelayer(0))}watch(d,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(d,y):this.watchNonRecursive(d,y)}watchUniversal(d,y){const w={path:this.toFilePath(d),excludes:y.excludes,recursive:y.recursive},g=(0,D.insert)(this.universalPathsToWatch,w);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{g(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(d=>(0,b.onUnexpectedError)(d))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,l.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===p.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)})));const d=this.options?.watcher?.recursive?.usePolling;if(d===!0)for(const y of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const y of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(y)&&d.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(d,y){const w={path:this.toFilePath(d),excludes:y.excludes,recursive:!1},g=(0,D.insert)(this.nonRecursivePathsToWatch,w);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{g(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(d=>(0,b.onUnexpectedError)(d))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(d=>this._onDidChangeFile.fire((0,l.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===p.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(d){d.type==="error"&&this._onDidWatchError.fire(d.message),this.logService[d.type](d.message)}toFilePath(d){return(0,P.normalize)(d.fsPath)}}t.AbstractDiskFileSystemProvider=C}),define(J[100],Y([0,1,18,3,17,24,7,59,135,2,54,11,101,19,38,81,16,50,14]),function(j,t,D,R,b,I,T,P,l,p,C,L,d,y,w,g,u,f,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let v=class extends p.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new R.ResourceQueue)}registerProvider(s,i){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${s}`);const r=new p.DisposableStore;return this.provider.set(s,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:i}),r.add(i.onDidChangeFile(e=>this._onDidFilesChange.fire(new u.FileChangesEvent(e,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&r.add(i.onDidWatchError(e=>this._onDidWatchError.fire(new Error(e)))),r.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:s}))),(0,p.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:i}),this.provider.delete(s),(0,p.dispose)(r)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(r){i.push(r)}}),!this.provider.has(s)&&await R.Promises.settled(i)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,i){const r=this.provider.get(s.scheme);return!!(r&&r.capabilities&i)}listCapabilities(){return l.Iterable.map(this.provider,([s,i])=>({scheme:s,capabilities:i.capabilities}))}async withProvider(s){if(!(0,y.isAbsolutePath)(s))throw new u.FileOperationError((0,g.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const i=this.provider.get(s.scheme);if(!i){const r=new Error;throw r.name="ENOPRO",r.message=(0,g.localize)(1,null,s.toString()),r}return i}async withReadProvider(s){const i=await this.withProvider(s);if((0,u.hasOpenReadWriteCloseCapability)(i)||(0,u.hasReadWriteCapability)(i)||(0,u.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const i=await this.withProvider(s);if((0,u.hasOpenReadWriteCloseCapability)(i)||(0,u.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,i){try{return await this.doResolveFile(s,i)}catch(r){throw(0,u.toFileSystemProviderErrorCode)(r)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,g.localize)(2,null,this.resourceForError(s)),1):(0,u.ensureFileSystemProviderError)(r)}}async doResolveFile(s,i){const r=await this.withProvider(s),e=this.isPathCaseSensitive(r),n=i?.resolveTo,o=i?.resolveSingleChildDescendants,a=i?.resolveMetadata,c=await r.stat(s);let h;return this.toFileStat(r,s,c,void 0,!!a,(S,O)=>(h||(h=C.TernarySearchTree.forUris(()=>!e),h.set(s,!0),n&&h.fill(!0,n)),h.get(S.resource)||h.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&o?O===1:!1))}async toFileStat(s,i,r,e,n,o){const{providerExtUri:a}=this.getExtUri(s),c={resource:i,name:a.basename(i),isFile:(r.type&u.FileType.File)!=0,isDirectory:(r.type&u.FileType.Directory)!=0,isSymbolicLink:(r.type&u.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&u.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,u.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(c.isDirectory&&o(c,e)){try{const h=await s.readdir(i),S=await R.Promises.settled(h.map(async([O,M])=>{try{const _=a.joinPath(i,O),X=n?await s.stat(_):{type:M};return await this.toFileStat(s,_,X,h.length,n,o)}catch(_){return this.logService.trace(_),null}}));c.children=(0,D.coalesce)(S)}catch(h){this.logService.trace(h),c.children=[]}return c}return c}async resolveAll(s){return R.Promises.settled(s.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(s){const i=await this.withProvider(s),r=await i.stat(s);return this.toFileStat(i,s,r,void 0,!0,()=>!1)}async exists(s){const i=await this.withProvider(s);try{return!!await i.stat(s)}catch{return!1}}async canCreateFile(s,i){try{await this.doValidateCreateFile(s,i)}catch(r){return r}return!0}async doValidateCreateFile(s,i){if(!i?.overwrite&&await this.exists(s))throw new u.FileOperationError((0,g.localize)(3,null,this.resourceForError(s)),3,i)}async createFile(s,i=b.VSBuffer.fromString(""),r){await this.doValidateCreateFile(s,r);const e=await this.writeFile(s,i);return this._onDidRunOperation.fire(new u.FileOperationEvent(s,0,e)),e}async writeFile(s,i,r){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:n}=this.getExtUri(e);try{await this.validateWriteFile(e,s,r)||await this.mkdirp(e,n.dirname(s));let a;if((0,u.hasReadWriteCapability)(e)&&!(i instanceof b.VSBuffer))if((0,w.isReadableStream)(i)){const c=await(0,w.peekStream)(i,3);c.ended?a=b.VSBuffer.concat(c.buffer):a=c}else a=(0,w.peekReadable)(i,c=>b.VSBuffer.concat(c),3);else a=i;!(0,u.hasOpenReadWriteCloseCapability)(e)||(0,u.hasReadWriteCapability)(e)&&a instanceof b.VSBuffer?await this.doWriteUnbuffered(e,s,r,a):await this.doWriteBuffered(e,s,r,a instanceof b.VSBuffer?(0,b.bufferToReadable)(a):a),this._onDidRunOperation.fire(new u.FileOperationEvent(s,4))}catch(o){throw new u.FileOperationError((0,g.localize)(4,null,this.resourceForError(s),(0,u.ensureFileSystemProviderError)(o).toString()),(0,u.toFileOperationResult)(o),r)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,i,r){if(!!r?.unlock&&!(s.capabilities&8192))throw new Error((0,g.localize)(5,null,this.resourceForError(i)));let n;try{n=await s.stat(i)}catch{return}if((n.type&u.FileType.Directory)!=0)throw new u.FileOperationError((0,g.localize)(6,null,this.resourceForError(i)),0,r);if(this.throwIfFileIsReadonly(i,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==u.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,u.etag)({mtime:r.mtime,size:n.size}))throw new u.FileOperationError((0,g.localize)(7,null),3,r);return n}async readFile(s,i,r){const e=await this.withReadProvider(s);return i?.atomic?this.doReadFileAtomic(e,s,i,r):this.doReadFile(e,s,i,r)}async doReadFileAtomic(s,i,r,e){return new Promise((n,o)=>{this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(s,i,r,e);n(a)}catch(a){o(a)}})})}async doReadFile(s,i,r,e){const n=await this.doReadFileStream(s,i,{...r,preferUnbuffered:!0},e);return{...n,value:await(0,b.streamToBuffer)(n.value)}}async readFileStream(s,i,r){const e=await this.withReadProvider(s);return this.doReadFileStream(e,s,i,r)}async doReadFileStream(s,i,r,e){const n=new I.CancellationTokenSource(e),o=this.validateReadFile(i,r).then(c=>c,c=>{throw n.cancel(),c});let a;try{return typeof r?.etag=="string"&&r.etag!==u.ETAG_DISABLED&&await o,r?.atomic&&(0,u.hasFileAtomicReadCapability)(s)||!((0,u.hasOpenReadWriteCloseCapability)(s)||(0,u.hasFileReadStreamCapability)(s))||(0,u.hasReadWriteCapability)(s)&&r?.preferUnbuffered?a=this.readFileUnbuffered(s,i,r):(0,u.hasFileReadStreamCapability)(s)?a=this.readFileStreamed(s,i,n.token,r):a=this.readFileBuffered(s,i,n.token,r),{...await o,value:a}}catch(c){a&&await(0,w.consumeStream)(a);const h=(0,g.localize)(8,null,this.resourceForError(i),(0,u.ensureFileSystemProviderError)(c).toString());throw c instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(h,c.stat,r):new u.FileOperationError(h,(0,u.toFileOperationResult)(c),r)}}readFileStreamed(s,i,r,e=Object.create(null)){const n=s.readFileStream(i,e,r);return(0,w.transform)(n,{data:o=>o instanceof b.VSBuffer?o:b.VSBuffer.wrap(o),error:o=>new u.FileOperationError((0,g.localize)(9,null,this.resourceForError(i),(0,u.ensureFileSystemProviderError)(o).toString()),(0,u.toFileOperationResult)(o),e)},o=>b.VSBuffer.concat(o))}readFileBuffered(s,i,r,e=Object.create(null)){const n=(0,b.newWriteableBufferStream)();return(0,f.readFileIntoStream)(s,i,n,o=>o,{...e,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new u.FileOperationError((0,g.localize)(10,null,this.resourceForError(i),(0,u.ensureFileSystemProviderError)(o).toString()),(0,u.toFileOperationResult)(o),e)},r),n}readFileUnbuffered(s,i,r){const e=(0,w.newWriteableStream)(n=>b.VSBuffer.concat(n));return(async()=>{try{let n;r?.atomic&&(0,u.hasFileAtomicReadCapability)(s)?n=await s.readFile(i,{atomic:!0}):n=await s.readFile(i),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(i,n.byteLength,r),e.end(b.VSBuffer.wrap(n))}catch(n){e.error(n),e.end()}})(),e}async validateReadFile(s,i){const r=await this.resolve(s,{resolveMetadata:!0});if(r.isDirectory)throw new u.FileOperationError((0,g.localize)(11,null,this.resourceForError(s)),0,i);if(typeof i?.etag=="string"&&i.etag!==u.ETAG_DISABLED&&i.etag===r.etag)throw new u.NotModifiedSinceFileOperationError((0,g.localize)(12,null),r,i);return this.validateReadFileLimits(s,r.size,i),r}validateReadFileLimits(s,i,r){if(r?.limits){let e;if(typeof r.limits.memory=="number"&&i>r.limits.memory&&(e=9),typeof r.limits.size=="number"&&i>r.limits.size&&(e=7),typeof e=="number")throw new u.FileOperationError((0,g.localize)(13,null,this.resourceForError(s)),e)}}async canMove(s,i,r){return this.doCanMoveCopy(s,i,"move",r)}async canCopy(s,i,r){return this.doCanMoveCopy(s,i,"copy",r)}async doCanMoveCopy(s,i,r,e){if(s.toString()!==i.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(n,s,o,i,r,e)}catch(n){return n}return!0}async move(s,i,r){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(e,s,n,i,"move",!!r),a=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(s,o==="move"?2:3,a)),a}async copy(s,i,r){const e=await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(e,s,n,i,"copy",!!r),a=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(s,o==="copy"?3:2,a)),a}async doMoveCopy(s,i,r,e,n,o){if(i.toString()===e.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(s,i,r,e,n,o);if(a&&!c&&o&&await this.del(e,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(e)),n==="copy"){if(s===r&&(0,u.hasFileFolderCopyCapability)(s))await s.copy(i,e,{overwrite:o});else{const h=await this.resolve(i);h.isDirectory?await this.doCopyFolder(s,h,r,e):await this.doCopyFile(s,i,r,e)}return n}else return s===r?(await s.rename(i,e,{overwrite:o}),n):(await this.doMoveCopy(s,i,r,e,"copy",o),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(s,i,r,e){if((0,u.hasOpenReadWriteCloseCapability)(s)&&(0,u.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(s,i,r,e);if((0,u.hasOpenReadWriteCloseCapability)(s)&&(0,u.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(s,i,r,e);if((0,u.hasReadWriteCapability)(s)&&(0,u.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(s,i,r,e);if((0,u.hasReadWriteCapability)(s)&&(0,u.hasReadWriteCapability)(r))return this.doPipeUnbuffered(s,i,r,e)}async doCopyFolder(s,i,r,e){await r.mkdir(e),Array.isArray(i.children)&&await R.Promises.settled(i.children.map(async n=>{const o=this.getExtUri(r).providerExtUri.joinPath(e,n.name);return n.isDirectory?this.doCopyFolder(s,await this.resolve(n.resource),r,o):this.doCopyFile(s,n.resource,r,o)}))}async doValidateMoveCopy(s,i,r,e,n,o){let a=!1;if(s===r){const{providerExtUri:h,isPathCaseSensitive:S}=this.getExtUri(s);if(S||(a=h.isEqual(i,e)),a&&n==="copy")throw new Error((0,g.localize)(14,null,this.resourceForError(i),this.resourceForError(e)));if(!a&&h.isEqualOrParent(e,i))throw new Error((0,g.localize)(15,null,this.resourceForError(i),this.resourceForError(e)))}const c=await this.exists(e);if(c&&!a){if(!o)throw new u.FileOperationError((0,g.localize)(16,null,this.resourceForError(i),this.resourceForError(e)),4);if(s===r){const{providerExtUri:h}=this.getExtUri(s);if(h.isEqualOrParent(i,e))throw new Error((0,g.localize)(17,null,this.resourceForError(i),this.resourceForError(e)))}}return{exists:c,isSameResourceWithDifferentPathCase:a}}getExtUri(s){const i=this.isPathCaseSensitive(s);return{providerExtUri:i?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(i,s);const r=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(s,0,r)),r}async mkdirp(s,i){const r=[],{providerExtUri:e}=this.getExtUri(s);for(;!e.isEqual(i,e.dirname(i));)try{if(((await s.stat(i)).type&u.FileType.Directory)==0)throw new Error((0,g.localize)(18,null,this.resourceForError(i)));break}catch(n){if((0,u.toFileSystemProviderErrorCode)(n)!==u.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(e.basename(i)),i=e.dirname(i)}for(let n=r.length-1;n>=0;n--){i=e.joinPath(i,r[n]);try{await s.mkdir(i)}catch(o){if((0,u.toFileSystemProviderErrorCode)(o)!==u.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,i){try{await this.doValidateDelete(s,i)}catch(r){return r}return!0}async doValidateDelete(s,i){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!i?.useTrash&&!(r.capabilities&4096))throw new Error((0,g.localize)(19,null,this.resourceForError(s)));let n;try{n=await r.stat(s)}catch{}if(n)this.throwIfFileIsReadonly(s,n);else throw new u.FileOperationError((0,g.localize)(20,null,this.resourceForError(s)),1);if(!!!i?.recursive){const a=await this.resolve(s);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,g.localize)(21,null,this.resourceForError(s)))}return r}async del(s,i){const r=await this.doValidateDelete(s,i),e=!!i?.useTrash,n=!!i?.recursive;await r.delete(s,{recursive:n,useTrash:e}),this._onDidRunOperation.fire(new u.FileOperationEvent(s,1))}watch(s,i={recursive:!1,excludes:[]}){const r=new p.DisposableStore;let e=!1,n=()=>{e=!0};return r.add((0,p.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(s,i);e?(0,p.dispose)(o):n=()=>(0,p.dispose)(o)}catch(o){this.logService.error(o)}})(),r}async doWatch(s,i){const r=await this.withProvider(s),e=(0,P.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(s),i]);let n=this.activeWatchers.get(e);return n||(n={count:0,disposable:r.watch(s,i)},this.activeWatchers.set(e,n)),n.count+=1,(0,p.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,p.dispose)(n.disposable),this.activeWatchers.delete(e)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,p.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,i,r,e){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(async()=>{const n=await s.open(i,{create:!0,unlock:r?.unlock??!1});try{(0,w.isReadableStream)(e)||(0,w.isReadableBufferedStream)(e)?await this.doWriteStreamBufferedQueued(s,n,e):await this.doWriteReadableBufferedQueued(s,n,e)}catch(o){throw(0,u.ensureFileSystemProviderError)(o)}finally{await s.close(n)}})}async doWriteStreamBufferedQueued(s,i,r){let e=0,n;if((0,w.isReadableBufferedStream)(r)){if(r.buffer.length>0){const o=b.VSBuffer.concat(r.buffer);await this.doWriteBuffer(s,i,o,o.byteLength,e,0),e+=o.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((o,a)=>{(0,w.listenStream)(n,{onData:async c=>{n.pause();try{await this.doWriteBuffer(s,i,c,c.byteLength,e,0)}catch(h){return a(h)}e+=c.byteLength,setTimeout(()=>n.resume())},onError:c=>a(c),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,i,r){let e=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(s,i,n,n.byteLength,e,0),e+=n.byteLength}async doWriteBuffer(s,i,r,e,n,o){let a=0;for(;a<e;)a+=await s.write(i,n+a,r.buffer,o+a,e-a)}async doWriteUnbuffered(s,i,r,e){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,i,r,e))}async doWriteUnbufferedQueued(s,i,r,e){let n;e instanceof b.VSBuffer?n=e:(0,w.isReadableStream)(e)?n=await(0,b.streamToBuffer)(e):(0,w.isReadableBufferedStream)(e)?n=await(0,b.bufferedStreamToBuffer)(e):n=(0,b.readableToBuffer)(e),await s.writeFile(i,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(s,i,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,i,r,e))}async doPipeBufferedQueued(s,i,r,e){let n,o;try{n=await s.open(i,{create:!1}),o=await r.open(e,{create:!0,unlock:!1});const a=b.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,h=0,S=0;do S=await s.read(n,c,a.buffer,h,a.byteLength-h),await this.doWriteBuffer(r,o,a,S,c,h),c+=S,h+=S,h===a.byteLength&&(h=0);while(S>0)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await R.Promises.settled([typeof n=="number"?s.close(n):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,i,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,i,r,e))}async doPipeUnbufferedQueued(s,i,r,e){return r.writeFile(e,await s.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,i,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,i,r,e))}async doPipeUnbufferedToBufferedQueued(s,i,r,e){const n=await r.open(e,{create:!0,unlock:!1});try{const o=await s.readFile(i);await this.doWriteBuffer(r,n,b.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,u.ensureFileSystemProviderError)(o)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(s,i,r,e){const n=await(0,b.streamToBuffer)(this.readFileBuffered(s,i,I.CancellationToken.None));await this.doWriteUnbuffered(r,e,void 0,n)}throwIfFileSystemIsReadonly(s,i){if(s.capabilities&2048)throw new u.FileOperationError((0,g.localize)(22,null,this.resourceForError(i)),6);return s}throwIfFileIsReadonly(s,i){if((i.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,g.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===L.Schemas.file?s.fsPath:s.toString(!0)}};v=ge([oe(0,E.ILogService)],v),t.FileService=v}),define(J[102],Y([0,1,103,136,3,54,17,7,45,2,10,12,19,38,15,83,16,50,99,28,96,95]),function(j,t,D,R,b,I,T,P,l,p,C,L,d,y,w,g,u,f,E,v,m,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,v.toErrorMessage)(r)}`)}})();class i extends E.AbstractDiskFileSystemProvider{constructor(e,n){super(e,n);this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new I.ResourceMap(o=>d.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,L.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:n,symbolicLink:o}=await w.SymlinkSupport.stat(this.toFilePath(e));return{type:this.toType(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(e){try{const n=await w.Promises.readdir(this.toFilePath(e),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async a=>{try{let c;a.isSymbolicLink()?c=(await this.stat((0,d.joinPath)(e,a.name))).type:c=this.toType(a),o.push([a.name,c])}catch(c){this.logService.trace(c)}})),o}catch(n){throw this.toFileSystemProviderError(n)}}toType(e,n){let o;return n?.dangling?o=u.FileType.Unknown:e.isFile()?o=u.FileType.File:e.isDirectory()?o=u.FileType.Directory:o=u.FileType.Unknown,n&&(o|=u.FileType.SymbolicLink),o}async createResourceLock(e){const n=this.toFilePath(e);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.resourceLocks.get(e);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const a=new b.Barrier;return this.resourceLocks.set(e,a),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,p.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(e)===a&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(e)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(e,n){let o;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(e)})`),o=await this.createResourceLock(e));const a=this.toFilePath(e);return await w.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{o?.dispose()}}readFileStream(e,n,o){const a=(0,y.newWriteableStream)(c=>T.VSBuffer.concat(c.map(h=>T.VSBuffer.wrap(h))).buffer);return(0,f.readFileIntoStream)(this,e,a,c=>c.buffer,{...n,bufferSize:256*1024},o),a}async writeFile(e,n,o){let a;try{const c=this.toFilePath(e);if(!o.create||!o.overwrite){if(await w.Promises.exists(c)){if(!o.overwrite)throw(0,u.createFileSystemProviderError)((0,g.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,u.createFileSystemProviderError)((0,g.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(e,{create:!0,unlock:o.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(e,c)}finally{typeof a=="number"&&await this.close(a)}}async open(e,n){const o=this.toFilePath(e);let a;(0,u.isFileOpenForWriteOptions)(n)&&(a=await this.createResourceLock(e));let c;try{if((0,u.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:S}=await w.SymlinkSupport.stat(o);S.mode&128||await w.Promises.chmod(o,S.mode|128)}catch(S){this.logService.trace(S)}let h;if((0,u.isFileOpenForWriteOptions)(n)){if(L.isWindows)try{await w.Promises.truncate(o,0),h="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}h||(h="w")}else h="r";c=await w.Promises.open(o,h)}catch(h){throw a?.dispose(),(0,u.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(e,h):this.toFileSystemProviderError(h)}if(this.mapHandleToPos.set(c,0),(0,u.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(c,e),a){const h=this.mapHandleToLock.get(c);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${o})`),this.mapHandleToLock.set(c,a),h&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${o})`),h.dispose())}return c}async close(e){const n=this.mapHandleToLock.get(e);try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&this.canFlush)try{await w.Promises.fdatasync(e)}catch(o){this.canFlush=!1,this.logService.error(o)}return await w.Promises.close(e)}catch(o){throw this.toFileSystemProviderError(o)}finally{n&&(this.mapHandleToLock.get(e)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${e}`),this.mapHandleToLock.delete(e)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${e}`),n.dispose())}}async read(e,n,o,a,c){const h=this.normalizePos(e,n);let S=null;try{S=(await w.Promises.read(e,o,a,c,h)).bytesRead}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(e,h,S)}return S}normalizePos(e,n){return n===this.mapHandleToPos.get(e)?null:n}updatePos(e,n,o){const a=this.mapHandleToPos.get(e);typeof a=="number"&&(typeof n=="number"||(typeof o=="number"?this.mapHandleToPos.set(e,a+o):this.mapHandleToPos.delete(e)))}async write(e,n,o,a,c){return(0,b.retry)(()=>this.doWrite(e,n,o,a,c),100,3)}async doWrite(e,n,o,a,c){const h=this.normalizePos(e,n);let S=null;try{S=(await w.Promises.write(e,o,a,c,h)).bytesWritten}catch(O){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(e),O)}finally{this.updatePos(e,h,S)}return S}async mkdir(e){try{await w.Promises.mkdir(this.toFilePath(e))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(e,n){try{const o=this.toFilePath(e);n.recursive?await w.Promises.rm(o,w.RimRafMode.MOVE):await w.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(e,n,o){const a=this.toFilePath(e),c=this.toFilePath(n);if(a!==c)try{await this.validateTargetDeleted(e,n,"move",o.overwrite),await w.Promises.move(a,c)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,g.localize)(2,null,(0,C.basename)(a),(0,C.basename)((0,C.dirname)(c)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(e,n,o){const a=this.toFilePath(e),c=this.toFilePath(n);if(a!==c)try{await this.validateTargetDeleted(e,n,"copy",o.overwrite),await w.Promises.copy(a,c,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,g.localize)(3,null,(0,C.basename)(a),(0,C.basename)((0,C.dirname)(c)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(e,n,o,a){const c=this.toFilePath(e),h=this.toFilePath(n);let S=!1;if(!!(this.capabilities&1024)||(S=(0,l.isEqual)(c,h,!0)),S&&o==="copy")throw(0,u.createFileSystemProviderError)((0,g.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!S&&await w.Promises.exists(h)){if(!a)throw(0,u.createFileSystemProviderError)((0,g.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}createUniversalWatcher(e,n,o){return new m.UniversalWatcherClient(a=>e(a),a=>n(a),o)}createNonRecursiveWatcher(e,n,o){return new s.NodeJSWatcherClient(a=>e(a),a=>n(a),o)}toFileSystemProviderError(e){if(e instanceof u.FileSystemProviderError)return e;let n;switch(e.code){case"ENOENT":n=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=u.FileSystemProviderErrorCode.NoPermissions;break;default:n=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(e,n)}async toFileSystemProviderWriteError(e,n){let o=this.toFileSystemProviderError(n);if(e&&o.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await w.SymlinkSupport.stat(this.toFilePath(e));a.mode&128||(o=(0,u.createFileSystemProviderError)(n,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return o}}t.DiskFileSystemProvider=i}),define(J[104],Y([0,1,16,14]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=void 0;async function b(P,l,p,C,L){try{const d=await new Promise((w,g)=>{j(["spdlog"],w,g)});d.setFlushOn(R.LogLevel.Trace);const y=await d.createAsyncRotatingLogger(P,l,p,C);return L&&y.clearFormatters(),y}catch(d){console.error(d)}return null}function I(P,l,p){switch(l){case R.LogLevel.Trace:P.trace(p);break;case R.LogLevel.Debug:P.debug(p);break;case R.LogLevel.Info:P.info(p);break;case R.LogLevel.Warning:P.warn(p);break;case R.LogLevel.Error:P.error(p);break;case R.LogLevel.Critical:P.critical(p);break;default:throw new Error("Invalid log level")}}class T extends R.AbstractMessageLogger{constructor(l,p,C,L,d){super();this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(l,p,C,L),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}async _createSpdLogLogger(l,p,C,L){const d=C?6:1,y=30/d*D.ByteSize.MB,w=await b(l,p,y,d,L);if(w){this._logger=w,this._logger.setLevel(this.getLevel());for(const{level:g,message:u}of this.buffer)I(this._logger,g,u);this.buffer=[]}}log(l,p){this._logger?I(this._logger,l,p):this.getLevel()<=l&&this.buffer.push({level:l,message:p})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=T}),define(J[32],Y([0,1,13]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.productSchemaId=t.IProductService=void 0,t.IProductService=(0,D.createDecorator)("productService"),t.productSchemaId="vscode://schemas/vscode-product"}),define(J[30],Y([0,1,55,6]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class b{constructor(){this.data=new Map}add(T,P){D.ok(R.isString(T)),D.ok(R.isObject(P)),D.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,P)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}t.Registry=new b}),define(J[105],Y([0,1,7,30]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function b(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class I{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,p){this.schemasById[b(l)]=p,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new I;R.Registry.add(t.Extensions.JSONContribution,T)}),define(J[34],Y([0,1,18,7,6,73,105,30]),function(j,t,D,R,b,I,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.keyFromOverrideIdentifiers=t.overrideIdentifiersFromKey=t.OVERRIDE_PROPERTY_REGEX=t.OVERRIDE_PROPERTY_PATTERN=t.configurationDefaultsSchemaId=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var l;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(l=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var p;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",t.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=P.Registry.as(T.Extensions.JSONContribution);class L{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},C.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(s,i=!0){this.registerConfigurations([s],i)}registerConfigurations(s,i=!0){const r=this.doRegisterConfigurations(s,i);C.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(s){const i=this.doDeregisterConfigurations(s);C.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}updateConfigurations({add:s,remove:i}){const r=[];r.push(...this.doDeregisterConfigurations(i)),r.push(...this.doRegisterConfigurations(s,!1)),C.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(r)})}registerDefaultConfigurations(s){const i=[],r=[];for(const{overrides:e,source:n}of s)for(const o in e)if(i.push(o),t.OVERRIDE_PROPERTY_REGEX.test(o)){const a={...this.configurationDefaultsOverrides.get(o)?.value||{},...e[o]};this.configurationDefaultsOverrides.set(o,{source:n,value:a});const c={type:"object",default:a,description:I.localize(1,null,o),$ref:t.resourceLanguageSettingsSchemaId,defaultDefaultValue:a,source:b.isString(n)?void 0:n};r.push(...w(o)),this.configurationProperties[o]=c,this.defaultLanguageConfigurationOverridesNode.properties[o]=c}else{this.configurationDefaultsOverrides.set(o,{value:e[o],source:n});const a=this.configurationProperties[o];a&&(this.updatePropertyDefaultValue(o,a),this.updateSchema(o,a))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const i=[];for(const{overrides:r,source:e}of s)for(const n in r){const o=this.configurationDefaultsOverrides.get(n),a=b.isString(e)?e:e?.id,c=b.isString(o?.source)?o?.source:o?.source?.id;if(a===c)if(i.push(n),this.configurationDefaultsOverrides.delete(n),t.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const h=this.configurationProperties[n];h&&(this.updatePropertyDefaultValue(n,h),this.updateSchema(n,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const i of s)this.overrideIdentifiers.add(i);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,i){const r=[];return s.forEach(e=>{r.push(...this.validateAndRegisterProperties(e,i,e.extensionInfo,e.restrictedProperties)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),r}doDeregisterConfigurations(s){const i=[],r=e=>{if(e.properties)for(const n in e.properties)i.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,e.properties[n]);e.allOf&&e.allOf.forEach(n=>r(n))};for(const e of s){r(e);const n=this.configurationContributors.indexOf(e);n!==-1&&this.configurationContributors.splice(n,1)}return i}validateAndRegisterProperties(s,i=!0,r,e,n=3){n=b.isUndefinedOrNull(s.scope)?n:s.scope;let o=[],a=s.properties;if(a)for(let h in a){if(i&&E(h)){delete a[h];continue}const S=a[h];if(S.source=r,S.defaultDefaultValue=a[h].default,this.updatePropertyDefaultValue(h,S),t.OVERRIDE_PROPERTY_REGEX.test(h)?S.scope=void 0:(S.scope=b.isUndefinedOrNull(S.scope)?n:S.scope,S.restricted=b.isUndefinedOrNull(S.restricted)?!!e?.includes(h):S.restricted),a[h].hasOwnProperty("included")&&!a[h].included){this.excludedConfigurationProperties[h]=a[h],delete a[h];continue}else this.configurationProperties[h]=a[h];!a[h].deprecationMessage&&a[h].markdownDeprecationMessage&&(a[h].deprecationMessage=a[h].markdownDeprecationMessage),o.push(h)}let c=s.allOf;if(c)for(let h of c)o.push(...this.validateAndRegisterProperties(h,i,r,e,n));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(s){const i=r=>{let e=r.properties;if(e)for(const o in e)this.updateSchema(o,e[o]);let n=r.allOf;n&&n.forEach(i)};i(s)}updateSchema(s,i){switch(t.allSettings.properties[s]=i,i.scope){case 1:t.applicationSettings.properties[s]=i;break;case 2:t.machineSettings.properties[s]=i;break;case 6:t.machineOverridableSettings.properties[s]=i;break;case 3:t.windowSettings.properties[s]=i;break;case 4:t.resourceSettings.properties[s]=i;break;case 5:t.resourceSettings.properties[s]=i,this.resourceLanguageSettingsSchema.properties[s]=i;break}}removeFromSchema(s,i){switch(delete t.allSettings.properties[s],i.scope){case 1:delete t.applicationSettings.properties[s];break;case 2:delete t.machineSettings.properties[s];break;case 6:delete t.machineOverridableSettings.properties[s];break;case 3:delete t.windowSettings.properties[s];break;case 4:case 5:delete t.resourceSettings.properties[s],delete this.resourceLanguageSettingsSchema.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const i=`[${s}]`,r={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(i,r),t.allSettings.properties[i]=r,t.applicationSettings.properties[i]=r,t.machineSettings.properties[i]=r,t.machineOverridableSettings.properties[i]=r,t.windowSettings.properties[i]=r,t.resourceSettings.properties[i]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const s={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:t.resourceLanguageSettingsSchemaId};t.allSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=s,t.applicationSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=s,t.machineSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=s,t.machineOverridableSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=s,t.windowSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=s,t.resourceSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=s,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,i){const r=this.configurationDefaultsOverrides.get(s);let e=r?.value,n=r?.source;b.isUndefined(e)&&(e=i.defaultDefaultValue,n=void 0),b.isUndefined(e)&&(e=u(i.type)),i.default=e,i.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",y=new RegExp(d,"g");t.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,t.OVERRIDE_PROPERTY_REGEX=new RegExp(t.OVERRIDE_PROPERTY_PATTERN);function w(m){const s=[];if(t.OVERRIDE_PROPERTY_REGEX.test(m)){let i=y.exec(m);for(;i?.length;){const r=i[1].trim();r&&s.push(r),i=y.exec(m)}}return(0,D.distinct)(s)}t.overrideIdentifiersFromKey=w;function g(m){return m.reduce((s,i)=>`${s}[${i}]`,"")}t.keyFromOverrideIdentifiers=g;function u(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=u;const f=new L;P.Registry.add(t.Extensions.Configuration,f);function E(m){return m.trim()?t.OVERRIDE_PROPERTY_REGEX.test(m)?I.localize(7,null,m):f.getConfigurationProperties()[m]!==void 0?I.localize(8,null,m):null:I.localize(6,null)}t.validateProperty=E;function v(){const m=[],s=f.getConfigurationProperties();for(const i of Object.keys(s))m.push([i,s[i].scope]);return m.push(["launch",4]),m.push(["task",4]),m}t.getScopes=v}),define(J[106],Y([0,1,18,7,56,2,54,22,6,9,25,34,30]),function(j,t,D,R,b,I,T,P,l,p,C,L,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class y{constructor(e={},n=[],o=[]){this._contents=e,this._keys=n,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,C.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,n){const o=this.getContentsForOverrideIdentifer(n);return o?e?(0,C.getConfigurationValue)(o,e):o:void 0}getKeysForOverrideIdentifier(e){const n=[];for(const o of this.overrides)o.identifiers.includes(e)&&n.push(...o.keys);return D.distinct(n)}getAllOverrideIdentifiers(){const e=[];for(const n of this.overrides)e.push(...n.identifiers);return D.distinct(e)}override(e){let n=this.overrideConfigurations.get(e);return n||(n=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,n)),n}merge(...e){const n=P.deepClone(this.contents),o=P.deepClone(this.overrides),a=[...this.keys];for(const c of e){this.mergeContents(n,c.contents);for(const h of c.overrides){const[S]=o.filter(O=>D.equals(O.identifiers,h.identifiers));S?(this.mergeContents(S.contents,h.contents),S.keys.push(...h.keys),S.keys=D.distinct(S.keys)):o.push(P.deepClone(h))}for(const h of c.keys)a.indexOf(h)===-1&&a.push(h)}return new y(n,a,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let o={};for(const a of D.distinct([...Object.keys(this.contents),...Object.keys(n)])){let c=this.contents[a],h=n[a];h&&(typeof c=="object"&&typeof h=="object"?(c=P.deepClone(c),this.mergeContents(c,h)):c=h),o[a]=c}return new y(o,this.keys,this.overrides)}mergeContents(e,n){for(const o of Object.keys(n)){if(o in e&&l.isObject(e[o])&&l.isObject(n[o])){this.mergeContents(e[o],n[o]);continue}e[o]=P.deepClone(n[o])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?P.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let n=null,o=null;const a=c=>{c&&(o?this.mergeContents(o,c):o=P.deepClone(c))};for(const c of this.overrides)D.equals(c.identifiers,[e])?n=c.contents:c.identifiers.includes(e)&&a(c.contents);return a(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,n){this.addKey(e),(0,C.addToValueTree)(this.contents,e,n,o=>{throw new Error(o)})}removeValue(e){this.removeKey(e)&&(0,C.removeFromValueTree)(this.contents,e)}addKey(e){let n=this.keys.length;for(let o=0;o<n;o++)e.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,e)}removeKey(e){let n=this.keys.indexOf(e);return n!==-1?(this.keys.splice(n,1),!0):!1}}t.ConfigurationModel=y;class w extends y{constructor(e={}){const n=d.Registry.as(L.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(n),a=Object.create(null),c=[];for(const h in n){const S=e[h],O=S!==void 0?S:n[h].default;(0,C.addToValueTree)(a,h,O,M=>console.error(`Conflict in default settings: ${M}`))}for(const h of Object.keys(a))L.OVERRIDE_PROPERTY_REGEX.test(h)&&c.push({identifiers:(0,L.overrideIdentifiersFromKey)(h),keys:Object.keys(a[h]),contents:(0,C.toValuesTree)(a[h],S=>console.error(`Conflict in default settings file: ${S}`))});super(a,o,c)}}t.DefaultConfigurationModel=w;class g{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,n){if(!l.isUndefinedOrNull(e)){const o=this.doParseContent(e);this.parseRaw(o,n)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,n){this._raw=e;const{contents:o,keys:a,overrides:c,restricted:h}=this.doParseRaw(e,n);this._configurationModel=new y(o,a,c),this._restrictedConfigurations=h||[]}doParseContent(e){let n={},o=null,a=[],c=[],h=[];function S(M){Array.isArray(a)?a.push(M):o!==null&&(a[o]=M)}let O={onObjectBegin:()=>{let M={};S(M),c.push(a),a=M,o=null},onObjectProperty:M=>{o=M},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{let M=[];S(M),c.push(a),a=M,o=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:S,onError:(M,_,X)=>{h.push({error:M,offset:_,length:X})}};if(e)try{b.visit(e,O),n=a[0]||{}}catch(M){console.error(`Error while parsing settings file ${this._name}: ${M}`),this._parseErrors=[M]}return n}doParseRaw(e,n){const o=d.Registry.as(L.Extensions.Configuration).getConfigurationProperties(),a=this.filter(e,o,!0,n);e=a.raw;const c=(0,C.toValuesTree)(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`)),h=Object.keys(e),S=this.toOverrides(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`));return{contents:c,keys:h,overrides:S,restricted:a.restricted}}filter(e,n,o,a){if(!a?.scopes&&!a?.skipRestricted)return{raw:e,restricted:[]};const c={},h=[];for(let S in e)if(L.OVERRIDE_PROPERTY_REGEX.test(S)&&o){const O=this.filter(e[S],n,!1,a);c[S]=O.raw,h.push(...O.restricted)}else{const O=n[S],M=O?typeof O.scope!="undefined"?O.scope:3:void 0;O?.restricted&&h.push(S),(M===void 0||a.scopes===void 0||a.scopes.includes(M))&&(a.skipRestricted&&O?.restricted||(c[S]=e[S]))}return{raw:c,restricted:h}}toOverrides(e,n){const o=[];for(const a of Object.keys(e))if(L.OVERRIDE_PROPERTY_REGEX.test(a)){const c={};for(const h in e[a])c[h]=e[a][h];o.push({identifiers:(0,L.overrideIdentifiersFromKey)(a),keys:Object.keys(c),contents:(0,C.toValuesTree)(c,n)})}return o}}t.ConfigurationModelParser=g;class u extends I.Disposable{constructor(e,n,o,a){super();this.userSettingsResource=e,this.scopes=n,this.fileService=a,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.any(R.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),R.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(1)||c.isOperation(4))&&o.isEqual(c.resource,e)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=u;class f{constructor(e,n,o=new y,a=new y,c=new T.ResourceMap,h=new y,S=new T.ResourceMap,O=!0){this._defaultConfiguration=e,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=a,this._folderConfigurations=c,this._memoryConfiguration=h,this._memoryConfigurationByResource=S,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(e,n,o){return this.getConsolidateConfigurationModel(n,o).getValue(e)}updateValue(e,n,o={}){let a;o.resource?(a=this._memoryConfigurationByResource.get(o.resource),a||(a=new y,this._memoryConfigurationByResource.set(o.resource,a))):a=this._memoryConfiguration,n===void 0?a.removeValue(e):a.setValue(e,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,o){const a=this.getConsolidateConfigurationModel(n,o),c=this.getFolderConfigurationModelForResource(n.resource,o),h=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,S=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),O=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),M=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),_=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),X=o?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,ee=c?n.overrideIdentifier?c.freeze().override(n.overrideIdentifier).getValue(e):c.freeze().getValue(e):void 0,te=n.overrideIdentifier?h.override(n.overrideIdentifier).getValue(e):h.getValue(e),ie=a.getValue(e),ue=D.distinct(D.flatten(a.overrides.map(he=>he.identifiers))).filter(he=>a.getOverrideValue(e,he)!==void 0);return{defaultValue:S,userValue:O,userLocalValue:M,userRemoteValue:_,workspaceValue:X,workspaceFolderValue:ee,memoryValue:te,value:ie,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userLocal:M!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspace:X!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspaceFolder:ee!==void 0?{value:c?.freeze().getValue(e),override:n.overrideIdentifier?c?.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,memory:te!==void 0?{value:h.getValue(e),override:n.overrideIdentifier?h.getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ue.length?ue:void 0}}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const o=[];if(!n){const{added:a,updated:c,removed:h}=s(this._defaultConfiguration,e);n=[...a,...c,...h]}for(const a of n)for(const c of(0,L.overrideIdentifiersFromKey)(a)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(c),S=e.getKeysForOverrideIdentifier(c),O=[...S.filter(M=>h.indexOf(M)===-1),...h.filter(M=>S.indexOf(M)===-1),...h.filter(M=>!P.equals(this._defaultConfiguration.override(c).getValue(M),e.override(c).getValue(M)))];o.push([c,O])}return this.updateDefaultConfiguration(e),{keys:n,overrides:o}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:o,removed:a,overrides:c}=s(this.localUserConfiguration,e),h=[...n,...o,...a];return h.length&&this.updateLocalUserConfiguration(e),{keys:h,overrides:c}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:o,removed:a,overrides:c}=s(this.remoteUserConfiguration,e);let h=[...n,...o,...a];return h.length&&this.updateRemoteUserConfiguration(e),{keys:h,overrides:c}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:o,removed:a,overrides:c}=s(this.workspaceConfiguration,e);let h=[...n,...o,...a];return h.length&&this.updateWorkspaceConfiguration(e),{keys:h,overrides:c}}compareAndUpdateFolderConfiguration(e,n){const o=this.folderConfigurations.get(e),{added:a,updated:c,removed:h,overrides:S}=s(o,n);let O=[...a,...c,...h];return(O.length||!o)&&this.updateFolderConfiguration(e,n),{keys:O,overrides:S}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:o,updated:a,removed:c,overrides:h}=s(n,void 0);return{keys:[...o,...a,...c],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,n){let o=this.getConsolidatedConfigurationModelForResource(e,n);return e.overrideIdentifier?o.override(e.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:e},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const a=n.getFolder(e);a&&(o=this.getFolderConsolidatedConfiguration(a.uri)||o);const c=this._memoryConfigurationByResource.get(e);c&&(o=o.merge(c))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(e);a?(n=o.merge(a),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(e,n)):n=o}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const o=n.getFolder(e);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:o,overrides:a,keys:c}=this._folderConfigurations.get(n);return e.push([n,{contents:o,overrides:a,keys:c}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>e.add(n)),this.userConfiguration.freeze().keys.forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(o=>e.add(o))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(o=>e.add(o))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(e).forEach(a=>n.add(a))),[...n.values()]}static parse(e){const n=this.parseConfigurationModel(e.defaults),o=this.parseConfigurationModel(e.user),a=this.parseConfigurationModel(e.workspace),c=e.folders.reduce((h,S)=>(h.set(p.URI.revive(S[0]),this.parseConfigurationModel(S[1])),h),new T.ResourceMap);return new f(n,o,new y,a,c,new y,new T.ResourceMap,!1)}static parseConfigurationModel(e){return new y(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=f;function E(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,n=new Map;for(const a of r)a.keys.forEach(c=>e.add(c)),a.overrides.forEach(([c,h])=>{const S=(0,T.getOrSet)(n,c,new Set);h.forEach(O=>S.add(O))});const o=[];return n.forEach((a,c)=>o.push([c,[...a.values()]])),{keys:[...e.values()],overrides:o}}t.mergeChanges=E;class v{constructor(e,n,o,a){this.change=e,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=a,this._previousConfiguration=void 0;const c=new Set;e.keys.forEach(S=>c.add(S)),e.overrides.forEach(([,S])=>S.forEach(O=>c.add(O))),this.affectedKeys=[...c.values()];const h=new y;this.affectedKeys.forEach(S=>h.setValue(S,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(n){const o=this.previousConfiguration?this.previousConfiguration.getValue(e,n,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!P.equals(o,a)}return!0}return!1}doesAffectedKeysTreeContains(e,n){let o=(0,C.toValuesTree)({[n]:!0},()=>{}),a;for(;typeof o=="object"&&(a=Object.keys(o)[0]);){if(e=e[a],!e)return!1;o=o[a]}return!0}}t.ConfigurationChangeEvent=v;class m extends v{constructor(e,n,o,a){super({keys:e.allKeys(),overrides:[]},void 0,e,n);this.source=o,this.sourceConfig=a}}t.AllKeysConfigurationChangeEvent=m;function s(r,e){const{added:n,removed:o,updated:a}=i(e,r),c=[],h=r?.getAllOverrideIdentifiers()||[],S=e?.getAllOverrideIdentifiers()||[];if(e){const O=S.filter(M=>!h.includes(M));for(const M of O)c.push([M,e.getKeysForOverrideIdentifier(M)])}if(r){const O=h.filter(M=>!S.includes(M));for(const M of O)c.push([M,r.getKeysForOverrideIdentifier(M)])}if(e&&r){for(const O of h)if(S.includes(O)){const M=i({contents:r.getOverrideValue(void 0,O)||{},keys:r.getKeysForOverrideIdentifier(O)},{contents:e.getOverrideValue(void 0,O)||{},keys:e.getKeysForOverrideIdentifier(O)});c.push([O,[...M.added,...M.removed,...M.updated]])}}return{added:n,removed:o,updated:a,overrides:c}}function i(r,e){const n=r?e?r.keys.filter(c=>e.keys.indexOf(c)===-1):[...r.keys]:[],o=e?r?e.keys.filter(c=>r.keys.indexOf(c)===-1):[...e.keys]:[],a=[];if(r&&e){for(const c of e.keys)if(r.keys.indexOf(c)!==-1){const h=(0,C.getConfigurationValue)(e.contents,c),S=(0,C.getConfigurationValue)(r.contents,c);P.equals(h,S)||a.push(c)}}return{added:n,removed:o,updated:a}}}),define(J[107],Y([0,1,3,7,2,19,25,106,34,30]),function(j,t,D,R,b,I,T,P,l,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class C extends b.Disposable{constructor(d,y){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,I.extUriBiasedIgnorePathCase,y)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(p.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(({properties:w})=>this.onDidDefaultConfigurationChange(w))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,y){const w=typeof d=="string"?d:void 0,g=(0,T.isConfigurationOverrides)(d)?d:(0,T.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(w,g,void 0)}updateValue(d,y,w,g){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const y=this.configuration.toData(),w=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(w,y,1)}onDidDefaultConfigurationChange(d){const y=this.configuration.toData(),w=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,d);this.trigger(w,y,6)}trigger(d,y,w){const g=new P.ConfigurationChangeEvent(d,{data:y},this.configuration);g.source=w,g.sourceConfig=this.getTargetConfiguration(w),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=C}),define(J[108],Y([0,1,11]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getRemoteName=t.getRemoteAuthority=void 0;function R(I){return I.scheme===D.Schemas.vscodeRemote?I.authority:void 0}t.getRemoteAuthority=R;function b(I){if(!I)return;const T=I.indexOf("+");return T<0?I:I.substr(0,T)}t.getRemoteName=b}),define(J[35],Y([0,1,26,13,108]),function(j,t,D,R,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isResolverExtension=t.isAuthenticationProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.UNDEFINED_PUBLISHER=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.UNDEFINED_PUBLISHER="undefined_publisher",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function I(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}t.getWorkspaceSupportTypeMessage=I;function T(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}t.isIExtensionIdentifier=T,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(P=t.ExtensionType||(t.ExtensionType={}));class l{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,w){if(typeof y=="undefined"||y===null)return typeof w=="undefined"||w===null;if(typeof w=="undefined"||w===null)return!1;if(typeof y=="string"||typeof w=="string"){let g=typeof y=="string"?y:y.value,u=typeof w=="string"?w:w.value;return D.equalsIgnoreCase(g,u)}return y._lower===w._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}t.ExtensionIdentifier=l;function p(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}t.isLanguagePackExtension=p;function C(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}t.isAuthenticationProviderExtension=C;function L(d,y){if(y){const w=`onResolveRemoteAuthority:${(0,b.getRemoteName)(y)}`;return d.activationEvents?.indexOf(w)!==-1}return!1}t.isResolverExtension=L,t.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[21],Y([0,1,26,35]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function b(w,g){return w.uuid&&g.uuid?w.uuid===g.uuid:w.id===g.id?!0:(0,D.compareIgnoreCase)(w.id,g.id)===0}t.areSameExtensions=b;class I{constructor(g,u){this.version=u,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof I?b(this,g)&&this.version===g.version:!1}}t.ExtensionIdentifierWithVersion=I;function T(w,g){return`${w}.${g}`}t.getExtensionId=T;function P(w){return w.toLocaleLowerCase()}t.adoptToGalleryExtensionId=P;function l(w,g){return P(T(w,g))}t.getGalleryExtensionId=l;function p(w,g){const u=[],f=E=>{for(const v of u)if(v.some(m=>b(g(m),g(E))))return v;return null};for(const E of w){const v=f(E);v?v.push(E):u.push([E])}return u}t.groupByExtension=p;function C(w){return{id:w.identifier.id,name:w.manifest.name,galleryId:null,publisherId:w.publisherId,publisherName:w.manifest.publisher,publisherDisplayName:w.publisherDisplayName,dependencies:w.manifest.extensionDependencies&&w.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=C;function L(w){return{id:w.identifier.id,name:w.name,galleryId:w.identifier.uuid,publisherId:w.publisherId,publisherName:w.publisher,publisherDisplayName:w.publisherDisplayName,isPreReleaseVersion:w.properties.isPreReleaseVersion,dependencies:!!(w.properties.dependencies&&w.properties.dependencies.length>0),...w.telemetryData}}t.getGalleryExtensionTelemetryData=L,t.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function d(w){const g=new Set;if(w.malicious)for(const u of w.malicious)g.add(u.id);return g}t.getMaliciousExtensionsSet=d;function y(w,g){const u=[],f=g.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const E=f.shift();if(E&&u.every(v=>!b(v.identifier,{id:E}))){const v=w.filter(m=>b(m.identifier,{id:E}));v.length===1&&(u.push(v[0]),f.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}t.getExtensionDependencies=y}),define(J[23],Y([0,1,75,21,13]),function(j,t,D,R,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.ExtensionManagementErrorCode=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.getIdAndVersion=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";const I=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function T(s){const i=I.exec(s);return i&&i[1]?[(0,R.adoptToGalleryExtensionId)(i[1]),i[2]]:[(0,R.adoptToGalleryExtensionId)(s),void 0]}t.getIdAndVersion=T;var P;(function(s){s.WIN32_X64="win32-x64",s.WIN32_IA32="win32-ia32",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(P=t.TargetPlatform||(t.TargetPlatform={}));function l(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=l;function p(s){switch(s){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=p;function C(s,i){switch(s){case 3:return i==="x64"?"win32-x64":i==="ia32"?"win32-ia32":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=C;function L(s,i){return i==="web"&&!s.includes("web")}t.isNotWebExtensionInWebTargetPlatform=L;function d(s,i,r){return L(i,r)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===r?!0:y(r).includes(s)}t.isTargetPlatformCompatible=d;function y(s){switch(s){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=y;function w(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}t.isIExtensionIdentifier=w;var g;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(g=t.SortBy||(t.SortBy={}));var u;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(u=t.SortOrder||(t.SortOrder={}));var f;(function(s){s.Install="install",s.Uninstall="uninstall"})(f=t.StatisticType||(t.StatisticType={}));var E;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(E=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,b.createDecorator)("extensionGalleryService");var v;(function(s){s.Unsupported="Unsupported",s.UnsupportedPreRelease="UnsupportedPreRelease",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatiblePreRelease="IncompatiblePreRelease",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Internal="Internal"})(v=t.ExtensionManagementErrorCode||(t.ExtensionManagementErrorCode={}));class m extends Error{constructor(i,r){super(i);this.code=r,this.name=r}}t.ExtensionManagementError=m,t.IExtensionManagementService=(0,b.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,b.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,b.createDecorator)("IExtensionTipsService"),t.ExtensionsLabel=(0,D.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,D.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,b.createDecorator)("IExtensionManagementCLIService")}),define(J[109],Y([0,1,24,8,62,11,41,9,76,23,21,35]),function(j,t,D,R,b,I,T,P,l,p,C,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=void 0;const d=u=>(0,l.localize)(0,null,u),y=(0,l.localize)(1,null,"ms-dotnettools.csharp");function w(u,f){return f?`${u.publisher}.${u.name}@${u.version}`:`${u.publisher}.${u.name}`}let g=class{constructor(f,E){this.extensionManagementService=f,this.extensionGalleryService=E}get location(){}async listExtensions(f,E,v=console){let m=await this.extensionManagementService.getInstalled(1);const s=L.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(E&&E!==""){if(s.indexOf(E.toLowerCase())<0){v.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}m=m.filter(r=>r.manifest.categories?r.manifest.categories.map(n=>n.toLowerCase()).indexOf(E.toLowerCase())>-1:!1)}else if(E===""){v.log("Possible Categories: "),s.forEach(r=>{v.log(r)});return}this.location&&v.log((0,l.localize)(2,null,this.location)),m=m.sort((r,e)=>r.identifier.id.localeCompare(e.identifier.id));let i;for(let r of m)i!==r.identifier.id&&(i=r.identifier.id,v.log(w(r.manifest,f)))}async installExtensions(f,E,v,m,s=console){const i=[],r=[];f.length&&s.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const e=await this.extensionManagementService.getInstalled(1),n=(c,h)=>{const S=e.find(O=>(0,C.areSameExtensions)(O.identifier,{id:c}));if(S){if(!h&&!m)return s.log((0,l.localize)(5,null,c,S.manifest.version,c)),!1;if(h&&S.manifest.version===h)return s.log((0,l.localize)(6,null,`${c}@${h}`)),!1}return!0},o=[],a=[];for(const c of f)if(c instanceof P.URI)o.push(c);else{const[h,S]=(0,p.getIdAndVersion)(c);n(h,S)&&a.push({id:h,version:S,installOptions:{...v,isBuiltin:!1}})}for(const c of E){const[h,S]=(0,p.getIdAndVersion)(c);n(h,S)&&a.push({id:h,version:S,installOptions:{...v,isBuiltin:!0}})}if(o.length&&await Promise.all(o.map(async c=>{try{const h=await this.installVSIX(c,{...v,isBuiltin:!1},m,s);h&&r.push(h)}catch(h){s.error(h.message||h.stack||h),i.push(c.toString())}})),a.length){const c=await this.getGalleryExtensions(a);await Promise.all(a.map(async h=>{const S=c.get(h.id.toLowerCase());if(S)try{const O=await this.installFromGallery(h,S,e,m,s);O&&r.push(O)}catch(O){s.error(O.message||O.stack||O),i.push(h.id)}else s.error(`${d(h.version?`${h.id}@${h.version}`:h.id)}
${y}`),i.push(h.id)}))}if(i.length)throw new Error((0,l.localize)(7,null,i.join(", ")))}async installVSIX(f,E,v,m){const s=await this.extensionManagementService.getManifest(f);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,v,m))try{return await this.extensionManagementService.install(f,E),m.log((0,l.localize)(8,null,(0,b.getBaseLabel)(f))),s}catch(r){if((0,R.isCancellationError)(r))return m.log((0,l.localize)(9,null,(0,b.getBaseLabel)(f))),null;throw r}return null}async getGalleryExtensions(f){const E=new Map,v=f.some(s=>s.installOptions.installPreReleaseVersion),m=await this.extensionGalleryService.getExtensions(f.map(s=>({...s,preRelease:v})),D.CancellationToken.None);for(const s of m)E.set(s.identifier.id.toLowerCase(),s);return E}async installFromGallery({id:f,version:E,installOptions:v},m,s,i,r){const e=await this.extensionGalleryService.getManifest(m,D.CancellationToken.None);if(e&&!this.validateExtensionKind(e,r))return null;const n=s.find(o=>(0,C.areSameExtensions)(o.identifier,m.identifier));if(n){if(m.version===n.manifest.version)return r.log((0,l.localize)(10,null,E?`${f}@${E}`:f)),null;r.log((0,l.localize)(11,null,f,m.version))}try{return v.isBuiltin?r.log(E?(0,l.localize)(12,null,f,E):(0,l.localize)(13,null,f)):r.log(E?(0,l.localize)(14,null,f,E):(0,l.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(m,{...v,installGivenVersion:!!E}),r.log((0,l.localize)(16,null,f,m.version)),e}catch(o){if((0,R.isCancellationError)(o))return r.log((0,l.localize)(17,null,f)),null;throw o}}validateExtensionKind(f,E){return!0}async validateVSIX(f,E,v){const m={id:(0,C.getGalleryExtensionId)(f.publisher,f.name)},i=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,C.areSameExtensions)(m,r.identifier)&&(0,T.gt)(r.manifest.version,f.version));return i&&!E?(v.log((0,l.localize)(18,null,i.identifier.id,i.manifest.version,f.version)),!1):this.validateExtensionKind(f,v)}async uninstallExtensions(f,E,v=console){const m=async i=>{if(i instanceof P.URI){const r=await this.extensionManagementService.getManifest(i);return w(r)}return i},s=[];for(const i of f){const r=await m(i),n=(await this.extensionManagementService.getInstalled()).filter(o=>(0,C.areSameExtensions)(o.identifier,{id:r}));if(!n.length)throw new Error(`${this.notInstalled(r)}
${y}`);if(n.some(o=>o.type===0)){v.log((0,l.localize)(19,null,r));return}if(!E&&n.some(o=>o.isBuiltin)){v.log((0,l.localize)(20,null,r));return}v.log((0,l.localize)(21,null,r));for(const o of n)await this.extensionManagementService.uninstall(o),s.push(o);this.location?v.log((0,l.localize)(22,null,r,this.location)):v.log((0,l.localize)(23,null,r))}}async locateExtension(f,E=console){const v=await this.extensionManagementService.getInstalled();f.forEach(m=>{v.forEach(s=>{if(s.identifier.id===m&&s.location.scheme===I.Schemas.file){E.log(s.location.fsPath);return}})})}notInstalled(f){return this.location?(0,l.localize)(24,null,f,this.location):(0,l.localize)(25,null,f)}};g=ge([oe(0,p.IExtensionManagementService),oe(1,p.IExtensionGalleryService)],g),t.ExtensionManagementCLIService=g}),define(J[110],Y([0,1,3,8,2,12,19,41,9,27,15,20,23,21,16,14]),function(j,t,D,R,b,I,T,P,l,p,C,L,d,y,w,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const u=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let f=class extends b.Disposable{constructor(v,m,s,i){super();this.fileService=m,this.extensionGalleryService=s,this.logService=i,this.extensionsDownloadDir=l.URI.file(v.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(v,m){await this.cleanUpPromise;const s=this.getName(v),i=(0,T.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(i)){const r=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,p.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(v,r,m);try{await this.rename(r,i,Date.now()+2*60*1e3)}catch(e){try{await this.fileService.del(r)}catch{}if(e.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",v.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(e)}. Deleted the vsix from downloaded location`,r.path),e}}return i}async delete(v){await this.cleanUpPromise,await this.fileService.del(v)}async rename(v,m,s){try{await C.Promises.rename(v.fsPath,m.fsPath)}catch(i){if(I.isWindows&&i&&i.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${v} to ${m} with 'EPERM' error. Trying again...`),this.rename(v,m,s);throw i}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const v=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(v.children){const m=[],s=[];for(const e of v.children){const n=this.parse(e.name);n&&s.push([n,e])}const i=(0,y.groupByExtension)(s,([e])=>e),r=[];for(const e of i)e.sort((n,o)=>P.rcompare(n[0].version,o[0].version)),m.push(...e.slice(1).map(n=>n[1].resource)),r.push(e[0][1]);r.sort((e,n)=>e.mtime-n.mtime),m.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(e=>e.resource)),await D.Promises.settled(m.map(e=>(this.logService.trace("Deleting vsix from cache",e.path),this.fileService.del(e))))}}catch(v){this.logService.error(v)}}getName(v){return this.cache?`${new y.ExtensionIdentifierWithVersion(v.identifier,v.version).key().toLowerCase()}${v.properties.targetPlatform!=="undefined"?`-${v.properties.targetPlatform}`:""}`:(0,p.generateUuid)()}parse(v){const m=u.exec(v);return m&&m[1]&&m[2]?new y.ExtensionIdentifierWithVersion({id:m[1]},m[2]):null}};f=ge([oe(0,L.INativeEnvironmentService),oe(1,w.IFileService),oe(2,d.IExtensionGalleryService),oe(3,g.ILogService)],f),t.ExtensionsDownloader=f}),define(J[111],Y([0,1,2,10,15,35]),function(j,t,D,R,b,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class T extends D.Disposable{constructor(l,p){super();this.environmentService=l,this.extensionsManifestCache=(0,R.join)(this.environmentService.userDataPath,I.MANIFEST_CACHE_FOLDER,I.USER_MANIFEST_CACHE_FILE),this._register(p.onDidInstallExtensions(C=>this.onDidInstallExtensions(C))),this._register(p.onDidUninstallExtension(C=>this.onDidUnInstallExtension(C)))}onDidInstallExtensions(l){l.some(p=>!!p.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){b.Promises.rm(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=T}),define(J[112],Y([0,1,137,18,3,2,11,10,15,20,23,21,53,14]),function(j,t,D,R,b,I,T,P,l,p,C,L,d,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let w=class extends I.Disposable{constructor(f,E,v){super();this.extensionManagementService=f,this.logService=v,this.cache=this._register(new g(E,v)),this.extensionManagementService.registerParticipant({postInstall:async m=>this.postInstallExtension(m),postUninstall:async m=>this.postUninstallExtension(m)})}async getLanguageIds(){const f=await this.cache.getLanguagePacks(),E=["en",...Object.keys(f)];return(0,R.distinct)(E)}async postInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",f.identifier.id),await this.update())}async postUninstallExtension(f){const E=await this.cache.getLanguagePacks();Object.keys(E).some(v=>E[v]&&E[v].extensions.some(m=>(0,L.areSameExtensions)(m.extensionIdentifier,f.identifier)))&&(this.logService.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,E]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),v=await this.cache.update(E);return!(0,R.equals)(Object.keys(f),Object.keys(v))}};w=ge([oe(0,C.IExtensionManagementService),oe(1,p.INativeEnvironmentService),oe(2,y.ILogService)],w),t.LocalizationsService=w;let g=class extends I.Disposable{constructor(f,E){super();this.logService=E,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new b.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(E=>{Object.keys(E).forEach(v=>delete E[v]),this.createLanguagePacksFromExtensions(E,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...E){for(const v of E)v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,v);Object.keys(f).forEach(v=>this.updateHash(f[v]))}createLanguagePacksFromExtension(f,E){const v=E.identifier,m=E.manifest.contributes&&E.manifest.contributes.localizations?E.manifest.contributes.localizations:[];for(const s of m)if(E.location.scheme===T.Schemas.file&&(0,d.isValidLocalization)(s)){let i=f[s.languageId];i||(i={hash:"",extensions:[],translations:{}},f[s.languageId]=i);let r=i.extensions.filter(e=>(0,L.areSameExtensions)(e.extensionIdentifier,v))[0];r?r.version=E.manifest.version:i.extensions.push({extensionIdentifier:v,version:E.manifest.version});for(const e of s.translations)i.translations[e.id]=(0,P.join)(E.location.fsPath,e.path)}}updateHash(f){if(f){const E=(0,D.createHash)("md5");for(const v of f.extensions)E.update(v.extensionIdentifier.uuid||v.extensionIdentifier.id).update(v.version);f.hash=E.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let E=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,v=>v.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(v)).then(v=>{try{return JSON.parse(v)}catch{return{}}}).then(v=>(E=f(v),v)).then(v=>{for(const s of Object.keys(v))v[s]||delete v[s];this.languagePacks=v,this.initializedCache=!0;const m=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",m),l.Promises.writeFile(this.languagePacksFilePath,m)}).then(()=>E,v=>this.logService.error(v))})}};g=ge([oe(0,p.INativeEnvironmentService),oe(1,y.ILogService)],g)}),define(J[42],Y([0,1,17,84,34,13,30]),function(j,t,D,R,b,I,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,I.createDecorator)("requestService");function P(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}t.isSuccess=P;function l(w){return w.res.statusCode===204}async function p(w){if(!P(w))throw new Error("Server returned "+w.res.statusCode);return l(w)?null:(await(0,D.streamToBuffer)(w.stream)).toString()}t.asText=p;async function C(w){if(!P(w))throw new Error("Server returned "+w.res.statusCode);if(l(w))return null;const u=(await(0,D.streamToBuffer)(w.stream)).toString();try{return JSON.parse(u)}catch(f){throw f.message+=`:
`+u,f}}t.asJson=C;function L(w){y(w)}t.updateProxyConfigurationsScope=L;let d;function y(w){const g=T.Registry.as(b.Extensions.Configuration),u=d;d={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[d],remove:u?[u]:[]})}y(2)}),define(J[113],Y([0,1,24,11,16,42]),function(j,t,D,R,b,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let T=class{constructor(l,p){this.requestService=l,this.fileService=p}async download(l,p,C=D.CancellationToken.None){if(l.scheme===R.Schemas.file||l.scheme===R.Schemas.vscodeRemote){await this.fileService.copy(l,p);return}const L={type:"GET",url:l.toString()},d=await this.requestService.request(L,C);if(d.res.statusCode===200)await this.fileService.writeFile(p,d.stream);else{const y=await(0,I.asText)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${y}`)}}};T=ge([oe(0,I.IRequestService),oe(1,b.IFileService)],T),t.DownloadService=T}),define(J[114],Y([0,1,115,6]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function b(T,P){return T.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:T.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function I(T,P,l={}){const p=(0,D.parse)(T),C=l.proxyUrl||b(p,P);if(!C)return null;const L=(0,D.parse)(C);if(!/^https?:$/.test(L.protocol||""))return null;const d={host:L.hostname||"",port:L.port||(L.protocol==="https"?"443":"80"),auth:L.auth,rejectUnauthorized:(0,R.isBoolean)(l.strictSSL)?l.strictSSL:!0};return p.protocol==="http:"?new(await new Promise((y,w)=>{j(["http-proxy-agent"],y,w)}))(d):new(await new Promise((y,w)=>{j(["https-proxy-agent"],y,w)}))(d)}t.getProxyAgent=I}),define(J[116],Y([0,1,3,7,2,101,6,65,13]),function(j,t,D,R,b,I,T,P,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const p="__$__targetStorageMarker";t.IStorageService=(0,l.createDecorator)("storageService");var C;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(C=t.WillSaveStateReason||(t.WillSaveStateReason={}));var L;(function(u){u[u.GLOBAL=0]="GLOBAL",u[u.WORKSPACE=1]="WORKSPACE"})(L=t.StorageScope||(t.StorageScope={}));var d;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(d=t.StorageTarget||(t.StorageTarget={}));class y extends b.Disposable{constructor(f={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=f,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,I.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,E){E===p?(f===0?this._globalKeyTargets=void 0:f===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:f})):this._onDidChangeValue.fire({scope:f,key:E,target:this.getKeyTargets(f)[E]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,E,v){return this.getStorage(E)?.get(f,v)}getBoolean(f,E,v){return this.getStorage(E)?.getBoolean(f,v)}getNumber(f,E,v){return this.getStorage(E)?.getNumber(f,v)}store(f,E,v,m){if((0,T.isUndefinedOrNull)(E)){this.remove(f,v);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,v,m),this.getStorage(v)?.set(f,E)})}remove(f,E){this.withPausedEmitters(()=>{this.updateKeyTarget(f,E,void 0),this.getStorage(E)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,E){const v=[],m=this.getKeyTargets(f);for(const s of Object.keys(m))m[s]===E&&v.push(s);return v}updateKeyTarget(f,E,v){const m=this.getKeyTargets(E);typeof v=="number"?m[f]!==v&&(m[f]=v,this.getStorage(E)?.set(p,JSON.stringify(m))):typeof m[f]=="number"&&(delete m[f],this.getStorage(E)?.set(p,JSON.stringify(m)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(f){return f===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(f){const E=this.get(p,f);if(E)try{return JSON.parse(E)}catch{}return Object.create(null)}isNew(f){return this.getBoolean(t.IS_NEW_KEY,f)===!0}async flush(f=C.NONE){this._onWillSaveState.fire({reason:f});const E=this.getStorage(0),v=this.getStorage(1);switch(f){case C.NONE:await D.Promises.settled([E?.whenFlushed()??Promise.resolve(),v?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await D.Promises.settled([E?.flush(0)??Promise.resolve(),v?.flush(0)??Promise.resolve()]);break}}async logStorage(){const f=this.getStorage(0)?.items??new Map,E=this.getStorage(1)?.items??new Map;return g(f,E,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class w extends y{constructor(){super();this.globalStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.globalStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f)))}getStorage(f){return f===0?this.globalStorage:this.workspaceStorage}getLogDetails(f){return f===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(f){}}t.InMemoryStorageService=w;async function g(u,f,E,v){const m=a=>{try{return JSON.parse(a)}catch{return a}},s=new Map,i=new Map;u.forEach((a,c)=>{s.set(c,a),i.set(c,m(a))});const r=new Map,e=new Map;f.forEach((a,c)=>{r.set(c,a),e.set(c,m(a))}),console.group(`Storage: Global (path: ${E})`);let n=[];s.forEach((a,c)=>{n.push({key:c,value:a})}),console.table(n),console.groupEnd(),console.log(i),console.group(`Storage: Workspace (path: ${v})`);let o=[];r.forEach((a,c)=>{o.push({key:c,value:a})}),console.table(o),console.groupEnd(),console.log(e)}t.logStorage=g}),define(J[117],Y([0,1,12,29,9,27]),function(j,t,D,R,b,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function T(p){if(D.platform===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}async function P(p,C,L,d,y,w,g,u,f,E){const v=Object.create(null);v["common.machineId"]=g,v.sessionID=(0,I.generateUuid)()+Date.now(),v.commitHash=y,v.version=w,v["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,D.PlatformToString)(D.platform),v["common.nodePlatform"]=R.platform,v["common.nodeArch"]=d,v["common.product"]=E||"desktop";const m=l(u||[]);m&&(v["common.msftInternal"]=m);let s=0;const i=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),D.isLinuxSnap&&(v["common.snap"]="true");const r=T(L);r&&(v["common.platformDetail"]=r);try{const e=await p.readFile(b.URI.file(f));v["common.source"]=e.value.toString().slice(0,30)}catch{}return v}t.resolveCommonProperties=P;function l(p){const C=R.env.USERDNSDOMAIN;if(!C)return!1;const L=C.toLowerCase();return p.some(d=>L===d)}t.verifyMicrosoftInternalDomain=l}),define(J[31],Y([0,1,13]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,D.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(R=t.TelemetryLevel||(t.TelemetryLevel={}));var b;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(b=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(J[118],Y([0,1,18,3,24,8,7,2,12,6,9,74,23,21,14,32,31]),function(j,t,D,R,b,I,T,P,l,p,C,L,d,y,w,g,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=void 0;let f=class extends P.Disposable{constructor(r,e,n,o){super();this.galleryService=r,this.telemetryService=e,this.logService=n,this.productService=o,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(a=>a.cancel()),this.uninstallingExtensions.forEach(a=>a.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(r){const e=await this.getTargetPlatform();return r.allTargetPlatforms.some(n=>(0,d.isTargetPlatformCompatible)(n,r.allTargetPlatforms,e))}async installFromGallery(r,e={}){try{if(!this.galleryService.isEnabled())throw new d.ExtensionManagementError(L.localize(0,null),d.ExtensionManagementErrorCode.Internal);const n=await this.checkAndGetCompatibleVersion(r,!e.installGivenVersion,!!e.installPreReleaseVersion);return await this.installExtension(n.manifest,n.extension,e)}catch(n){throw m(this.telemetryService,"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(r),void 0,n),this.logService.error("Failed to install extension.",r.identifier.id),this.logService.error(n),v(n)}}async uninstall(r,e={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.unininstallExtension(r,e)}async reinstallFromGallery(r){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",r.identifier.id),!this.galleryService.isEnabled())throw new Error(L.localize(1,null));const e=await this.getTargetPlatform(),[n]=await this.galleryService.getExtensions([{...r.identifier,preRelease:r.preRelease}],{targetPlatform:e,compatible:!0},b.CancellationToken.None);if(!n)throw new Error(L.localize(2,null));await this.createUninstallExtensionTask(r,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.extensionsControlManifest||r-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=r),this.extensionsControlManifest}registerParticipant(r){this.participants.push(r)}async installExtension(r,e,n){if(!C.URI.isUri(e)){let S=this.installingExtensions.get(new y.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(S)return this.logService.info("Extensions is already requested to install",e.identifier.id),S.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const o=[],a=[],c=this.createInstallExtensionTask(r,e,n);C.URI.isUri(e)||this.installingExtensions.set(new y.ExtensionIdentifierWithVersion(c.identifier,r.version).key(),c),this._onInstallExtension.fire({identifier:c.identifier,source:e}),this.logService.info("Installing extension:",c.identifier.id),o.push({task:c,manifest:r});let h=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",c.identifier.id);else try{const O=await this.getAllDepsAndPackExtensionsToInstall(c.identifier,r,!!n.installOnlyNewlyAddedFromExtensionPack,!!n.installPreReleaseVersion);for(const{gallery:M,manifest:_}of O)if(h=h||!!_.extensionDependencies?.some(X=>(0,y.areSameExtensions)({id:X},c.identifier)),this.installingExtensions.has(new y.ExtensionIdentifierWithVersion(M.identifier,M.version).key()))this.logService.info("Extension is already requested to install",M.identifier.id);else{const X=this.createInstallExtensionTask(_,M,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new y.ExtensionIdentifierWithVersion(X.identifier,_.version).key(),X),this._onInstallExtension.fire({identifier:X.identifier,source:M}),this.logService.info("Installing extension:",X.identifier.id),o.push({task:X,manifest:_})}}catch(O){if(C.URI.isUri(c.source))(0,D.isNonEmptyArray)(r.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",c.identifier.id,O.message),(0,D.isNonEmptyArray)(r.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",c.identifier.id,O.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",c.identifier.id),O}const S=o.reduce((O,{task:M,manifest:_})=>(O.set(M.identifier.id.toLowerCase(),{task:M,manifest:_}),O),new Map);for(;S.size;){let O;const M=[...S.values()].filter(({manifest:_})=>!_.extensionDependencies?.some(X=>S.has(X.toLowerCase())));M.length?O=S.size===1?M:M.filter(({task:_})=>!(_===c&&!h)):(this.logService.info("Found extensions with circular dependencies",M.map(({task:_})=>_.identifier.id)),O=[...S.values()]),await this.joinAllSettled(O.map(async({task:_})=>{const X=new Date().getTime(),ee=(0,p.isUndefined)(n.operation)?_.operation:n.operation;try{const te=await _.run();if(await this.joinAllSettled(this.participants.map(ie=>ie.postInstall(te,_.source,n,b.CancellationToken.None))),!C.URI.isUri(_.source)&&(m(this.telemetryService,ee===3?"extensionGallery:update":"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(_.source),new Date().getTime()-X,void 0),l.isWeb&&ee!==3))try{await this.galleryService.reportStatistic(te.manifest.publisher,te.manifest.name,te.manifest.version,"install")}catch{}a.push({local:te,identifier:_.identifier,operation:ee,source:_.source})}catch(te){throw C.URI.isUri(_.source)||m(this.telemetryService,ee===3?"extensionGallery:update":"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(_.source),new Date().getTime()-X,te),this.logService.error("Error while installing the extension:",_.identifier.id),te}finally{S.delete(_.identifier.id.toLowerCase())}}))}return a.forEach(({identifier:O})=>this.logService.info("Extension installed successfully:",O.id)),this._onDidInstallExtensions.fire(a),a.filter(({identifier:O})=>(0,y.areSameExtensions)(O,c.identifier))[0].local}catch(S){if(o.forEach(({task:O})=>O.cancel()),a.length)try{const O=await Promise.allSettled(a.map(({local:M})=>this.createUninstallExtensionTask(M,{versionOnly:!0}).run()));for(let M=0;M<O.length;M++){const _=O[M],{identifier:X}=a[M];_.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",X.id):this.logService.warn("Rollback: Error while uninstalling extension",X.id,(0,I.getErrorMessage)(_.reason))}}catch(O){this.logService.warn("Error while rolling back extensions",(0,I.getErrorMessage)(O),a.map(({identifier:M})=>M.id))}throw this._onDidInstallExtensions.fire(o.map(({task:O})=>({identifier:O.identifier,operation:2,source:O.source}))),S}finally{for(const{task:S,manifest:O}of o)if(!C.URI.isUri(S.source)){const M=new y.ExtensionIdentifierWithVersion(S.identifier,O.version).key();this.installingExtensions.delete(M)||this.logService.warn("Installation task is not found in the cache",M)}}}async joinAllSettled(r){const e=[],n=[],o=await Promise.allSettled(r);for(const a of o)a.status==="fulfilled"?e.push(a.value):n.push(a.reason);if(n.length)throw E(n);return e}async getAllDepsAndPackExtensionsToInstall(r,e,n,o){if(!this.galleryService.isEnabled())return[];let a=await this.getInstalled();const c=[r,...a.map(O=>O.identifier)],h=[],S=async(O,M)=>{const _=M.extensionDependencies||[],X=[..._];if(M.extensionPack){const ee=n?a.find(te=>(0,y.areSameExtensions)(te.identifier,O)):void 0;for(const te of M.extensionPack)ee&&ee.manifest.extensionPack&&ee.manifest.extensionPack.some(ie=>(0,y.areSameExtensions)({id:ie},{id:te}))||X.every(ie=>!(0,y.areSameExtensions)({id:ie},{id:te}))&&X.push(te)}if(X.length){const ee=[...c,...h.map(ie=>ie.gallery.identifier)],te=X.filter(ie=>ee.every(ue=>!(0,y.areSameExtensions)(ue,{id:ie})));if(te.length){const ie=await this.galleryService.getExtensions(te.map(ue=>({id:ue,preRelease:o})),b.CancellationToken.None);for(const ue of ie){if(ee.find(Z=>(0,y.areSameExtensions)(Z,ue.identifier)))continue;const he=_.some(Z=>(0,y.areSameExtensions)({id:Z},ue.identifier));let V;try{V=await this.checkAndGetCompatibleVersion(ue,!0,o)}catch(Z){if(Z instanceof d.ExtensionManagementError&&Z.code===d.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!he){this.logService.info("Skipping the packed extension as it cannot be installed",ue.identifier.id);continue}else throw Z}h.push({gallery:V.extension,manifest:V.manifest}),await S(V.extension.identifier,V.manifest)}}}};return await S(r,e),a=await this.getInstalled(),h.filter(O=>!a.some(M=>(0,y.areSameExtensions)(M.identifier,O.gallery.identifier)))}async checkAndGetCompatibleVersion(r,e,n){const o=await this.getExtensionsControlManifest();if((0,y.getMaliciousExtensionsSet)(o).has(r.identifier.id))throw new d.ExtensionManagementError(L.localize(3,null,r.identifier.id),d.ExtensionManagementErrorCode.Malicious);if(!!o.unsupportedPreReleaseExtensions&&!!o.unsupportedPreReleaseExtensions[r.identifier.id])throw new d.ExtensionManagementError(L.localize(4,null,r.identifier.id,o.unsupportedPreReleaseExtensions[r.identifier.id].displayName),d.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(r)){const h=await this.getTargetPlatform();throw new d.ExtensionManagementError(L.localize(5,null,r.identifier.id,this.productService.nameLong,(0,d.TargetPlatformToString)(h)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(r,e,n);if(a){if(n&&e&&r.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new d.ExtensionManagementError(L.localize(6,null,r.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!n&&r.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([r.identifier],b.CancellationToken.None))[0]?new d.ExtensionManagementError(L.localize(7,null,r.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.ExtensionManagementError(L.localize(8,null,r.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const c=await this.galleryService.getManifest(a,b.CancellationToken.None);if(c===null)throw new d.ExtensionManagementError(`Missing manifest for extension ${r.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(c.version!==a.version)throw new d.ExtensionManagementError(`Cannot install '${r.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:c}}async getCompatibleVersion(r,e,n){const o=await this.getTargetPlatform();let a=null;return e&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==n&&(a=(await this.galleryService.getExtensions([{...r.identifier,preRelease:n}],{targetPlatform:o,compatible:!0},b.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(r,n,o)&&(a=r),!a&&e&&(a=await this.galleryService.getCompatibleExtension(r,n,o)),a}async unininstallExtension(r,e){const n=this.uninstallingExtensions.get(r.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),n.waitUntilTaskIsFinished();const o=(S,O)=>{const M=this.createUninstallExtensionTask(S,O);return this.uninstallingExtensions.set(M.extension.identifier.id.toLowerCase(),M),this.logService.info("Uninstalling extension:",S.identifier.id),this._onUninstallExtension.fire(S.identifier),M},a=(S,O)=>{O?this.logService.error("Failed to uninstall extension:",S.identifier.id,O.message):this.logService.info("Successfully uninstalled extension:",S.identifier.id),m(this.telemetryService,"extensionGallery:uninstall",(0,y.getLocalExtensionTelemetryData)(S),void 0,O),this._onDidUninstallExtension.fire({identifier:S.identifier,error:O?.code})},c=[],h=[];try{c.push(o(r,{}));const S=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",r.identifier.id);else{const O=this.getAllPackExtensionsToUninstall(r,S);for(const M of O)this.uninstallingExtensions.has(M.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",M.identifier.id):c.push(o(M,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",r.identifier.id):this.checkForDependents(c.map(O=>O.extension),S,r),await this.joinAllSettled(c.map(async O=>{try{if(await O.run(),await this.joinAllSettled(this.participants.map(M=>M.postUninstall(O.extension,e,b.CancellationToken.None))),O.extension.identifier.uuid)try{await this.galleryService.reportStatistic(O.extension.manifest.publisher,O.extension.manifest.name,O.extension.manifest.version,"uninstall")}catch{}a(O.extension)}catch(M){const _=M instanceof d.ExtensionManagementError?M:new d.ExtensionManagementError((0,I.getErrorMessage)(M),d.ExtensionManagementErrorCode.Internal);throw a(O.extension,_),_}finally{h.push(O)}}))}catch(S){const O=S instanceof d.ExtensionManagementError?S:new d.ExtensionManagementError((0,I.getErrorMessage)(S),d.ExtensionManagementErrorCode.Internal);for(const M of c){try{M.cancel()}catch{}h.includes(M)||a(M.extension,O)}throw O}finally{for(const S of c)this.uninstallingExtensions.delete(S.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",S.extension.identifier.id)}}checkForDependents(r,e,n){for(const o of r){const a=this.getDependents(o,e);if(a.length){const c=a.filter(h=>!r.some(S=>(0,y.areSameExtensions)(S.identifier,h.identifier)));if(c.length)throw new Error(this.getDependentsErrorMessage(o,c,n))}}}getDependentsErrorMessage(r,e,n){return n===r?e.length===1?L.localize(9,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?L.localize(10,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):L.localize(11,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?L.localize(12,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?L.localize(13,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):L.localize(14,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(r,e,n=[]){if(n.indexOf(r)!==-1)return[];n.push(r);const o=r.manifest.extensionPack?r.manifest.extensionPack:[];if(o.length){const a=e.filter(h=>!h.isBuiltin&&o.some(S=>(0,y.areSameExtensions)({id:S},h.identifier))),c=[];for(const h of a)c.push(...this.getAllPackExtensionsToUninstall(h,e,n));return[...a,...c]}return[]}getDependents(r,e){return e.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(o=>(0,y.areSameExtensions)({id:o},r.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const r=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",r),r}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};f=ge([oe(0,d.IExtensionGalleryService),oe(1,u.ITelemetryService),oe(2,w.ILogService),oe(3,g.IProductService)],f),t.AbstractExtensionManagementService=f;function E(i){const r=Array.isArray(i)?i:[i];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((e,n)=>new Error(`${e.message}${e.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}t.joinErrors=E;function v(i){if(i instanceof d.ExtensionManagementError)return i;const r=new d.ExtensionManagementError(i.message,d.ExtensionManagementErrorCode.Internal);return r.stack=i.stack,r}function m(i,r,e,n,o){const a=o?o instanceof d.ExtensionManagementError?o.code:d.ExtensionManagementErrorCode.Internal:void 0;i.publicLogError(r,{...e,success:!o,duration:n,errorcode:a})}t.reportTelemetry=m;class s{constructor(){this.barrier=new R.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(r=>new Promise((e,n)=>{const o=r.onCancellationRequested(()=>{o.dispose(),n((0,I.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=s}),define(J[36],Y([0,1,22,6,25,31]),function(j,t,D,R,b,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPiiPathsFromEnvironment=t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=void 0;class T{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(E,v){return Promise.resolve(void 0)}publicLog2(E,v){return this.publicLog(E,v)}publicLogError(E,v){return Promise.resolve(void 0)}publicLogError2(E,v){return this.publicLogError(E,v)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}t.NullTelemetryServiceShape=T,t.NullTelemetryService=new T;class P{async publicLog(E,v,m){}async publicLogError(E,v,m){}}t.NullEndpointTelemetryService=P,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(f,E){return E.onDidChangeConfiguration(v=>{v.source!==6&&f.publicLog2("updateConfiguration",{configurationSource:(0,b.ConfigurationTargetToString)(v.source),configurationKeys:w(v.sourceConfig)})})}t.configurationTelemetry=l;function p(f,E){return!(E.disableTelemetry||!f.enableTelemetry||E.extensionTestsLocationURI)}t.supportsTelemetry=p;function C(f){const E=f.getValue(I.TELEMETRY_SETTING_ID),v=f.getValue("telemetry.enableCrashReporter");if(f.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||v===!1)return 0;switch(E??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}t.getTelemetryLevel=C;function L(f){const E=Object.create(null),v=Object.create(null),m=Object.create(null);y(f,m);for(let s in m){s=s.length>150?s.substr(s.length-149):s;const i=m[s];typeof i=="number"?v[s]=i:typeof i=="boolean"?v[s]=i?1:0:typeof i=="string"?(i.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${i.length}`),E[s]=i.substring(0,8191)):typeof i!="undefined"&&i!==null&&(E[s]=i)}return{properties:E,measurements:v}}t.validateTelemetryData=L;function d(f){if(!f)return"none";let E="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(m=>{f.indexOf(`${m}+`)===0&&(E=m)}),E}t.cleanRemoteAuthority=d;function y(f,E,v=0,m){if(!!f)for(let s of Object.getOwnPropertyNames(f)){const i=f[s],r=m?m+s:s;Array.isArray(i)?E[r]=(0,D.safeStringify)(i):i instanceof Date?E[r]=i.toISOString():(0,R.isObject)(i)?v<2?y(i,E,v+1,r+"."):E[r]=(0,D.safeStringify)(i):E[r]=i}}function w(f){if(!f)return[];const E=[];return g(E,"",f),E}function g(f,E,v){v&&typeof v=="object"&&!Array.isArray(v)?Object.keys(v).forEach(m=>g(f,E?`${E}.${m}`:m,v[m])):f.push(E)}function u(f){return[f.appRoot,f.extensionsPath,f.userHome.fsPath,f.tmpDir.fsPath,f.userDataPath]}t.getPiiPathsFromEnvironment=u}),define(J[119],Y([0,1,91,36]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=void 0;async function b(I,T,P,l,p,C){const L={"X-Market-Client-Id":`VSCode ${I}`,"User-Agent":`VSCode ${I} (${T.nameShort})`},d=await(0,D.getServiceMachineId)(P,p,C);return(0,R.supportsTelemetry)(T,P)&&(0,R.getTelemetryLevel)(l)===3&&(L["X-Market-User-Id"]=d),L}t.resolveMarketplaceHeaders=b}),define(J[120],Y([0,1,18,24,8,22,12,29,6,9,25,20,23,21,48,16,14,32,42,119,116,31]),function(j,t,D,R,b,I,T,P,l,p,C,L,d,y,w,g,u,f,E,v,m,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const i=T.isWeb?"web":(0,d.getTargetPlatform)(T.platform,P.arch);var r;(function(A){A[A.None=0]="None",A[A.IncludeVersions=1]="IncludeVersions",A[A.IncludeFiles=2]="IncludeFiles",A[A.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",A[A.IncludeSharedAccounts=8]="IncludeSharedAccounts",A[A.IncludeVersionProperties=16]="IncludeVersionProperties",A[A.ExcludeNonValidated=32]="ExcludeNonValidated",A[A.IncludeInstallationTargets=64]="IncludeInstallationTargets",A[A.IncludeAssetUri=128]="IncludeAssetUri",A[A.IncludeStatistics=256]="IncludeStatistics",A[A.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",A[A.Unpublished=4096]="Unpublished",A[A.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function e(...A){return String(A.reduce((F,z)=>F|z,0))}var n;(function(A){A[A.Tag=1]="Tag",A[A.ExtensionId=4]="ExtensionId",A[A.Category=5]="Category",A[A.ExtensionName=7]="ExtensionName",A[A.Target=8]="Target",A[A.Featured=9]="Featured",A[A.SearchText=10]="SearchText",A[A.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},h={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class S{constructor(F=h){this.state=F}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(F,z=this.state.pageSize){return new S({...this.state,pageNumber:F,pageSize:z})}withFilter(F,...z){const W=[...this.state.criteria,...z.length?z.map(G=>({filterType:F,value:G})):[{filterType:F}]];return new S({...this.state,criteria:W})}withSortBy(F){return new S({...this.state,sortBy:F})}withSortOrder(F){return new S({...this.state,sortOrder:F})}withFlags(...F){return new S({...this.state,flags:F.reduce((z,W)=>z|W,0)})}withAssetTypes(...F){return new S({...this.state,assetTypes:F})}get raw(){const{criteria:F,pageNumber:z,pageSize:W,sortBy:G,sortOrder:q,flags:re,assetTypes:ae}=this.state;return{filters:[{criteria:F,pageNumber:z,pageSize:W,sortBy:G,sortOrder:q}],assetTypes:ae,flags:re}}get searchText(){const F=this.state.criteria.filter(z=>z.filterType===n.SearchText)[0];return F&&F.value?F.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(F=>String(F.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(A,F){const z=(A||[]).filter(W=>W.statisticName===F)[0];return z?z.value:0}function M(A){const F="Microsoft.VisualStudio.Code.Translation.";return A.files.filter(W=>W.assetType.indexOf(F)===0).reduce((W,G)=>{const q=ee(A,G.assetType);return q&&W.push([G.assetType.substring(F.length),q]),W},[])}function _(A){if(A.properties){const F=A.properties.filter(G=>G.key===o.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=F.filter(G=>z.test(G.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return ee(A,o.Repository)}function X(A){return{uri:`${A.fallbackAssetUri}/${o.VSIX}?redirect=true${A.targetPlatform?`&targetPlatform=${A.targetPlatform}`:""}`,fallbackUri:`${A.fallbackAssetUri}/${o.VSIX}${A.targetPlatform?`?targetPlatform=${A.targetPlatform}`:""}`}}function ee(A,F){return A.files.filter(W=>W.assetType===F)[0]?{uri:`${A.assetUri}/${F}${A.targetPlatform?`?targetPlatform=${A.targetPlatform}`:""}`,fallbackUri:`${A.fallbackAssetUri}/${F}${A.targetPlatform?`?targetPlatform=${A.targetPlatform}`:""}`}:null}function te(A,F){const z=A.properties?A.properties.filter(G=>G.key===F):[],W=z.length>0&&z[0].value;return W?W.split(",").map(G=>(0,y.adoptToGalleryExtensionId)(G)):[]}function ie(A){const F=A.properties?A.properties.filter(z=>z.key===a.Engine):[];return F.length>0&&F[0].value||""}function ue(A){const F=A.properties?A.properties.filter(z=>z.key===a.PreRelease):[];return F.length>0&&F[0].value==="true"}function he(A){const F=A.properties?A.properties.filter(W=>W.key===a.LocalizedLanguages):[],z=F.length>0&&F[0].value||"";return z?z.split(","):[]}function V(A){return A.indexOf("preview")!==-1}function Z(A){return A.targetPlatform?(0,d.toTargetPlatform)(A.targetPlatform):"undefined"}function U(A){const F=(0,D.distinct)(A.versions.map(Z)),z=!!A.tags?.includes(d.WEB_EXTENSION_TAG),W=F.indexOf("web");return z?W===-1&&F.push("web"):W!==-1&&F.splice(W,1),F}function k(A,F){const z=(0,d.getFallbackTargetPlarforms)(F);for(let W=0;W<A.length;W++){const G=A[W];if(G.version===A[W-1]?.version){let q=W;const re=Z(G);if(re===F)for(;q>0&&A[q-1].version===G.version;)q--;else if(z.includes(re))for(;q>0&&A[q-1].version===G.version&&Z(A[q-1])!==F;)q--;q!==W&&(A.splice(W,1),A.splice(q,0,G))}}return A}t.sortExtensionVersions=k;function x(A,F,z){A.telemetryData={index:F,querySource:z}}function H(A,F,z){const W=A.versions[0],G={manifest:ee(F,o.Manifest),readme:ee(F,o.Details),changelog:ee(F,o.Changelog),license:ee(F,o.License),repository:_(F),download:X(F),icon:ee(F,o.Icon),coreTranslations:M(F)};return{identifier:{id:(0,y.getGalleryExtensionId)(A.publisher.publisherName,A.extensionName),uuid:A.extensionId},name:A.extensionName,version:F.version,displayName:A.displayName,publisherId:A.publisher.publisherId,publisher:A.publisher.publisherName,publisherDisplayName:A.publisher.displayName,publisherDomain:A.publisher.domain?{link:A.publisher.domain,verified:!!A.publisher.isDomainVerified}:void 0,description:A.shortDescription||"",installCount:O(A.statistics,"install"),rating:O(A.statistics,"averagerating"),ratingCount:O(A.statistics,"ratingcount"),categories:A.categories||[],tags:A.tags||[],releaseDate:Date.parse(A.releaseDate),lastUpdated:Date.parse(A.lastUpdated),allTargetPlatforms:z,assets:G,properties:{dependencies:te(F,a.Dependency),extensionPack:te(F,a.ExtensionPack),engine:ie(F),localizedLanguages:he(F),targetPlatform:Z(F),isPreReleaseVersion:ue(F)},hasPreReleaseVersion:ue(W),hasReleaseVersion:!0,preview:V(A.flags)}}let ne=class{constructor(F,z,W,G,q,re,ae,pe){this.requestService=z,this.logService=W,this.environmentService=G,this.telemetryService=q,this.fileService=re,this.productService=ae,this.configurationService=pe;const fe=ae.extensionsGallery;this.extensionsGalleryUrl=fe&&fe.serviceUrl,this.extensionsControlUrl=fe&&fe.controlUrl,this.commonHeadersPromise=(0,v.resolveMarketplaceHeaders)(ae.version,ae,this.environmentService,this.configurationService,this.fileService,F)}api(F=""){return`${this.extensionsGalleryUrl}${F}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(F,z,W){const G=R.CancellationToken.isCancellationToken(z)?{}:z,q=R.CancellationToken.isCancellationToken(z)?z:W,re=[],ae=[],pe=[],fe=[];let se=!0;for(const me of F){me.uuid?ae.push(me.uuid):re.push(me.id);const we=!!(me.version||me.preRelease);pe.push({id:me.id,uuid:me.uuid,includePreRelease:we}),me.version&&fe.push({id:me.id,uuid:me.uuid,version:me.version}),se=se&&!!me.hasPreRelease&&!we}if(!ae.length&&!re.length)return[];let ce=new S().withPage(1,F.length);ae.length&&(ce=ce.withFilter(n.ExtensionId,...ae)),re.length&&(ce=ce.withFilter(n.ExtensionName,...re)),(G.queryAllVersions||se)&&(ce=ce.withFlags(ce.flags,r.IncludeVersions));const{extensions:ye}=await this.queryGalleryExtensions(ce,{targetPlatform:G.targetPlatform??i,includePreRelease:pe,versions:fe,compatible:!!G.compatible},q);return G.source&&ye.forEach((me,we)=>x(me,we,G.source)),ye}async getCompatibleExtension(F,z,W){if((0,d.isNotWebExtensionInWebTargetPlatform)(F.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(F,z,W))return F;const G=new S().withFlags(r.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,F.identifier.uuid),{extensions:q}=await this.queryGalleryExtensions(G,{targetPlatform:W,compatible:!0,includePreRelease:z},R.CancellationToken.None);return q[0]||null}async isExtensionCompatible(F,z,W){if(!(0,d.isTargetPlatformCompatible)(F.properties.targetPlatform,F.allTargetPlatforms,W)||!z&&F.properties.isPreReleaseVersion)return!1;let G=F.properties.engine;if(!G){const q=await this.getManifest(F,R.CancellationToken.None);if(!q)throw new Error("Manifest was not found");G=q.engines.vscode}return(0,w.isEngineValid)(G,this.productService.version,this.productService.date)}async isValidVersion(F,z,W,G,q){if(!(0,d.isTargetPlatformCompatible)(Z(F),G,q)||z!=="any"&&ue(F)!==(z==="prerelease"))return!1;if(W){const re=await this.getEngine(F);if(!(0,w.isEngineValid)(re,this.productService.version,this.productService.date))return!1}return!0}async query(F,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let W=F.text||"";const G=(0,I.getOrDefault)(F,se=>se.pageSize,50);let q=new S().withPage(1,G);W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,ce,ye)=>(q=q.withFilter(n.Category,ye||ce),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,ce,ye)=>(q=q.withFilter(n.Tag,ye||ce),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(q=q.withFilter(n.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),q=q.withFilter(n.SearchText,W)),q=q.withSortBy(0)):F.ids?q=q.withFilter(n.ExtensionId,...F.ids):F.names?q=q.withFilter(n.ExtensionName,...F.names):q=q.withSortBy(4),typeof F.sortBy=="number"&&(q=q.withSortBy(F.sortBy)),typeof F.sortOrder=="number"&&(q=q.withSortOrder(F.sortOrder));const re=async(se,ce)=>{const{extensions:ye,total:me}=await this.queryGalleryExtensions(se,{targetPlatform:i,compatible:!1,includePreRelease:!!F.includePreRelease},ce);return ye.forEach((we,Ne)=>x(we,(se.pageNumber-1)*se.pageSize+Ne,F.source)),{extensions:ye,total:me}},{extensions:ae,total:pe}=await re(q,z),fe=async(se,ce)=>{if(ce.isCancellationRequested)throw new b.CancellationError;const{extensions:ye}=await re(q.withPage(se+1),ce);return ye};return{firstPage:ae,total:pe,pageSize:q.pageSize,getPage:fe}}async queryGalleryExtensions(F,z,W){const G=F.flags;!!(F.flags&r.IncludeLatestVersionOnly)&&!!(F.flags&r.IncludeVersions)&&(F=F.withFlags(F.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(F.flags&r.IncludeLatestVersionOnly)&&!(F.flags&r.IncludeVersions)&&(F=F.withFlags(F.flags,r.IncludeLatestVersionOnly)),z.versions?.length&&(F=F.withFlags(F.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),F=F.withFlags(F.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:q,total:re}=await this.queryRawGalleryExtensions(F,W);if(!(F.flags&r.IncludeLatestVersionOnly)){const se=[];for(const ce of q){const ye=await this.toGalleryExtensionWithCriteria(ce,z,!0);ye&&se.push(ye)}return{extensions:se,total:re}}const pe=[],fe=new Map;for(let se=0;se<q.length;se++){const ce=q[se],ye={id:(0,y.getGalleryExtensionId)(ce.publisher.publisherName,ce.extensionName),uuid:ce.extensionId},me=(0,l.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Ne=>(0,y.areSameExtensions)(Ne,ye))?.includePreRelease;let we=await this.toGalleryExtensionWithCriteria(ce,z,!1);!we||we.properties.isPreReleaseVersion&&(!me||!we.hasReleaseVersion)||!we.properties.isPreReleaseVersion&&we.properties.targetPlatform!==z.targetPlatform&&we.hasPreReleaseVersion?fe.set(ce.extensionId,se):pe.push([se,we])}if(fe.size){const se=new Date().getTime(),ce=new S().withFlags(G&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,fe.size).withFilter(n.ExtensionId,...fe.keys()),{extensions:ye}=await this.queryGalleryExtensions(ce,z,W);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-se,count:fe.size});for(const me of ye){const we=fe.get(me.identifier.uuid);pe.push([we,me])}}return{extensions:pe.sort((se,ce)=>se[0]-ce[0]).map(([,se])=>se),total:re}}async toGalleryExtensionWithCriteria(F,z,W){const G={id:(0,y.getGalleryExtensionId)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},q=z.versions?.find(fe=>(0,y.areSameExtensions)(fe,G))?.version,re=(0,l.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(fe=>(0,y.areSameExtensions)(fe,G))?.includePreRelease,ae=U(F),pe=k(F.versions,z.targetPlatform);if(z.compatible&&W&&(0,d.isNotWebExtensionInWebTargetPlatform)(ae,z.targetPlatform))return null;for(let fe=0;fe<pe.length;fe++){const se=pe[fe];if(!(q&&se.version!==q)){if(await this.isValidVersion(se,re?"any":"release",z.compatible,ae,z.targetPlatform))return H(F,se,ae);if(q&&se.version===q)return null}}return q||z.compatible?null:H(F,F.versions[0],ae)}async queryRawGalleryExtensions(F,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");F=F.withFlags(F.flags,r.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,e(r.Unpublished));const W=await this.commonHeadersPromise,G=JSON.stringify(F.raw),q={...W,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},re=new Date().getTime();let ae,pe,fe=0;try{if(ae=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:G,headers:q},z),ae.res.statusCode&&ae.res.statusCode>=400&&ae.res.statusCode<500)return{galleryExtensions:[],total:fe};const se=await(0,E.asJson)(ae);if(se){const ce=se.results[0],ye=ce.extensions,me=ce.resultMetadata&&ce.resultMetadata.filter(we=>we.metadataType==="ResultCount")[0];return fe=me&&me.metadataItems.filter(we=>we.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:fe}}return{galleryExtensions:[],total:fe}}catch(se){throw pe=se,se}finally{this.telemetryService.publicLog2("galleryService:query",{...F.telemetryData,requestBodySize:String(G.length),duration:new Date().getTime()-re,success:!!ae&&(0,E.isSuccess)(ae),responseBodySize:ae?.res.headers["Content-Length"],statusCode:ae?String(ae.res.statusCode):void 0,errorCode:pe?(0,b.isCancellationError)(pe)?"canceled":(0,b.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(fe)})}}async reportStatistic(F,z,W,G){if(!this.isEnabled())return;const q=T.isWeb?this.api(`/itemName/${F}.${z}/version/${W}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${F}/extensions/${z}/${W}/stats?statType=${G}`),re=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.commonHeadersPromise,Accept:re};try{await this.requestService.request({type:"POST",url:q,headers:pe},R.CancellationToken.None)}catch{}}async download(F,z,W){this.logService.trace("ExtensionGalleryService#download",F.identifier.id);const G=(0,y.getGalleryExtensionTelemetryData)(F),q=new Date().getTime(),re=se=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...G,duration:se}),ae=W===2?"install":W===3?"update":"",pe=ae?{uri:`${F.assets.download.uri}${p.URI.parse(F.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${F.assets.download.fallbackUri}${p.URI.parse(F.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:F.assets.download,fe=await this.getAsset(pe);await this.fileService.writeFile(z,fe.stream),re(new Date().getTime()-q)}async getReadme(F,z){if(F.assets.readme){const W=await this.getAsset(F.assets.readme,{},z);return await(0,E.asText)(W)||""}return""}async getManifest(F,z){if(F.assets.manifest){const W=await this.getAsset(F.assets.manifest,{},z),G=await(0,E.asText)(W);return G?JSON.parse(G):null}return null}async getManifestFromRawExtensionVersion(F,z){const W=ee(F,o.Manifest);if(!W)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},q=await this.getAsset(W,{headers:G});return await(0,E.asJson)(q)}async getCoreTranslation(F,z){const W=F.assets.coreTranslations.filter(G=>G[0]===z.toUpperCase())[0];if(W){const G=await this.getAsset(W[1]),q=await(0,E.asText)(G);return q?JSON.parse(q):null}return null}async getChangelog(F,z){if(F.assets.changelog){const W=await this.getAsset(F.assets.changelog,{},z);return await(0,E.asText)(W)||""}return""}async getAllCompatibleVersions(F,z,W){let G=new S().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);F.identifier.uuid?G=G.withFilter(n.ExtensionId,F.identifier.uuid):G=G.withFilter(n.ExtensionName,F.identifier.id);const{galleryExtensions:q}=await this.queryRawGalleryExtensions(G,R.CancellationToken.None);if(!q.length)return[];const re=U(q[0]);if((0,d.isNotWebExtensionInWebTargetPlatform)(re,W))return[];const ae=[],pe=new Set;return await Promise.all(q[0].versions.map(async fe=>{try{if(pe.has(fe.version))return;await this.isValidVersion(fe,z?"any":"release",!0,re,W)&&(ae.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:ue(fe)}),pe.add(fe.version))}catch{}})),ae}async getAsset(F,z={},W=R.CancellationToken.None){const G=await this.commonHeadersPromise,q={type:"GET"},re={...G,...z.headers||{}};z={...z,...q,headers:re};const ae=F.uri,pe=F.fallbackUri,fe={...z,url:ae};try{const se=await this.requestService.request(fe,W);if(se.res.statusCode===200)return se;const ce=await(0,E.asText)(se);throw new Error(`Expected 200, got back ${se.res.statusCode} instead.

${ce}`)}catch(se){if((0,b.isCancellationError)(se))throw se;const ce=(0,b.getErrorMessage)(se);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ae,message:ce});const ye={...z,url:pe};return this.requestService.request(ye,W)}}async getEngine(F){let z=ie(F);if(!z){const W=await this.getManifestFromRawExtensionVersion(F,R.CancellationToken.None);if(!W)throw new Error("Manifest was not found");z=W.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const F=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(F.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,E.asJson)(F),W=[],G={};if(z){for(const q of z.malicious)W.push({id:q});if(z.unsupported)for(const q of Object.keys(z.unsupported)){const re=z.unsupported[q];(0,l.isBoolean)(re)||(G[q.toLowerCase()]=re.preReleaseExtension)}if(z.migrateToPreRelease)for(const[q,re]of Object.entries(z.migrateToPreRelease))(!re.engine||(0,w.isEngineValid)(re.engine,this.productService.version,this.productService.date))&&(G[q.toLowerCase()]=re)}return{malicious:W,unsupportedPreReleaseExtensions:G}}};ne=ge([oe(1,E.IRequestService),oe(2,u.ILogService),oe(3,L.IEnvironmentService),oe(4,s.ITelemetryService),oe(5,g.IFileService),oe(6,f.IProductService),oe(7,C.IConfigurationService)],ne);let K=class extends ne{constructor(F,z,W,G,q,re,ae,pe){super(F,z,W,G,q,re,ae,pe)}};K=ge([oe(0,m.IStorageService),oe(1,E.IRequestService),oe(2,u.ILogService),oe(3,L.IEnvironmentService),oe(4,s.ITelemetryService),oe(5,g.IFileService),oe(6,f.IProductService),oe(7,C.IConfigurationService)],K),t.ExtensionGalleryService=K;let Q=class extends ne{constructor(F,z,W,G,q,re,ae){super(void 0,F,z,W,G,q,re,ae)}};Q=ge([oe(0,E.IRequestService),oe(1,u.ILogService),oe(2,L.IEnvironmentService),oe(3,s.ITelemetryService),oe(4,g.IFileService),oe(5,f.IProductService),oe(6,C.IConfigurationService)],Q),t.ExtensionGalleryServiceWithNoStorageService=Q}),define(J[121],Y([0,1,2,22,12,26,85,25,34,122,30,31,36]),function(j,t,D,R,b,I,T,P,l,p,C,L,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let y=class{constructor(u,f){this._configurationService=f,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=u.appenders,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let E of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,I.escapeRegExpCharacters)(E),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(u,f){this._experimentProperties[u]=f}_updateTelemetryLevel(){this._telemetryLevel=(0,d.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const u=await this._commonProperties;let f=u.sessionID,E=u["common.machineId"],v=u["common.firstSessionDate"],m=u["common.msftInternal"];return{sessionId:f,machineId:E,firstSessionDate:v,msftInternal:m}}dispose(){this._disposables.dispose()}_log(u,f,E,v){return this.telemetryLevel<f?Promise.resolve(void 0):this._commonProperties.then(m=>{E=(0,R.mixin)(E,m),E=(0,R.mixin)(E,this._experimentProperties),E=(0,R.cloneAndChange)(E,s=>{if(typeof s=="string")return this._cleanupInfo(s,v)}),this._appenders.forEach(s=>s.log(u,E))},m=>{console.error(m)})}publicLog(u,f,E){return this._log(u,3,f,E)}publicLog2(u,f,E){return this.publicLog(u,f,E)}publicLogError(u,f){return this.sendErrorTelemetry?this._log(u,2,f,!0):Promise.resolve(void 0)}publicLogError2(u,f){return this.publicLogError(u,f)}_anonymizeFilePaths(u){let f=u;const E=[];for(let i of this._cleanupPatterns)for(;;){const r=i.exec(u);if(!r)break;E.push([r.index,i.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(f="";;){const i=m.exec(u);if(!i)break;!v.test(i[0])&&E.every(([r,e])=>i.index<r||i.index>=e)&&(f+=u.substring(s,i.index)+"<REDACTED: user-file-path>",s=m.lastIndex)}return s<u.length&&(f+=u.substr(s)),f}_removePropertiesWithPossibleUserInfo(u){if(!u)return u;const f=u.toLowerCase(),E=/@[a-zA-Z0-9-.]+/,v=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,m=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return v.test(f)?"<REDACTED: secret>":E.test(f)?"<REDACTED: email>":m.test(f)?"<REDACTED: token>":u}_cleanupInfo(u,f){let E=u;f&&(E=this._anonymizeFilePaths(E));for(let v of this._cleanupPatterns)E=E.replace(v,"");return E=this._removePropertiesWithPossibleUserInfo(E),E}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=ge([oe(1,P.IConfigurationService)],y),t.TelemetryService=y;function w(){const g=(0,T.localize)(0,null,p.default.nameLong),u=p.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",p.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=b.isWeb?"":(0,T.localize)(3,null),E=(0,T.localize)(4,null),v=(0,T.localize)(5,null),m=(0,T.localize)(6,null),s=(0,T.localize)(7,null),i=`
|       | ${E} | ${v} | ${m} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,T.localize)(8,null);return`
${g} ${u} ${f}

&nbsp;

${s}
${i}

&nbsp;

${r}
`}C.Registry.as(l.Extensions.Configuration).registerConfiguration({id:L.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(9,null),properties:{[L.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),C.Registry.as(l.Extensions.Configuration).registerConfiguration({id:L.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[L.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:p.default.privacyStatementUrl?(0,T.localize)(16,null,p.default.nameLong,p.default.privacyStatementUrl):(0,T.localize)(15,null,p.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${L.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[123],Y([0,1,8,22,36]),function(j,t,D,R,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function I(P,l){const p=await new Promise((L,d)=>{j(["applicationinsights"],L,d)});let C;return p.defaultClient?(C=new p.TelemetryClient(P),C.channel.setUseDiskRetryCaching(!0)):(p.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),C=p.defaultClient),P.indexOf("AIF-")===0&&(C.config.endpointUrl=l?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),C}class T{constructor(l,p,C,L,d){this._eventPrefix=l,this._defaultData=p,this.testCollector=L,this.mirrored=d,this._defaultData||(this._defaultData=Object.create(null)),typeof C=="function"?this._aiClient=C():this._aiClient=C,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=I(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(p=>{l(p)},p=>{(0,D.onUnexpectedError)(p),console.error(p)})}}log(l,p){if(!!this._aiClient){p=(0,R.mixin)(p,this._defaultData),p=(0,b.validateTelemetryData)(p),this.testCollector&&(p.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++");try{this._withAIClient(C=>C.trackEvent({name:this._eventPrefix+"/"+l,properties:p.properties,measurements:p.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(p=>{try{p.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})}catch{}})}):Promise.resolve(void 0)}}t.AppInsightsAppender=T}),define(J[124],Y([0,1,10,15]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function b(I,T){const P=Object.create(null),l=(C,L)=>{const d=JSON.parse(C);P[L]=d};if(T){const C=[],L=await R.Promises.readdir(T);for(const y of L)try{(await R.Promises.stat((0,D.join)(T,y))).isDirectory()&&C.push(y)}catch{}const d=[];for(const y of C)(await R.Promises.readdir((0,D.join)(T,y))).filter(g=>g==="telemetry.json").length===1&&d.push(y);for(const y of d){const w=(await R.Promises.readFile((0,D.join)(T,y,"telemetry.json"))).toString();l(w,y)}}let p=(await R.Promises.readFile((0,D.join)(I,"telemetry-core.json"))).toString();return l(p,"vscode-core"),p=(await R.Promises.readFile((0,D.join)(I,"telemetry-extensions.json"))).toString(),l(p,"vscode-extensions"),JSON.stringify(P,null,4)}t.buildTelemetryMessage=b}),define(J[125],Y([0,1,39,10,86,24,28,8,12,27,70,138,3]),function(j,t,D,R,b,I,T,P,l,p,C,L,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getResolvedShellEnv=void 0;const y=1e4;let w;async function g(f,E,v){return E["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,L.isLaunchedFromCli)(v)&&!E["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,L.isLaunchedFromCli)(v)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=d.Promises.withAsyncBody(async(m,s)=>{const i=new I.CancellationTokenSource,r=setTimeout(()=>{i.dispose(!0),s(new Error((0,b.localize)(0,null)))},y);try{m(await u(f,i.token))}catch(e){!(0,P.isCancellationError)(e)&&!i.token.isCancellationRequested?s(new Error((0,b.localize)(1,null,(0,T.toErrorMessage)(e)))):m({})}finally{clearTimeout(r),i.dispose()}})),w)}t.getResolvedShellEnv=g;async function u(f,E){const v=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",v);const m=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",m);const s=(0,p.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(s+"(.*)"+s),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};f.trace("getUnixShellEnvironment#env",r);const e=await(0,C.getSystemShell)(l.OS,r);return f.trace("getUnixShellEnvironment#shell",e),new Promise((n,o)=>{if(E.isCancellationRequested)return o((0,P.canceled)());const a=(0,R.basename)(e);let c,h;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(c=`& '${process.execPath}' ${S} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,h=["-Login","-Command"]):(c=`'${process.execPath}' ${S} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,a==="tcsh"?h=["-ic"]:h=["-ilc"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),c);const O=(0,D.spawn)(e,[...h,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});E.onCancellationRequested(()=>(O.kill(),o((0,P.canceled)()))),O.on("error",X=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(X)),o(X)});const M=[];O.stdout.on("data",X=>M.push(X));const _=[];O.stderr.on("data",X=>_.push(X)),O.on("close",(X,ee)=>{const te=Buffer.concat(M).toString("utf8");f.trace("getUnixShellEnvironment#raw",te);const ie=Buffer.concat(_).toString("utf8");if(ie.trim()&&f.trace("getUnixShellEnvironment#stderr",ie),X||ee)return o(new Error((0,b.localize)(2,null,X,ee)));const ue=i.exec(te),he=ue?ue[1]:"{}";try{const V=JSON.parse(he);v?V.ELECTRON_RUN_AS_NODE=v:delete V.ELECTRON_RUN_AS_NODE,m?V.ELECTRON_NO_ATTACH_CONSOLE=m:delete V.ELECTRON_NO_ATTACH_CONSOLE,delete V.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",V),n(V)}catch(V){f.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(V)),o(V)}})})}}),define(J[37],Y([0,1,13]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IUriIdentityService=void 0,t.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(J[126],Y([0,1,7,2,9,20,21,16,14,37]),function(j,t,D,R,b,I,T,P,l,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let C=class extends R.Disposable{constructor(d,y,w,g,u){super();this.extensionsManagementService=d,this.logService=g,this.uriIdentityService=u,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(E=>{this.installedExtensions=E.map(v=>v.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(E=>this.onInstallExtension(E))),this._register(d.onDidInstallExtensions(E=>this.onDidInstallExtensions(E))),this._register(d.onDidUninstallExtension(E=>this.onDidUninstallExtension(E)));const f=b.URI.file(w.extensionsPath);this._register(y.watch(f)),this._register(D.Event.filter(y.onDidFilesChange,E=>E.rawChanges.some(v=>this.doesChangeAffects(v,f)))(()=>this.onDidChange()))}doesChangeAffects(d,y){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(d.resource),y)?this.uriIdentityService.extUri.isEqual(d.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!(d.type!==1&&d.type!==2||this.uriIdentityService.extUri.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const y of d)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(y=>!(0,T.areSameExtensions)(y,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,T.areSameExtensions)(y,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),y=d.filter(g=>[...this.installingExtensions,...this.installedExtensions].some(u=>(0,T.areSameExtensions)(u,g.identifier))?!1:g.installedTimestamp&&g.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",g.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",g.identifier.id),!1)),w=this.installedExtensions.filter(g=>this.installingExtensions.some(u=>(0,T.areSameExtensions)(u,g))?!1:d.every(u=>!(0,T.areSameExtensions)(u.identifier,g))?(this.logService.info("Detected extension removed from another source",g.id),!0):!1);this.installedExtensions=d.map(g=>g.identifier),(y.length||w.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:w})}}};C=ge([oe(1,P.IFileService),oe(2,I.INativeEnvironmentService),oe(3,l.ILogService),oe(4,p.IUriIdentityService)],C),t.ExtensionsWatcher=C}),define(J[127],Y([0,1,37,92,16,19,58,7,2]),function(j,t,D,R,b,I,T,P,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UriIdentityService=void 0;class p{constructor(d){this.uri=d,this.time=p._clock++}touch(){return this.time=p._clock++,this}}p._clock=0;let C=class{constructor(d){this._fileService=d,this._dispooables=new l.DisposableStore,this._limit=2**16;const y=new Map,w=g=>{let u=y.get(g.scheme);return u===void 0&&(u=d.hasProvider(g)&&!this._fileService.hasCapability(g,1024),y.set(g.scheme,u)),u};this._dispooables.add(P.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(g=>{y.delete(g.scheme)})),this.extUri=new I.ExtUri(w),this._canonicalUris=new T.SkipList((g,u)=>this.extUri.compare(g,u,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,I.normalizePath)(d));let y=this._canonicalUris.get(d);return y?y.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new p(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((w,g)=>w[1].touch<g[1].touch?1:w[1].touch>g[1].touch?-1:0);p._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let w=0;w<y;w++)this._canonicalUris.set(d[w][0],d[w][1].touch())}};C=ge([oe(0,b.IFileService)],C),t.UriIdentityService=C,(0,R.registerSingleton)(D.IUriIdentityService,C,!0)}),define(J[43],Y([0,1,103,3,10,6,15,72,139,140]),function(j,t,D,R,b,I,T,P,l,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class C extends Error{constructor(i,r){let e=r.message;switch(i){case"CorruptZip":e=`Corrupt ZIP: ${e}`;break}super(e);this.type=i,this.cause=r}}t.ExtractError=C;function L(s){const i=s.externalFileAttributes>>16||33188;return[448,56,7].map(r=>i&r).reduce((r,e)=>r+e,i&61440)}function d(s){if(s instanceof C)return s;let i;return/end of central directory record signature not found/.test(s.message)&&(i="CorruptZip"),new C(i,s)}function y(s,i,r,e,n,o){const a=b.dirname(i),c=b.join(e,a);if(!c.startsWith(e))return Promise.reject(new Error(P.localize(0,null,i)));const h=b.join(e,i);let S;return o.onCancellationRequested(()=>{S&&S.destroy()}),Promise.resolve(T.Promises.mkdir(c,{recursive:!0})).then(()=>new Promise((O,M)=>{if(!o.isCancellationRequested)try{S=(0,D.createWriteStream)(h,{mode:r}),S.once("close",()=>O()),S.once("error",M),s.once("error",M),s.pipe(S)}catch(_){M(_)}}))}function w(s,i,r,e){let n=(0,R.createCancelablePromise)(()=>Promise.resolve()),o=0;return e.onCancellationRequested(()=>{n.cancel(),s.close()}),new Promise((a,c)=>{const h=new R.Sequencer,S=O=>{O.isCancellationRequested||(o++,s.readEntry())};s.once("error",c),s.once("close",()=>n.then(()=>{e.isCancellationRequested||s.entryCount===o?a():c(new C("Incomplete",new Error(P.localize(1,null,o,s.entryCount))))},c)),s.readEntry(),s.on("entry",O=>{if(e.isCancellationRequested)return;if(!r.sourcePathRegex.test(O.fileName)){S(e);return}const M=O.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(M)){const ee=b.join(i,M);n=(0,R.createCancelablePromise)(te=>T.Promises.mkdir(ee,{recursive:!0}).then(()=>S(te)).then(void 0,c));return}const _=u(s,O),X=L(O);n=(0,R.createCancelablePromise)(ee=>h.queue(()=>_.then(te=>y(te,M,X,i,r,ee).then(()=>S(ee)))).then(null,c))})})}function g(s,i=!1){return new Promise((r,e)=>{(0,l.open)(s,i?{lazyEntries:!0}:void 0,(n,o)=>{n?e(d(n)):r((0,I.assertIsDefined)(o))})})}function u(s,i){return new Promise((r,e)=>{s.openReadStream(i,(n,o)=>{n?e(d(n)):r((0,I.assertIsDefined)(o))})})}function f(s,i){return new Promise((r,e)=>{const n=new p.ZipFile;i.forEach(a=>{a.contents?n.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&n.addFile(a.localPath,a.path)}),n.end();const o=(0,D.createWriteStream)(s);n.outputStream.pipe(o),n.outputStream.once("error",e),o.once("error",e),o.once("finish",()=>r(s))})}t.zip=f;function E(s,i,r={},e){const n=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let o=g(s,!0);return r.overwrite&&(o=o.then(a=>T.Promises.rm(i).then(()=>a))),o.then(a=>w(a,i,{sourcePathRegex:n},e))}t.extract=E;function v(s,i){return g(s).then(r=>new Promise((e,n)=>{r.on("entry",o=>{o.fileName===i&&u(r,o).then(a=>e(a),a=>n(a))}),r.once("close",()=>n(new Error(P.localize(2,null,i))))}))}function m(s,i){return v(s,i).then(r=>new Promise((e,n)=>{const o=[];r.once("error",n),r.on("data",a=>o.push(a)),r.on("end",()=>e(Buffer.concat(o)))}))}t.buffer=m}),define(J[128],Y([0,1,43,78]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function b(I){return(0,D.buffer)(I,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}t.getManifest=b}),define(J[129],Y([0,1,18,3,8,2,11,10,12,19,41,9,27,15,43,79,20,23,21,90,35,16,14,32]),function(j,t,D,R,b,I,T,P,l,p,C,L,d,y,w,g,u,f,E,v,m,s,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;let e=class extends I.Disposable{constructor(o,a,c,h,S){super();this.beforeRemovingExtension=o,this.fileService=a,this.logService=c,this.environmentService=h,this.productService=S,this._devSystemExtensionsPath=null,this.systemExtensionsPath=h.builtinExtensionsPath,this.extensionsPath=h.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(o){const a=[];(o===null||o===0)&&a.push(this.scanSystemExtensions().then(null,c=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(c).message,f.ExtensionManagementErrorCode.Internal)))),(o===null||o===1)&&a.push(this.scanUserExtensions(!0).then(null,c=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(c).message,f.ExtensionManagementErrorCode.Internal))));try{const c=await Promise.all(a);return(0,D.flatten)(c)}catch(c){throw this.joinErrors(c)}}async scanUserExtensions(o){this.logService.trace("Started scanning user extensions");let[a,c]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return c=c.filter(h=>!a[new E.ExtensionIdentifierWithVersion(h.identifier,h.manifest.version).key()]),o&&(c=(0,E.groupByExtension)(c,S=>S.identifier).map(S=>S.sort((O,M)=>C.rcompare(O.manifest.version,M.manifest.version))[0])),this.logService.trace("Scanned user extensions:",c.length),c}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(o,a,c,h){const S=o.key(),O=P.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),M=P.join(this.extensionsPath,S);try{await y.Promises.rm(M)}catch{try{await y.Promises.rm(M)}catch{}throw new f.ExtensionManagementError((0,g.localize)(0,null,M,o.id),f.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(o,a,O,h);let _=await this.scanExtension(L.URI.file(O),1);if(!_)throw new Error((0,g.localize)(1,null,O));await this.storeMetadata(_,{...c,installedTimestamp:Date.now()});try{await this.rename(o,O,M,Date.now()+2*60*1e3),this.logService.info("Renamed to",M)}catch(X){try{await y.Promises.rm(O)}catch{}if(X.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",o.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(X)}. Deleted from extracted location`,O),X}try{_=await this.scanExtension(L.URI.file(M),1)}catch{}if(_)return _;throw new Error((0,g.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(o,a){return this.setMetadata(o,a),await this.storeMetadata(o,{...a,installedTimestamp:o.installedTimestamp}),o}async storeMetadata(o,a){a.isMachineScoped=a.isMachineScoped||void 0,a.isBuiltin=a.isBuiltin||void 0,a.installedTimestamp=a.installedTimestamp||void 0;const c=P.join(o.location.fsPath,"package.json"),h=await y.Promises.readFile(c,"utf8"),{manifest:S}=await this.parseManifest(h);return S.__metadata=a,await y.Promises.writeFile(c,JSON.stringify(S,null,"	")),o}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...o){const a=o.map(c=>new E.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version));await this.withUninstalledExtensions(c=>{a.forEach(h=>c[h.key()]=!0)})}async setInstalled(o){await this.withUninstalledExtensions(h=>delete h[o.key()]);const c=(await this.scanExtensions(1)).find(h=>new E.ExtensionIdentifierWithVersion(h.identifier,h.manifest.version).equals(o))||null;return c?(await this.storeMetadata(c,{installedTimestamp:Date.now()}),this.scanExtension(c.location,1)):null}async withUninstalledExtensions(o){return this.uninstalledFileLimiter.queue(async()=>{let a;try{a=await y.Promises.readFile(this.uninstalledPath,"utf8")}catch(h){if(h.code!=="ENOENT")throw h}let c={};if(a)try{c=JSON.parse(a)}catch{}return o&&(o(c),Object.keys(c).length?await y.Promises.writeFile(this.uninstalledPath,JSON.stringify(c)):await y.Promises.rm(this.uninstalledPath)),c})}async removeExtension(o,a){this.logService.trace(`Deleting ${a} extension from disk`,o.identifier.id,o.location.fsPath),await y.Promises.rm(o.location.fsPath),this.logService.info("Deleted from disk",o.identifier.id,o.location.fsPath)}async removeUninstalledExtension(o){await this.removeExtension(o,"uninstalled"),await this.withUninstalledExtensions(a=>delete a[new E.ExtensionIdentifierWithVersion(o.identifier,o.manifest.version).key()])}async extractAtLocation(o,a,c,h){this.logService.trace(`Started extracting the extension from ${a} to ${c}`);try{await y.Promises.rm(c)}catch(S){throw new f.ExtensionManagementError(this.joinErrors(S).message,f.ExtensionManagementErrorCode.Delete)}try{await(0,w.extract)(a,c,{sourcePath:"extension",overwrite:!0},h),this.logService.info(`Extracted extension to ${c}:`,o.id)}catch(S){try{await y.Promises.rm(c)}catch{}let O=f.ExtensionManagementErrorCode.Extract;throw S instanceof w.ExtractError&&(S.type==="CorruptZip"?O=f.ExtensionManagementErrorCode.CorruptZip:S.type==="Incomplete"&&(O=f.ExtensionManagementErrorCode.IncompleteZip)),new f.ExtensionManagementError(S.message,O)}}async rename(o,a,c,h){try{await y.Promises.rename(a,c)}catch(S){if(l.isWindows&&S&&S.code==="EPERM"&&Date.now()<h)return this.logService.info(`Failed renaming ${a} to ${c} with 'EPERM' error. Trying again...`,o.id),this.rename(o,a,c,h);throw new f.ExtensionManagementError(S.message||(0,g.localize)(3,null,a,c),S.code||f.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const o=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return o;const a=this.scanDevSystemExtensions(),[c,h]=await Promise.all([o,a]);return[...c,...h]}async scanExtensionsInDir(o,a){const c=new R.Limiter(10),h=await this.fileService.resolve(L.URI.file(o));return h.children?(await Promise.all(h.children.filter(O=>O.isDirectory).map(O=>c.queue(async()=>a===1&&(0,p.basename)(O.resource).indexOf(".")===0?null:this.scanExtension(O.resource,a))))).filter(O=>O&&O.identifier):[]}async scanExtension(o,a){try{const c=await this.fileService.resolve(o);if(c.children){const{manifest:h,metadata:S}=await this.readManifest(o.fsPath),O=c.children.find(({name:ee})=>/^readme(\.txt|\.md|)$/i.test(ee))?.resource,M=c.children.find(({name:ee})=>/^changelog(\.txt|\.md|)$/i.test(ee))?.resource,_={id:(0,E.getGalleryExtensionId)(h.publisher,h.name)},X={type:a,identifier:_,manifest:h,location:o,readmeUrl:O,changelogUrl:M,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:a===0};return this.setMetadata(X,S),X}}catch(c){a!==0&&this.logService.trace(c)}return null}async scanDefaultSystemExtensions(){const o=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",o.length),o}async scanDevSystemExtensions(){const o=this.getDevSystemExtensionsList();if(o.length){const a=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",a.length),a.filter(c=>o.some(h=>(0,E.areSameExtensions)(c.identifier,{id:h})))}else return[]}setMetadata(o,a){o.publisherDisplayName=a?.publisherDisplayName||null,o.publisherId=a?.publisherId||null,o.identifier.uuid=a?.id,o.isMachineScoped=!!a?.isMachineScoped,o.isPreReleaseVersion=!!a?.isPreReleaseVersion,o.preRelease=!!a?.preRelease,o.isBuiltin=o.type===0||!!a?.isBuiltin,o.installedTimestamp=a?.installedTimestamp}async removeUninstalledExtensions(){const o=await this.getUninstalledExtensions(),a=await this.scanAllUserExtensions(),c=new Set;for(const O of a)o[new E.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]||c.add(O.identifier.id.toLowerCase());const h=(0,E.groupByExtension)(a,O=>O.identifier);await R.Promises.settled(h.map(async O=>{const M=O.sort((_,X)=>C.rcompare(_.manifest.version,X.manifest.version))[0];c.has(M.identifier.id.toLowerCase())||await this.beforeRemovingExtension(M)}));const S=a.filter(O=>o[new E.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]);await R.Promises.settled(S.map(O=>this.removeUninstalledExtension(O)))}async removeOutdatedExtensions(){const o=await this.scanAllUserExtensions(),a=[],c=(0,E.groupByExtension)(o,h=>h.identifier);a.push(...(0,D.flatten)(c.map(h=>h.sort((S,O)=>C.rcompare(S.manifest.version,O.manifest.version)).slice(1)))),await R.Promises.settled(a.map(h=>this.removeExtension(h,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(o=>o.name)}joinErrors(o){const a=Array.isArray(o)?o:[o];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((c,h)=>new Error(`${c.message}${c.message?",":""}${h instanceof Error?h.message:h}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(T.FileAccess.asFileUri("",j).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(o){const a=[y.Promises.readFile(P.join(o,"package.json"),"utf8").then(O=>this.parseManifest(O)),y.Promises.readFile(P.join(o,"package.nls.json"),"utf8").then(void 0,O=>O.code!=="ENOENT"?Promise.reject(O):"{}").then(O=>JSON.parse(O))],[{manifest:c,metadata:h},S]=await Promise.all(a);return{manifest:(0,v.localizeManifest)(c,S),metadata:h}}parseManifest(o){return new Promise((a,c)=>{try{const h=JSON.parse(o);h.publisher||(h.publisher=m.UNDEFINED_PUBLISHER);const S=h.__metadata||null;a({manifest:h,metadata:S})}catch{c(new Error((0,g.localize)(4,null)))}})}};e=ge([oe(1,s.IFileService),oe(2,i.ILogService),oe(3,u.INativeEnvironmentService),oe(4,r.IProductService)],e),t.ExtensionsScanner=e}),define(J[130],Y([0,1,28,8,11,10,12,29,19,41,6,9,27,15,43,77,49,20,118,23,21,110,98,128,111,129,126,48,16,13,14,32,31,37]),function(j,t,D,R,b,I,T,P,l,p,C,L,d,y,w,g,u,f,E,v,m,s,i,r,e,n,o,a,c,h,S,O,M,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;let X=class extends E.AbstractExtensionManagementService{constructor(V,Z,U,k,x,H,ne,K,Q){super(V,Z,U,K);this.environmentService=k,this.downloadService=x,this.fileService=ne;const A=this._register(H.createInstance(i.ExtensionsLifecycle));this.extensionsScanner=this._register(H.createInstance(n.ExtensionsScanner,z=>A.postUninstall(z))),this.manifestCache=this._register(new e.ExtensionsManifestCache(k,this)),this.extensionsDownloader=this._register(H.createInstance(s.ExtensionsDownloader));const F=this._register(new o.ExtensionsWatcher(this,ne,k,U,Q));this._register(F.onDidChangeExtensionsByAnotherSource(({added:z,removed:W})=>{z.length&&this._onDidInstallExtensions.fire(z.map(G=>({identifier:G.identifier,operation:1,local:G}))),W.forEach(G=>this._onDidUninstallExtension.fire({identifier:G}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const V=await this.isAlpineLinux(),Z=(0,v.getTargetPlatform)(V?"alpine":T.platform,P.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",Z),Z})()),this._targetPlatformPromise}async isAlpineLinux(){if(!T.isLinux)return!1;let V;try{V=(await this.fileService.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{V=(await this.fileService.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(U){this.logService.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(U))}}return!!V&&(V.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(V){this.logService.trace("ExtensionManagementService#zip",V.identifier.id);const Z=await this.collectFiles(V),U=await(0,w.zip)((0,l.joinPath)(this.environmentService.tmpDir,(0,d.generateUuid)()).fsPath,Z);return L.URI.file(U)}async unzip(V){return this.logService.trace("ExtensionManagementService#unzip",V.toString()),(await this.install(V)).identifier}async getManifest(V){const Z=await this.downloadVsix(V),U=I.resolve(Z.fsPath);return(0,r.getManifest)(U)}getInstalled(V=null){return this.extensionsScanner.scanExtensions(V)}async install(V,Z={}){this.logService.trace("ExtensionManagementService#install",V.toString());const U=await this.downloadVsix(V),k=await(0,r.getManifest)(I.resolve(U.fsPath));if(k.engines&&k.engines.vscode&&!(0,a.isEngineValid)(k.engines.vscode,this.productService.version,this.productService.date))throw new Error(g.localize(0,null,(0,m.getGalleryExtensionId)(k.publisher,k.name),this.productService.version));return this.installExtension(k,U,Z)}async updateMetadata(V,Z){this.logService.trace("ExtensionManagementService#updateMetadata",V.identifier.id);const U={...V.manifest.__metadata||{},...Z};return Z.isPreReleaseVersion&&(U.preRelease=!0),V=await this.extensionsScanner.saveMetadataForLocalExtension(V,U),this.manifestCache.invalidate(),V}async updateExtensionScope(V,Z){return this.logService.trace("ExtensionManagementService#updateExtensionScope",V.identifier.id),V=await this.extensionsScanner.saveMetadataForLocalExtension(V,{...V.manifest.__metadata||{},isMachineScoped:Z}),this.manifestCache.invalidate(),V}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(V){if(V.scheme===b.Schemas.file)return V;const Z=(0,l.joinPath)(this.environmentService.tmpDir,(0,d.generateUuid)());return await this.downloadService.download(V,Z),Z}createInstallExtensionTask(V,Z,U){return L.URI.isUri(Z)?new ie(V,Z,U,this.galleryService,this.extensionsScanner,this.logService):new te(Z,U,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(V,Z){return new ue(V,Z,this.extensionsScanner)}async collectFiles(V){const Z=async k=>{let x=await y.Promises.readdir(k);x=x.map(K=>I.join(k,K));const H=await Promise.all(x.map(K=>y.Promises.stat(K)));let ne=Promise.resolve([]);return H.forEach((K,Q)=>{const A=x[Q];K.isFile()&&(ne=ne.then(F=>[...F,A])),K.isDirectory()&&(ne=ne.then(F=>Z(A).then(z=>[...F,...z])))}),ne};return(await Z(V.location.fsPath)).map(k=>({path:`extension/${I.relative(V.location.fsPath,k)}`,localPath:k}))}};X=ge([oe(0,v.IExtensionGalleryService),oe(1,M.ITelemetryService),oe(2,S.ILogService),oe(3,f.INativeEnvironmentService),oe(4,u.IDownloadService),oe(5,h.IInstantiationService),oe(6,c.IFileService),oe(7,O.IProductService),oe(8,_.IUriIdentityService)],X),t.ExtensionManagementService=X;class ee extends E.AbstractExtensionTask{constructor(V,Z,U,k){super();this.identifier=V,this.source=Z,this.extensionsScanner=U,this.logService=k,this._operation=2}get operation(){return this._operation}async installExtension(V,Z){try{const U=await this.unsetUninstalledAndGetLocal(V.identifierWithVersion);if(U)return V.metadata?this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},...V.metadata}):U}catch{throw T.isMacintosh?new v.ExtensionManagementError(g.localize(1,null),v.ExtensionManagementErrorCode.Internal):new v.ExtensionManagementError(g.localize(2,null),v.ExtensionManagementErrorCode.Internal)}return this.extract(V,Z)}async unsetUninstalledAndGetLocal(V){if(!await this.isUninstalled(V))return null;this.logService.trace("Removing the extension from uninstalled list:",V.id);const U=await this.extensionsScanner.setInstalled(V);return this.logService.info("Removed the extension from uninstalled list:",V.id),U}async isUninstalled(V){return!!(await this.extensionsScanner.getUninstalledExtensions())[V.key()]}async extract({zipPath:V,identifierWithVersion:Z,metadata:U},k){let x=await this.extensionsScanner.extractUserExtension(Z,V,U,k);return this.logService.info("Extracting completed.",Z.id),x}}class te extends ee{constructor(V,Z,U,k,x){super(V.identifier,V,k,x);this.gallery=V,this.options=Z,this.extensionsDownloader=U}async doRun(V){const U=(await this.extensionsScanner.scanExtensions(null)).find(x=>(0,m.areSameExtensions)(x.identifier,this.gallery.identifier));U&&(this._operation=3);const k=await this.downloadInstallableExtension(this.gallery,this._operation);k.metadata.isMachineScoped=this.options.isMachineScoped||U?.isMachineScoped,k.metadata.isBuiltin=this.options.isBuiltin||U?.isBuiltin,k.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,k.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,C.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:U?.preRelease);try{const x=await this.installExtension(k,V);return U&&p.neq(U.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(U),x}catch(x){throw await this.deleteDownloadedVSIX(k.zipPath),x}}async deleteDownloadedVSIX(V){try{await this.extensionsDownloader.delete(L.URI.file(V))}catch(Z){this.logService.warn("Error while deleting the downloaded vsix",V.toString(),(0,R.getErrorMessage)(Z))}}async downloadInstallableExtension(V,Z){const U={id:V.identifier.uuid,publisherId:V.publisherId,publisherDisplayName:V.publisherDisplayName};let k;try{this.logService.trace("Started downloading extension:",V.identifier.id),k=(await this.extensionsDownloader.downloadExtension(V,Z)).fsPath,this.logService.info("Downloaded extension:",V.identifier.id,k)}catch(x){throw new v.ExtensionManagementError((0,E.joinErrors)(x).message,v.ExtensionManagementErrorCode.Download)}try{const x=await(0,r.getManifest)(k);return{zipPath:k,identifierWithVersion:new m.ExtensionIdentifierWithVersion(V.identifier,x.version),metadata:U}}catch(x){throw await this.deleteDownloadedVSIX(k),new v.ExtensionManagementError((0,E.joinErrors)(x).message,v.ExtensionManagementErrorCode.Invalid)}}}class ie extends ee{constructor(V,Z,U,k,x,H){super({id:(0,m.getGalleryExtensionId)(V.publisher,V.name)},Z,x,H);this.manifest=V,this.location=Z,this.options=U,this.galleryService=k}async doRun(V){const Z=new m.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),k=(await this.extensionsScanner.scanExtensions(1)).find(H=>(0,m.areSameExtensions)(this.identifier,H.identifier)),x=await this.getMetadata(this.identifier.id,this.manifest.version,V);if(x.isMachineScoped=this.options.isMachineScoped||k?.isMachineScoped,x.isBuiltin=this.options.isBuiltin||k?.isBuiltin,k)if(this._operation=3,Z.equals(new m.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version)))try{await this.extensionsScanner.removeExtension(k,"existing")}catch{throw new Error(g.localize(3,null,this.manifest.displayName||this.manifest.name))}else p.gt(k.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(k);else{const H=await this.unsetUninstalledAndGetLocal(Z);if(H)try{await this.extensionsScanner.removeExtension(H,"existing")}catch{throw new Error(g.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:I.resolve(this.location.fsPath),identifierWithVersion:Z,metadata:x},V)}async getMetadata(V,Z,U){try{let[k]=await this.galleryService.getExtensions([{id:V,version:Z}],U);if(k||([k]=await this.galleryService.getExtensions([{id:V}],U)),k)return{id:k.identifier.uuid,publisherDisplayName:k.publisherDisplayName,publisherId:k.publisherId,isPreReleaseVersion:k.properties.isPreReleaseVersion,preRelease:k.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class ue extends E.AbstractExtensionTask{constructor(V,Z,U){super();this.extension=V,this.options=Z,this.extensionsScanner=U}async doRun(V){const Z=[],U=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const k=new m.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);Z.push(...U.filter(x=>k.equals(new m.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version))))}else Z.push(...U.filter(k=>(0,m.areSameExtensions)(k.identifier,this.extension.identifier)));if(!Z.length)throw new Error(g.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...Z),this.options.remove)for(const k of Z)try{V.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(k)}catch(x){throw new Error(g.localize(6,null,(0,D.toErrorMessage)(x)))}}}}),define(J[131],Y([0,1,115,3,17,8,2,6,25,20,125,14,114,141]),function(j,t,D,R,b,I,T,P,l,p,C,L,d,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let w=class extends T.Disposable{constructor(u,f,E){super();this.environmentService=f,this.logService=E,this.configure(u.getValue()),this._register(u.onDidChangeConfiguration(()=>this.configure(u.getValue()),this))}configure(u){this.proxyUrl=u.http&&u.http.proxy,this.strictSSL=!!(u.http&&u.http.proxyStrictSSL),this.authorization=u.http&&u.http.proxyAuthorization}async request(u,f){this.logService.trace("RequestService#request",u.url);const{proxyUrl:E,strictSSL:v}=this;let m;try{m=await(0,C.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",r))}const s={...process.env,...m},i=u.agent?u.agent:await(0,d.getProxyAgent)(u.url||"",s,{proxyUrl:E,strictSSL:v});return u.agent=i,u.strictSSL=v,this.authorization&&(u.headers={...u.headers||{},"Proxy-Authorization":this.authorization}),this._request(u,f)}async getNodeRequest(u){return((0,D.parse)(u.url).protocol==="https:"?await new Promise((v,m)=>{j(["https"],v,m)}):await new Promise((v,m)=>{j(["http"],v,m)})).request}_request(u,f){return R.Promises.withAsyncBody(async(E,v)=>{let m;const s=(0,D.parse)(u.url),i=u.getRawRequest?u.getRawRequest(u):await this.getNodeRequest(u),r={hostname:s.hostname,port:s.port?parseInt(s.port):s.protocol==="https:"?443:80,protocol:s.protocol,path:s.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,P.isBoolean)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(r.auth=u.user+":"+u.password),m=i(r,e=>{const n=(0,P.isNumber)(u.followRedirects)?u.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&n>0&&e.headers.location)this._request({...u,url:e.headers.location,followRedirects:n-1},f).then(E,v);else{let o=e;e.headers["content-encoding"]==="gzip"&&(o=e.pipe((0,y.createGunzip)())),E({res:e,stream:(0,b.streamToBufferReadableStream)(o)})}}),m.on("error",v),u.timeout&&m.setTimeout(u.timeout),u.data&&typeof u.data=="string"&&m.write(u.data),m.end(),f.onCancellationRequested(()=>{m.abort(),v((0,I.canceled)())})})}async resolveProxy(u){}};w=ge([oe(0,l.IConfigurationService),oe(1,p.INativeEnvironmentService),oe(2,L.ILogService)],w),t.RequestService=w}),define(J[142],Y([0,1,33,3,17,28,8,2,11,10,29,9,15,25,107,49,113,20,89,120,23,109,130,16,100,102,40,97,52,53,112,14,104,122,32,42,131,117,31,121,36,123,124,37,127]),function(j,t,D,R,b,I,T,P,l,p,C,L,d,y,w,g,u,f,E,v,m,s,i,r,e,n,o,a,c,h,S,O,M,_,X,ee,te,ie,ue,he,V,Z,U,k,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class H extends P.Disposable{constructor(Q){super();this.argv=Q,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[Q,A]=await this.initServices();return Q.invokeFunction(async F=>{const z=F.get(O.ILogService),W=F.get(r.IFileService),G=F.get(f.INativeEnvironmentService),q=F.get(m.IExtensionManagementCLIService);z.info("CLI main",this.argv),this.registerErrorHandler(z),await this.doRun(G,q,W),await Promise.all(A.map(re=>{(0,R.raceTimeout)(re.flush(),1e3)}))})}async initServices(){const Q=new c.ServiceCollection,A={_serviceBrand:void 0,..._.default};Q.set(X.IProductService,A);const F=new E.NativeEnvironmentService(this.argv,A);Q.set(f.INativeEnvironmentService,F),await Promise.all([F.appSettingsHome.fsPath,F.extensionsPath].map(fe=>fe?d.Promises.mkdir(fe,{recursive:!0}):void 0));const z=(0,O.getLogLevel)(F),W=[];W.push(new M.SpdLogLogger("cli",(0,p.join)(F.logsPath,"cli.log"),!0,!1,z)),z===O.LogLevel.Trace&&W.push(new O.ConsoleLogger(z));const G=this._register(new O.MultiplexLogService(W));Q.set(O.ILogService,G);const q=this._register(new e.FileService(G));Q.set(r.IFileService,q);const re=this._register(new n.DiskFileSystemProvider(G));q.registerProvider(l.Schemas.file,re);const ae=this._register(new w.ConfigurationService(F.settingsResource,q));Q.set(y.IConfigurationService,ae),await ae.initialize(),Q.set(k.IUriIdentityService,new x.UriIdentityService(q)),Q.set(ee.IRequestService,new o.SyncDescriptor(te.RequestService)),Q.set(g.IDownloadService,new o.SyncDescriptor(u.DownloadService)),Q.set(m.IExtensionManagementService,new o.SyncDescriptor(i.ExtensionManagementService)),Q.set(m.IExtensionGalleryService,new o.SyncDescriptor(v.ExtensionGalleryServiceWithNoStorageService)),Q.set(m.IExtensionManagementCLIService,new o.SyncDescriptor(s.ExtensionManagementCLIService)),Q.set(h.ILocalizationsService,new o.SyncDescriptor(S.LocalizationsService));const pe=[];if((0,V.supportsTelemetry)(A,F)){A.aiConfig&&A.aiConfig.asimovKey&&pe.push(new Z.AppInsightsAppender("monacoworkbench",null,A.aiConfig.asimovKey));const{installSourcePath:fe}=F,se={appenders:pe,sendErrorTelemetry:!1,commonProperties:(async()=>{let ce;try{const ye=await d.Promises.readFile((0,p.join)(F.userDataPath,"storage.json"));ce=JSON.parse(ye.toString())[ue.machineIdKey]}catch(ye){ye.code!=="ENOENT"&&G.error(ye)}return(0,ie.resolveCommonProperties)(q,(0,D.release)(),(0,D.hostname)(),process.arch,A.commit,A.version,ce,A.msftInternalDomains,fe)})(),piiPaths:(0,V.getPiiPathsFromEnvironment)(F)};Q.set(ue.ITelemetryService,new o.SyncDescriptor(he.TelemetryService,[se]))}else Q.set(ue.ITelemetryService,V.NullTelemetryService);return[new a.InstantiationService(Q),pe]}registerErrorHandler(Q){(0,T.setUnexpectedErrorHandler)(A=>{const F=(0,I.toErrorMessage)(A,!0);!F||Q.error(`[uncaught exception in CLI]: ${F}`)}),process.on("uncaughtException",A=>(0,T.onUnexpectedError)(A)),process.on("unhandledRejection",A=>(0,T.onUnexpectedError)(A))}async doRun(Q,A,F){if(this.argv["install-source"])return this.setInstallSource(Q,F,this.argv["install-source"]);if(this.argv["list-extensions"])return A.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const z={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return A.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],z,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return A.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return A.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,U.buildTelemetryMessage)(Q.appRoot,Q.extensionsPath))}}asExtensionIdOrVSIX(Q){return Q.map(A=>/\.vsix$/i.test(A)?L.URI.file((0,p.isAbsolute)(A)?A:(0,p.join)((0,C.cwd)(),A)):A)}async setInstallSource(Q,A,F){await A.writeFile(L.URI.file(Q.installSourcePath),b.VSBuffer.fromString(F.slice(0,30)))}}async function ne(K){const Q=new H(K);try{await Q.run()}finally{Q.dispose()}}t.main=ne})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d6ecda7ef2c306253594b196b18ab74caa6016cd/core/vs/code/node/cliProcessMain.js.map
